{
        Program Name : CEF32
        Package Name : CEF
        Purpose      : CEF32 main form
        Institution  :
        Date Written : 27-Apr-2000
        Written By   : Alan Conroy
        Version      : 1.2

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        Released to the public domain.

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *  23-Mar-2006   EAC         Open all input files in read   *
        *                            mode.                          *
        *                            Implement Dump.                *
        *                            Can now load/dump *.ent files. *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit defines the main form for the generic CEF user interface.
}

unit CEFMain ;

interface

uses // Borland...
     Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     ExtCtrls, Menus, ComCtrls, StdCtrls,

     // C&C...
     ArrayDis, // TArray_Display
     ArrayInt, // TArray_Interface
     CommonUt, // TInteger_List
     EditWin, // tEditor_Window
     _Streams, // TCOM_Stream
     SStreams, // TCOM_String_Stream
     Standard, // TInteger64_List
     _UEHDefs, // TUEC

     // CEF...
     CEF, // TMemory
     CEF_Assembler, // TCEF_Assembler
     Conditions_Dlg ; // Conditions_Form

type TMemory_Array_Interface = class( TCOM_Array_Interface )
                                   public // API...
                                       function Get_Byte( Index : int64 ) : byte ;
                                           override ;
                                       procedure Set_Byte( Index : int64 ;
                                           Value : byte ) ; override ;

                                       function Read_Only : boolean ; override ;

                                       function Low_Bound( Subscript : integer ) : int64 ;
                                           override ;
                                       function High_Bound( Subscript : integer ) : int64 ;
                                           override ;
                                       function Subscripts : integer ;
                                           override ;
                               end ;

type TLine_Streamer = class( TCOM_String_Stream )
                          public
                              Current_Line : integer ;
                      end ;

type TCEF_Assembler_Status = class( TAssembler_Status )
                                 public // Constructors and destructors...
                                     constructor Create ;
                                     destructor Destroy ; override ;

                                 private
                                     _Aborted : boolean ;
                                     _Code : int64 ;
                                     _Data : int64 ;
                                     _Warnings : longint ;
                                     _Errors : longint ;
                                     _Error_Text : string ;
                                     Last_File : string ;
                                     Line : integer ;

                                 public // API...
                                     Error_List : TStringList ;
                                     Current_File : string ;
                                     In_Streamer : TLine_Streamer ;

                                     function Filename : PChar ; override ;
                                     function Get_Code : int64 ; override ;
                                     function Get_Data : int64 ; override ;
                                     function Get_Errors : integer ; override ;
                                     function Get_Warnings : integer ;
                                         override ;
                                     function Get_Error_Text : PChar ;
                                         override ;
                                     procedure Set_Code( Value : int64 ) ;
                                         override ;
                                     procedure Set_Data( Value : int64 ) ;
                                         override ;
                                     procedure Set_Errors( Value : integer ) ;
                                         override ;
                                     procedure Set_Warnings( Value : integer ) ;
                                         override ;
                                     procedure Set_Error_Text( Value : PChar ) ;
                                         override ;
                                     procedure Log_Error( Text, Filename : PChar ;
                                         Line, Severity : longint ) ; override ;
                                     procedure Get_Error( Index : longint ;
                                         var Text, Filename : PChar ;
                                         var Line, Severity : longint ) ;
                                         override ;
                                     procedure Set_Aborted( Value : boolean ) ;
                                         override ;
                                     function Get_Aborted : boolean ; override ;
                                     procedure Set_Line( Value : integer ) ;
                                         override ;
                             end ; // TCEF_Assembler_Status

// TPaint_Panel...

type TPaint_Panel = class( TPanel )
                        public
                            procedure wmPaint( var Message ) ;
                                message WM_Paint ;
                    end ;


     TCEF32_Interface = class( TUI_Interface )
                            public // Constructors and destructors...
                                constructor Create ;
                                destructor Destroy ; override ;

                            private // Instance data...
                                Signal_Components : TList ;

                            public // API...
                                procedure Idle( Component : TComponent ) ;
                                    override ;
                                function Breakpoint_Notice( Address : int64 ;
                                    Physical : boolean ; Space : integer ;
                                    CPU : TComponent ) : boolean ; override ;
                                procedure Log_Error( Component : TComponent ;
                                    Text : PChar ; Severity : longint ) ;
                                    override ;
                                procedure Log_Simulated_Error( Component : TComponent ;
                                    Text : PChar ; Severity : longint ) ;
                                    override ;
                                procedure State_Change_Notice( Component : TComponent ;
                                    Index : longint ; Active : boolean ) ;
                                    override ;
                                procedure Signal_Change_Notice( Component : TComponent ;
                                    Index : longint ; Active : boolean ) ;
                                    override ;
                                procedure Signal_Exception( Component : TComponent ;
                                    Description : PChar ; Index : longint ) ;
                                    override ;
                                procedure Watchpoint_Notice( Address : int64 ;
                                    Access, Tag : longint ; Component : TComponent ;
                                    Memory, Internal, Port : boolean ) ;
                                    override ;
                                procedure Log_Trace( Component : TComponent ;
                                    Description : PChar ) ; override ;
                                function Get_File_Stream( Name : PChar ) : TCOM_Stream ;
                                    override ;
                                procedure Toggle_Embed( Component : TComponent ) ;
                                    override ;
                                procedure Want_Signals( Component : TComponent ;
                                    Value : boolean ) ; override ;
                                procedure Terminate ; override ;
                                procedure Hide( Flag : boolean ) ; override ;
                        end ; // TCEF32_Interface

type TCEF_TabSheet = class( TTabSheet )
                         public // API...
                             Editor : tEditor_Window ; // nil if not an editor
                             Disassembly : boolean ; // True if a disassembly sheet
                             UI : TComponent ;

                             procedure SetBounds( ALeft, ATop, AWidth, AHeight : Integer ) ;
                                 override ;
                     end ;

type TComponent_Parent = class( TComponent )
                             public // API...
                                 procedure Child_Notification( Child : TComponent ;
                                     var Notice : longint ; var Params : int64 ) ;
                                     override ;
                         end ;

type TMain_Form = class( TForm )
    Top_panel : TPanel ;
    Bottom_Panel : TPanel ;
    Main_Splitter : TSplitter ;
    MainMenu1: TMainMenu ;
    File1 : TMenuItem ;
    Help1 : TMenuItem ;
    Help2 : TMenuItem ;
    About1 : TMenuItem ;
    Exit1 : TMenuItem ;
    Open1 : TMenuItem ;
    Open_Dialog : TOpenDialog ;
    Watch_Panel : TPanel ;
    Splitter1 : TSplitter ;
    StatusBar: TStatusBar;
    Internals1: TMenuItem;
    Popup_Menu: TPopupMenu;
    Radix1: TMenuItem;
    Signed1: TMenuItem;
    Size1: TMenuItem;
    EBCDIC1: TMenuItem;
    Binary1: TMenuItem;
    Octal1: TMenuItem;
    Decimal1: TMenuItem;
    Hexadecimal1: TMenuItem;
    Other1: TMenuItem;
    Byte1: TMenuItem;
    Word1: TMenuItem;
    Long1: TMenuItem;
    Double1: TMenuItem;
    N1: TMenuItem;
    Gotoaddress1: TMenuItem;
    Find1: TMenuItem;
    Radix50: TMenuItem;
    Physical1: TMenuItem;
    Save_Memory_Dialog: TSaveDialog;
    Save_Memory_State_Dialog: TSaveDialog;
    N2: TMenuItem;
    Save1: TMenuItem;
    Restore1: TMenuItem;
    N3: TMenuItem;
    Save2: TMenuItem;
    Restore2: TMenuItem;
    PageControl1: TPageControl;
    CPU_Panel: TPanel;
    Splitter2: TSplitter;
    N4: TMenuItem;
    Save3: TMenuItem;
    SaveAs1: TMenuItem;
    SaveAll1: TMenuItem;
    New1: TMenuItem;
    N5: TMenuItem;
    OpenEmulator1: TMenuItem;
    Save_Dialog: TSaveDialog;
    Restore_Memory_Dialog: TOpenDialog;
    Restore_memory_State_Dialog: TOpenDialog;
    Components1: TMenuItem;
    DefaultMemory1: TMenuItem;
    Assemble1: TMenuItem;
    Assemble2: TMenuItem;
    AssembleAll1: TMenuItem;
    N7: TMenuItem;
    Printersetup1: TMenuItem;
    Print1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    N8: TMenuItem;
    Close1: TMenuItem;
    CloseAll1: TMenuItem;
    N11: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    N41: TMenuItem;
    N51: TMenuItem;
    N61: TMenuItem;
    N71: TMenuItem;
    N81: TMenuItem;
    N91: TMenuItem;
    N10: TMenuItem;
    Load1: TMenuItem;
    N20: TMenuItem;
    N12: TMenuItem;
    N22: TMenuItem;
    N32: TMenuItem;
    N42: TMenuItem;
    N52: TMenuItem;
    N62: TMenuItem;
    N72: TMenuItem;
    N82: TMenuItem;
    N92: TMenuItem;
    Open_Component_Dialog: TOpenDialog;
    CPU_Status: TListBox;
    CPU_Caption: TPanel;
    Modify1: TMenuItem;
    CPU_PopupMenu: TPopupMenu;
    Watchpoints1: TMenuItem;
    Createnew1: TMenuItem;
    View1: TMenuItem;
    Run1: TMenuItem;
    Execute1: TMenuItem;
    StepOver1: TMenuItem;
    StepInto1: TMenuItem;
    Runimmediate1: TMenuItem;
    UnloadAll1: TMenuItem;
    Reopenemulator1: TMenuItem;
    Reopensource1: TMenuItem;
    N13: TMenuItem;
    N23: TMenuItem;
    N33: TMenuItem;
    N43: TMenuItem;
    N53: TMenuItem;
    N63: TMenuItem;
    N73: TMenuItem;
    N83: TMenuItem;
    N93: TMenuItem;
    Panel1: TPanel;
    Immediate_Mode_Panel: TPanel;
    Memory_Panel: TPanel;
    Memory_ScrollBar: TScrollBar;
    Label1: TLabel;
    Immediate_Mode_Edit: TEdit;
    Pause1: TMenuItem;
    Increment1: TMenuItem;
    Decrement1: TMenuItem;
    Change1: TMenuItem;
    Zero1: TMenuItem;
    AddWatch1: TMenuItem;
    AddBreakpoint1: TMenuItem;
    AddRegisterBreakpoint1: TMenuItem;
    N6: TMenuItem;
    RegisterBreakpoints1: TMenuItem;
    Watch_List_Box: TListBox;
    Watches_Popup_Menu: TPopupMenu;
    Add1: TMenuItem;
    Delete1: TMenuItem;
    DeleteAll1: TMenuItem;
    N9: TMenuItem;
    Edit1: TMenuItem;
    AddPortBreakpoint1: TMenuItem;
    N14: TMenuItem;
    PortBreakpoints1: TMenuItem;
    ExecutionBreakpoints1: TMenuItem;
    N15: TMenuItem;
    Profiling1: TMenuItem;
    ProfileReport1: TMenuItem;
    N16: TMenuItem;
    Trace1: TMenuItem;
    TraceLog1: TMenuItem;
    AddressSpace1: TMenuItem;
    Disassembly_Popup: TPopupMenu;
    Showsource1: TMenuItem;
    Stack_List_Box: TListBox;
    Splitter3: TSplitter;
    Gotoaddress2: TMenuItem;
    GotoCurrent1: TMenuItem;
    Stack_Popup: TPopupMenu;
    TopofStack1: TMenuItem;
    Gotoaddress3: TMenuItem;
    procedure About1Click( Sender : TObject ) ;
    procedure Help2Click( Sender : TObject ) ;
    procedure Exit1Click( Sender : TObject ) ;
    procedure Open1Click( Sender : TObject ) ;
    procedure Memory_BoxPaint( Sender: TObject ) ;
    procedure FormShow( Sender : TObject ) ;
    procedure FormDestroy( Sender : TObject ) ;
    procedure FormCreate( Sender : TObject ) ;
    procedure Internals1Click(Sender: TObject);
    procedure Memory_ScrollBarChange(Sender: TObject);
    procedure EBCDIC1Click(Sender: TObject);
    procedure Signed1Click(Sender: TObject);
    procedure Binary1Click(Sender: TObject);
    procedure Octal1Click(Sender: TObject);
    procedure Decimal1Click(Sender: TObject);
    procedure Hexadecimal1Click(Sender: TObject);
    procedure Other1Click(Sender: TObject);
    procedure Byte1Click(Sender: TObject);
    procedure Word1Click(Sender: TObject);
    procedure Long1Click(Sender: TObject);
    procedure Double1Click(Sender: TObject);
    procedure Gotoaddress1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure Radix50Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Restore1Click(Sender: TObject);
    procedure Save2Click(Sender: TObject);
    procedure Restore2Click(Sender: TObject);
    procedure Physical1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Save3Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure SaveAll1Click(Sender: TObject);
    procedure OpenEmulator1Click(Sender: TObject);
    procedure Assemble2Click(Sender: TObject);
    procedure AssembleAll1Click(Sender: TObject);
    procedure Printersetup1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure CloseAll1Click(Sender: TObject);
    procedure Reopen_File(Sender: TObject);
    procedure Reopen_Emulator(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CPU_StatusDblClick(Sender: TObject);
    procedure Modify1Click(Sender: TObject);
    procedure Createnew1Click(Sender: TObject);
    procedure View1Click(Sender: TObject);
    procedure Execute1Click(Sender: TObject);
    procedure StepOver1Click(Sender: TObject);
    procedure StepInto1Click(Sender: TObject);
    procedure Runimmediate1Click(Sender: TObject);
    procedure UnloadAll1Click(Sender: TObject);
    procedure Immediate_Mode_PanelResize(Sender: TObject);
    procedure Immediate_Mode_EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Pause1Click(Sender: TObject);
    procedure Increment1Click(Sender: TObject);
    procedure Decrement1Click(Sender: TObject);
    procedure Change1Click(Sender: TObject);
    procedure CPU_StatusMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Zero1Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure AddWatch1Click(Sender: TObject);
    procedure AddBreakpoint1Click(Sender: TObject);
    procedure AddRegisterBreakpoint1Click(Sender: TObject);
    procedure RegisterBreakpoints1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure DeleteAll1Click(Sender: TObject);
    procedure Watch_List_BoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Watch_List_BoxDblClick(Sender: TObject);
    procedure Watch_List_BoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ExecutionBreakpoints1Click(Sender: TObject);
    procedure AddPortBreakpoint1Click(Sender: TObject);
    procedure PortBreakpoints1Click(Sender: TObject);
    procedure Clear_Watches ;
    procedure Profiling1Click(Sender: TObject);
    procedure ProfileReport1Click(Sender: TObject);
    procedure TraceLog1Click(Sender: TObject);
    procedure Trace1Click(Sender: TObject);
    procedure Showsource1Click(Sender: TObject);
    procedure GotoCurrent1Click(Sender: TObject);
    procedure Gotoaddress2Click(Sender: TObject);
    procedure TopofStack1Click(Sender: TObject);
    procedure Gotoaddress3Click(Sender: TObject);

  private // Instance data...
      AD : TArray_Display ;
      AI : TMemory_Array_Interface ;
      Component_List : TStringList ;
      Current_Address_Space : integer ;
      Disassembly_Sheet : TCEF_TabSheet ;
      Disassembly_List_Box : TListBox ;
      Disassembly_Top, Disassembly_Next, Disassembly_Second : int64 ;
      _Hide : boolean ; // True to hide form on startup
      In_Assembly : boolean ;
      In_Execution : boolean ;
      Master_Assembler : TCEF_Assembler ;
      Master_CPU : TComponent ;
      Memory_DLL : integer ; // DLL handle for default main memory
      Parent_Component : TComponent_Parent ;
      Reopen_Menus : array[ 1..9 ] of TMenuItem ;
      EReopen_Menus : array[ 1..9 ] of TMenuItem ;
      Physical_Address : boolean ;
      Register_Watchpoints : TInteger64_List ;
      Register_Watchpoint_Access : TInteger_List ;
      Execution_Watchpoints : TInteger64_List ;
      Port_Watchpoints : TInteger64_List ;
      Port_Watchpoints_Access : TInteger_List ;
      Start_Execution : boolean ;
      Status : TCEF_Assembler_Status ;
      ScrollBar1 : TScrollbar ;
      Stack_Top : int64 ;
      Startup_Command_File : boolean ;
      Terminate_Requested : boolean ;
      Terminate_Base_Time : cardinal ;
      Terminate_Wait : boolean ;
      TabSheet1 : TCEF_TabSheet ;
      Traces : TStringList ; // Trace queue
      Trace_Position : integer ; // Current insertion position for trace queue
      UI : TCEF32_Interface ;
      Watches : TList ;
      Watchpoints : TInteger64_List ;
      Watchpoint_Size : TInteger_List ;
      Watchpoint_Access : TInteger_List ;
      Write_Errors : boolean ;

  private // Internal utility routines...
      procedure Add_To_Reopen( const S : string ) ;
      function Assemble( Editor : TEditor_Window ;
          Status : TAssembler_Status ) : boolean ;
      function Configure_Component_Menus( C : TComponent ; M : TMenuItem ) : TMenuItem ;
      procedure Open_Emulator( Filename : string ) ;
      procedure Open_File( Name : string ) ;
      procedure ConfigureClick( Sender : TObject ) ;
      procedure ConnectionsClick( Sender : TObject ) ;
      procedure ConditionsClick( Sender : TObject ) ;
      procedure Disassembly_List_BoxKeyDown(Sender: TObject; var Key: Word;
        Shift: TShiftState);
      procedure Disassembly_List_BoxMouseUp(Sender: TObject;
        Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
      procedure Disassembly_List_Resize( Sender : TObject ) ;
      function Get_File_Stream( Name : string ) : TCOM_Stream ;
      procedure ProfileClick( Sender : TObject ) ;
      procedure ProfileReportClick( Sender : TObject ) ;
      procedure Remove_Component( Index : integer ; _Free : boolean ) ;
      procedure Update_CPU_State ;
      procedure Update_Watches ;
      procedure UnloadClick( Sender : TObject ) ;
      function Load_Component( Filename, Setup, Name : string ) : boolean ;
      procedure Log_Trace( Component : TComponent ; Description : string ) ;
      procedure Update_Disassembly ;
      procedure Update_Stack ;
      procedure Map_Source( Force : boolean ) ;
      procedure Report_Profile( Component : TComponent ) ;
      procedure Reset1Click( Sender : TObject ) ;
      procedure Restart1Click( Sender : TObject ) ;
      procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
        var ScrollPos: Integer);
      procedure ToggleEmbedClick( Sender : TObject ) ;
      procedure Set_Master_CPU( CPU : TComponent ) ;
      function _Examine_Memory( Address : int64 ;
          Physical_Address : boolean ; Address_Space : integer ) : byte ;
      procedure Dump1Click( Sender : TObject ) ;
      procedure LoadMem1Click( Sender : TObject ) ;

  private // Callbacks...
      procedure CB_Address_Space_Click( Sender : TObject ) ;
      procedure CB_Update_Menu( Sender : TObject ) ;
      procedure CB_Kill( Sender : TObject )  ;
      procedure CB_State_Change( Sender : TObject ) ;
      procedure CB_Idle( Sender : TObject ; var Done : boolean ) ;

  public // API...
      Low_Address, High_Address : int64 ;
      Low_Physical_Address, High_Physical_Address : int64 ;
      Main_Memory : TComponent ;
      Paint_Panel : TPaint_Panel ;

      procedure Write_Memory( Address : int64 ; Value : byte ) ;
      function Deposit_Memory( Address : int64 ; Value : byte ) : TUEC ;
      function Examine_Memory( Address : int64 ) : byte ;
      procedure Show_Error( Sender : TListBox ) ;
      function Menu_For_Component( Component : TComponent ) : TMenuItem ;
  end ; // TMain_Form

var Main_Form : TMain_Form ;

implementation

uses // CEF32...
     About,
     CEFUtil,
     Radix_Dialog,
     Goto_Address,
     Find_Dialog, // ERT
     ModReg,
     ModMem,
     ModConfig,
     Create_Watchpoint,
     mem_watchpoints_dialog,
     Assembly_Status,
     Error_List,
     New_Watch, // New_Watch_Dialog
     Trace_Dlg, // Trace_Form
     Trace_Log_Dlg, // Trace_Log_Form
     CCM,
     Profile_Report,
     DumpMem,
     LoadMem,

     // Other...
     ASCIIDef, // CR
     CVT, // CVTB
     Debug_Dialog, // Begin_Debugger
     EBCDICs,
     ErrMastr, // Get_Error_Text
     FStreams, // Create_File_Stream
     GenNum_Dialog, // TGenNum_Form
     Num1s, // Num1
     Parse, // TString_Parser
     Radix50s, // Rad
     SaveEdit, // Save_Modified_Dialog
     UStrings, // Trim_Quotes
     VCL_Std ; // Delete_All_Children

{$R *.DFM}

type TWatch = class
                 public
                     Address : int64 ;
                     Size : longint ;
                     Base : integer ; // (0 = ASCII, 1 = EBCDIC, 50 = Radix50)
              end ;

type TError_Information = class
                              public
                                  Line : longint ;
                                  Severity : longint ;
                                  Filename : string ;
                          end ;

type TEditor_Streamer = class( TLine_Streamer )
                            private // Instance data...
                                _Editor : TEditor_Window ;
                                Line_Buffer : string ;

                            public // Constructors and destructors...
                                constructor Create( Editor : TEditor_Window ) ;

                            public // API...
                                function At_End : boolean ; override ; stdcall ;

                                function Facility_ID : longint ;
                                    override ; stdcall ;

                                procedure Last_Error( var UEC : TUEC ) ;
                                    override ;

                                procedure Read( var Buffer ; var Size : longint ) ;
                                    override ; stdcall ;

                                procedure Read_Line( var Buffer ; var Size : longint ) ;
                                    override ; stdcall ;

                                procedure Seek( Position : longint ) ;
                                    override ; stdcall ;

                                function Size : longint ; override ;

                                procedure Write( var Buffer ; size : longint ) ;
                                    override ; stdcall ;

                                procedure Write_Line( Buffer : PChar ) ;
                                    override ; stdcall ;
                        end ;



// TComponent_Parent methods...

// API...

procedure TComponent_Parent.Child_Notification( Child : TComponent ;
    var Notice : longint ; var Params : int64 ) ;

var Index : integer ;

begin
    if( Notice = Child_Notice_Terminating ) then
    begin
        Index := Main_Form.Component_List.IndexOfObject( Child ) ;
        if( Index <> -1 ) then
        begin
            Main_Form.Remove_Component( Index, False ) ;
        end ;
    end ;
end ;



// TCEF_TabSheet methods...

procedure TCEF_TabSheet.SetBounds( ALeft, ATop, AWidth, AHeight : Integer ) ;

begin
    inherited SetBounds( ALeft, ATop, AWidth, AHeight ) ;

    if( UI <> nil ) then
    begin
        UI.User_Interface.Set_Size( AHeight, AWidth ) ;
    end ;
end ;



// TCEF_Assembler_Status methods...

// Constructors and destructors...

constructor TCEF_Assembler_Status.Create ;

begin
    inherited Create ;

    Error_List := TStringList.Create ;
end ;


destructor TCEF_Assembler_Status.Destroy ;

var Loop : integer ;

begin
    for Loop := 0 to Error_List.Count - 1 do
    begin
        Error_List.Objects[ Loop ].Free ;
        Error_List.Objects[ Loop ] := nil ;
    end ;
    Error_List.Free ;

    inherited Destroy ;
end ;


// API...

function TCEF_Assembler_Status.Filename : PChar ;

begin
    Result := PChar( Current_File ) ;
end ;


function TCEF_Assembler_Status.Get_Code : int64 ;

begin
    Result := _Code ;
end ;


function TCEF_Assembler_Status.Get_Data : int64 ;

begin
    Result := _Data ;
end ;


function TCEF_Assembler_Status.Get_Errors : integer ;

begin
    Result := _Errors ;
end ;


function TCEF_Assembler_Status.Get_Warnings : integer ;

begin
    Result := _Warnings ;
end ;


function TCEF_Assembler_Status.Get_Error_Text : PChar ;

begin
    if( ( length( _Error_Text ) = 0 ) and ( Error_List.Count > 0  ) ) then
    begin
        Result := PChar( Error_List[ 0 ] ) ;
    end else
    begin
        Result := PChar( _Error_Text ) ;
    end ;
end ;


procedure TCEF_Assembler_Status.Set_Code( Value : int64 ) ;

begin
    _Code := Value ;
end ;


procedure TCEF_Assembler_Status.Set_Data( Value : int64 ) ;

begin
    _Data := Value ;
end ;


procedure TCEF_Assembler_Status.Set_Errors( Value : integer ) ;

begin
    _Errors := Value ;
end ;


procedure TCEF_Assembler_Status.Set_Warnings( Value : integer ) ;

begin
    _Warnings := Value ;
end ;


procedure TCEF_Assembler_Status.Set_Error_Text( Value : PChar ) ;

begin
    _Error_Text := Value ;
end ;


procedure TCEF_Assembler_Status.Log_Error( Text, Filename : PChar ;
    Line, Severity : longint ) ;

var P : TError_Information ;
    S : string ;

begin
    P := TError_Information.Create ;
    if( Line = -1 ) then
    begin
        if( In_Streamer <> nil ) then
        begin
            P.Line := In_Streamer.Current_Line ;
        end ;
    end else
    begin
        P.Line := Line ;
    end ;
    if( Filename = nil ) then
    begin
        P.Filename := Current_File ;
    end else
    begin
        P.Filename := string( Filename ) ;
    end ;
    P.Severity := Severity ;
    case Severity of
        Severity_Warning :
            begin
                inc( _Warnings ) ;
                S := '[Warning] ' ;
            end ;
        Severity_Error, Severity_Fatal :
            begin
                inc( _Errors ) ;
                S := '[Error] ' ;
            end ;
        else S := '[Hint] ' ;
    end ;
    Error_List.AddObject( S + P.Filename + '(' + inttostr( P.Line ) + ') ' + string( Text ), P ) ;
end ; // TCEF_Assembler_Status.Log_Error


procedure TCEF_Assembler_Status.Get_Error( Index : longint ;
    var Text, Filename : PChar ; var Line, Severity : longint ) ;

var Info : TError_Information ;

begin
    if( ( Index < 0 ) or ( Index >= Error_List.Count ) ) then
    begin
        Text := nil ;
        Filename := nil ;
        Line := 0 ;
        Severity := 0 ;
        exit ;
    end ;
    Info := TError_Information( Error_List.Objects[ Index ] ) ;
    Text := PChar( Error_List[ Index ] ) ;
    Filename := PChar( Info.Filename ) ;
    Line := Info.Line ;
    Severity := Info.Severity ;
end ;


procedure TCEF_Assembler_Status.Set_Aborted( Value : boolean ) ;

begin
    _Aborted := Value ;
end ;


function Bytes_Text( Value : int64 ) : string ;

begin
    Result := inttostr( Value ) + ' byte' ;
    if( Value <> 1 ) then
    begin
        Result := Result + 's' ;
    end ;
end ;


function TCEF_Assembler_Status.Get_Aborted : boolean ;

var S : string ;

begin
    // Check aborted status
    if( Assembly_Statistics = nil ) then
    begin
        Result := False ;
        exit ;
    end ;
    if( Assembly_Statistics.Aborted ) then
    begin
        _Aborted := True ;
    end ;
    Result := _Aborted ;

    // Update the dialog...
    if( _Aborted or ( ( Line and 32 ) = 0 ) or ( Last_File <> Current_File ) ) then
    begin
        Last_File := Current_File ;
        Assembly_Statistics.Data_Label.Caption := Bytes_Text( Data ) ;
        Assembly_Statistics.Code_Label.Caption := Bytes_Text( Code ) ;
        Assembly_Statistics.Warnings_Label.Caption := inttostr( Warnings ) ;
        Assembly_Statistics.Errors_Label.Caption := inttostr( Errors ) ;
        S := Current_File ;
        if( Line <> 0 ) then
        begin
            S := S + ' (' + inttostr( Line ) + ')' ;
        end ;
        Assembly_Statistics.Filename.Caption := S ;
    end ;
end ;


procedure TCEF_Assembler_Status.Set_Line( Value : integer ) ;

begin
    Line := Value ;
end ;



function Component_Name( Component : TComponent ) : string ;

begin
    if( Component = nil ) then
    begin
        Result := 'Emulator' ;
    end else
    begin
        Result := string( Component.Name ) ;
        Component := Component.Parent ;
        while( Component <> nil ) do
        begin
            Result := string( Component.Name ) + '.' + Result ;
            Component := Component.Parent ;
        end ;
    end ;
end ;


// TCEF32_Interface methods...

// Constructors and destructors...

constructor TCEF32_Interface.Create ;

begin
    inherited Create ;

    Signal_Components := TList.Create ;
end ;


destructor TCEF32_Interface.Destroy ;

begin
    Signal_Components.Free ;
    Signal_Components := nil ;

    inherited Destroy ;
end ;


// API...

procedure TCEF32_Interface.Idle( Component : TComponent ) ;

begin
    Application.ProcessMessages ;
    if( Component <> nil ) then
    begin
        Component.Wake ;
    end ;
end ;


function TCEF32_Interface.Breakpoint_Notice( Address : int64 ;
    Physical : boolean ; Space : integer ; CPU : TComponent ) : boolean ;

begin
    ShowMessage( Component_name( CPU ) + ': Breakpoint at address ' + CvtB( 10, Main_Form.AD.Base, inttostr( Address ) ) ) ;
    CPU.CPU.Stop ;
    Result := True ;
end ;


procedure TCEF32_Interface.Log_Error( Component : TComponent ; Text : PChar ;
    Severity : longint ) ;

var S : string ;

begin
    S := Component_Name( Component ) + ': ' + string( Text ) ;
    ShowMessage( S ) ;
    if( Severity = Severity_Fatal ) then
    begin
        Main_Form.Close ;
    end else
    if(
        ( Main_Form.Master_CPU <> nil )
        and
        ( TComponent_Info( Main_Form.Master_CPU.Tag ).Ignore_Errors[ Severity ] )
      ) then
    begin
        Main_Form.Master_CPU.CPU.Stop ;
    end ;
end ;


procedure TCEF32_Interface.Log_Simulated_Error( Component : TComponent ;
    Text : PChar ; Severity : longint ) ;

var S : string ;

begin
    S := Component_Name( Component ) + ': ' + string( Text ) ;
    ShowMessage( S ) ;
    if( Severity = Severity_Fatal ) then
    begin
        Main_Form.Close ;
    end else
    if(
        ( Main_Form.Master_CPU <> nil )
        and
        ( TComponent_Info( Main_Form.Master_CPU.Tag ).Ignore_Errors[ Severity ] )
      ) then
    begin
        Main_Form.Master_CPU.CPU.Stop ;
    end ;
end ;


procedure TCEF32_Interface.State_Change_Notice( Component : TComponent ;
    Index : longint ; Active : boolean ) ;

var Info : TComponent_Info ;

begin
    Info := TComponent_Info( Component.Tag ) ;
    if(
        ( Info.State_Changes.IndexOf( Index ) >= 0 )
        and
        Main_Form.In_Execution
      ) then
    begin
        ShowMessage( Component_name( Component ) + ': Break on state change, ' + Component.Get_State_Name( Index ) ) ;
        if( Main_Form.Master_CPU <> nil ) then
        begin
            Main_Form.Master_CPU.CPU.Stop ;
        end ;
    end ;
end ;


procedure TCEF32_Interface.Signal_Change_Notice( Component : TComponent ;
    Index : longint ; Active : boolean ) ;

var C : TComponent ;
    I : integer ;
    Info : TComponent_Info ;
    Loop : integer ;
    SN : string ;

begin
    // Notify all components that request signal change notices...
    SN := Component.Signal_Name( Index ) ;
    for Loop := 0 to Signal_Components.Count - 1 do
    begin
        C := TComponent( Signal_Components[ Loop ] ) ;
        C.Signal_Change_Notice( Component, Index, Active ) ;
        I := C.Signal_Index( PChar( SN ) ) ;
        if( I >= 0 ) then
        begin
            Info := TComponent_Info( C.Tag ) ;
            Info.Set_Signal( I, True, Active ) ;
        end ;
    end ;

    // Check for signal breakpoint...
    Info := TComponent_Info( Component.Tag ) ;
    if( Info <> nil ) then
    begin
        Info.Set_Signal( Index, True, Active ) ;
        if(
            ( Info.Signal_Changes.IndexOf( Index ) >= 0 )
            and
            Main_Form.In_Execution
          ) then
        begin
            ShowMessage( Component_name( Component ) + ': Break on signal change, ' + Component.Signal_Name( Index ) ) ;
            if( Main_Form.Master_CPU <> nil ) then
            begin
                Main_Form.Master_CPU.CPU.Stop ;
            end ;
        end ;
    end ;
end ; // TCEF32_Interface.Signal_Change_Notice


procedure TCEF32_Interface.Signal_Exception( Component : TComponent ;
    Description : PChar ; Index : longint ) ;

var Info : TComponent_Info ;

begin
    Info := TComponent_Info( Component.Tag ) ;
    if(
        ( Info.Exceptions.IndexOf( Index ) >= 0 )
        and
        Main_Form.In_Execution
      ) then
    begin
        ShowMessage( Component_name( Component ) + ': Exception, ' + Component.Get_Exception_Description( Index ) ) ;
        if( Main_Form.Master_CPU <> nil ) then
        begin
            Main_Form.Master_CPU.CPU.Stop ;
        end ;
    end ;
end ;


procedure TCEF32_Interface.Log_Trace( Component : TComponent ;
    Description : PChar ) ;

begin
    Main_Form.Log_Trace( Component, string( Description ) ) ;
end ;


function TCEF32_Interface.Get_File_Stream( Name : PChar ) : TCOM_Stream ;

begin
    Result := Main_Form.Get_File_Stream( string( Name ) ) ;
end ;


procedure TCEF32_Interface.Toggle_Embed( Component : TComponent ) ;

var M : TMenuItem ;

begin
    if( Component <> nil ) then
    begin
        M := Main_Form.Menu_For_Component( Component ) ;
        if( M <> nil ) then
        begin
            Main_Form.ToggleEmbedClick( M ) ;
        end ;
    end ;
end ;


procedure TCEF32_Interface.Want_Signals( Component : TComponent ;
    Value : boolean ) ;

begin
    if( Component <> nil ) then
    begin
        if( Value ) then
        begin
            Signal_Components.Add( Component ) ;
        end else
        begin
            Signal_Components.Remove( Component ) ;
        end ;
    end ;
end ;


procedure TCEF32_Interface.Terminate ;

begin
    Main_Form.Visible := True ;
    Main_Form.Terminate_Requested := True ;
    SetFocus( Main_Form.Handle ) ;
end ;


procedure TCEF32_Interface.Hide( Flag : boolean ) ;

begin
    Main_Form.Visible := Flag ;
end ;


procedure TCEF32_Interface.Watchpoint_Notice( Address : int64 ;
    Access, Tag : longint ; Component : TComponent ;
    Memory, Internal, Port : boolean ) ;

var S : string ;

begin
    case Access of
        Access_Read : S := 'read' ;
        Access_Write : S := 'write' ;
        else S := 'access' ;
    end ;
    if( Port ) then
    begin
        case Access of
            Access_Read : S := 'input' ;
            Access_Write : S := 'output' ;
        end ;
        ShowMessage( Component_Name( Component ) + ': Port ' + S + ' watchpoint triggered for port ' + CvtB( 10, Main_Form.AD.Base, inttostr( Address ) ) ) ;
    end else
    if( Internal and ( Component.Component_Type = Component_Type_CPU ) ) then
    begin
        if( Memory ) then
        begin
            ShowMessage( Component_Name( Component ) + ': Cache ' + S + ' watchpoint at address ' + CvtB( 10, Main_Form.AD.Base, inttostr( Address ) ) ) ;
        end else
        begin
            ShowMessage( Component_Name( Component ) + ': Register ' + S + ' watchpoint triggered for register ' + Component.CPU.Register_Name( Address ) ) ;
        end ;
    end else
    begin
        ShowMessage( Component_Name( Component ) + ': Watchpoint at address ' + CvtB( 10, Main_Form.AD.Base, inttostr( Address ) ) ) ;
    end ;
    if( Main_Form.Master_CPU <> nil ) then
    begin
        Main_Form.Master_CPU.CPU.Stop ;
    end ;
end ; // TCEF32_Interface.Watchpoint_Notice



type TFile_Streamer = class( TCOM_Stream )
                          private // Instance data...
                              F : file ;
                              _Last_Error : integer ;
                              _UEC : TUEC ;

                          public // Constructors and destructors...
                              constructor Create( Name : string ; _Create : boolean ) ;

                              destructor Destroy ; override ;

                          public // API...
                              function At_End : boolean ; override ; stdcall ;

                              function Facility_ID : longint ;
                                  override ; stdcall ;

                              procedure Last_Error( var UEC : TUEC ) ;
                                  override ;

                              procedure Read( var Buffer ; var Size : longint ) ;
                                  override ; stdcall ;

                              procedure Read_Line( var Buffer ; var Size : longint ) ;
                                  override ; stdcall ;

                              procedure Seek( Position : longint ) ;
                                  override ; stdcall ;

                              function Size : longint ;
                                  override ;

                              procedure Write( var Buffer ; size : longint ) ;
                                  override ; stdcall ;

                              procedure Write_Line( Buffer : PChar ) ;
                                  override ; stdcall ;
                      end ;

// Constructors and destructors...

constructor TFile_Streamer.Create( Name : string ; _Create : boolean ) ;

begin
    inherited Create ;

    assignfile( F, Name ) ;
    {$I-}
    if( _Create ) then
    begin
        rewrite( F, 1 ) ;
    end else
    begin
        reset( F, 1 ) ;
    end ;
    {$I+}
    _Last_Error := IOResult ;
    if( _Last_Error <> 0 ) then
    begin
        ShowMessage( ERT( _Last_Error ) + ' while accessing file ' + Name ) ;
    end ;
end ;


destructor TFile_Streamer.Destroy ;

begin
    closefile( F ) ;

    inherited Destroy ;
end ;


// API...

{ Returns True if there is no more data in the stream to read. }
function TFile_Streamer.At_End : boolean ;

begin
    Result := EOF( F ) ;
end ;


{ Returns the facility code for this class. }
function TFile_Streamer.Facility_ID : longint ;

begin
    Result := 53 ;
end ;


procedure TFile_Streamer.Last_Error( var UEC : TUEC ) ;

begin
    UEC := _UEC ;
end ;


{ Reads the specified number of bytes from the stream.  Size is modified
  to be the actual bytes transferred. }
procedure TFile_Streamer.Read( var Buffer ; var Size : longint ) ;

var Count : integer ;

begin
    {$I-}
    blockread( F, Buffer, Size, Count ) ;
    {$I+}
    _UEC.Facility := Facility_ID ;
    _UEC.Code := IOResult ;
    Size := Count ;
end ;


{ Reads one line of input, up to the size of the buffer.  The line is
  assumed to end at an ASCII 13 code.  The ASCII 13 code is not included
  in the returned data.  Size is modified to be the actual bytes
  transferred. }
procedure TFile_Streamer.Read_Line( var Buffer ; var Size : longint ) ;

var C : char ;
    Count : integer ;
    S : string ;
    Temp : longint ;

begin
    Count := 0 ;
    while( ( Count <= Size ) and ( not At_End ) ) do
    begin
        Temp := 1 ;
        Read( C, Temp ) ;
        if( _UEC.Code <> 0 ) then
        begin
            Size := Count ;
            move( S[ 1 ], Buffer, Count ) ;
            exit ;
        end ;
        if( C = CR ) then // End of line
        begin
            break ;
        end ;
        S := S + C ;
        inc( Count ) ;
    end ;
    Size := Count ;
    move( S[ 1 ], Buffer, Count ) ;
end ;


{ Position to specified byte within streamed data. }
procedure TFile_Streamer.Seek( Position : longint ) ;

begin
    {$I-}
    System.Seek( F, Position ) ;
    {$I+}
    _UEC.Facility := Facility_ID ;
    _UEC.Code := IOResult ;
end ;


function TFile_Streamer.Size : longint ;

begin
    Size := filesize( F ) ;
end ;


{ Writes the specified buffer, of the specified size in bytes, to the
  stream. }
procedure TFile_Streamer.Write( var Buffer ; size : longint ) ;

begin
    {$I-}
    blockwrite( F, Buffer, Size ) ;
    {$I+}
    _UEC.Facility := Facility_ID ;
    _UEC.Code := IOResult ;
end ;


{ Writes the specified null-terminated text to the stream.  An ASCII
  code 13 is appended to the text on output. }
procedure TFile_Streamer.Write_Line( Buffer : PChar ) ;

var S : char ;

begin
    Write( Buffer[ 0 ], strlen( Buffer ) ) ;
    if( _UEC.Code = 0 ) then
    begin
        S := CR ;
        Write( S, 1 ) ;
    end ;
end ;



// Constructors and destructors...

constructor TEditor_Streamer.Create( Editor : TEditor_Window ) ;

begin
    inherited Create ;

    _Editor := Editor ;
    if( _Editor.Max_Line > 0 ) then
    begin
        Line_Buffer := _Editor.Get_Line( 1 ) + CR ;
    end ;
    Current_Line := 1 ;
end ;


// API...

function TEditor_Streamer.At_End : boolean ;

begin
    Result := ( ( length( Line_Buffer ) = 0 ) and ( Current_Line > _Editor.Max_Line ) ) ;
end ;


function TEditor_Streamer.Facility_ID : longint ;

begin
    Result := 55 ;
end ;


procedure TEditor_Streamer.Last_Error( var UEC : TUEC ) ;

begin
    fillchar( UEC, sizeof( UEC ), 0 ) ;
end ;


procedure TEditor_Streamer.Read( var Buffer ; var Size : longint ) ;

begin
    Read_Line( Buffer, Size ) ; // No difference from Read_Line
end ;


procedure TEditor_Streamer.Read_Line( var Buffer ; var Size : longint ) ;

begin
    if( length( Line_Buffer ) = 0 ) then // Nothing in buffer
    begin
        inc( Current_Line ) ;
        if( not At_End ) then
        begin
            Line_Buffer := _Editor.Get_Line( Current_Line ) + CR ;
        end ;
    end ;
    if( Size > length( Line_Buffer ) ) then
    begin
        Size := length( Line_Buffer ) ;
    end ;
    move( Line_Buffer[ 1 ], Buffer, Size ) ;
    Line_Buffer := copy( Line_Buffer, Size + 1, length( Line_Buffer ) ) ;
end ;


procedure TEditor_Streamer.Seek( Position : longint ) ;

begin
    Current_Line := 1 ;
    Line_Buffer := '' ;
    while( Position > 0 ) do
    begin
        if( At_End ) then
        begin
            exit ;
        end ;
        Line_Buffer := _Editor.Get_Line( Current_Line ) + CR ;
        Position := Position - length( Line_Buffer ) ;
        if( Position < 0 ) then
        begin
            Line_Buffer := copy( Line_Buffer, -Position, length( Line_Buffer ) ) ;
        end ;
    end ;
end ;


function TEditor_Streamer.Size : longint ;

begin
    Size := -1 ;
end ;


procedure TEditor_Streamer.Write( var Buffer ; size : longint ) ;

begin
    // We don't support the assembler writing back to the editor.
end ;


procedure TEditor_Streamer.Write_Line( Buffer : PChar ) ;

begin
    // We don't support the assembler writing back to the editor.
end ;


type TNull_Streamer = class( TCOM_Stream )
                            public // API...
                                Write_Size : int64 ;

                                function At_End : boolean ; override ; stdcall ;

                                function Facility_ID : longint ;
                                    override ; stdcall ;

                                procedure Last_Error( var UEC : TUEC ) ;
                                    override ;

                                procedure Read( var Buffer ; var Size : longint ) ;
                                    override ; stdcall ;

                                procedure Read_Line( var Buffer ; var Size : longint ) ;
                                    override ; stdcall ;

                                procedure Seek( Position : longint ) ;
                                    override ; stdcall ;

                                function Size : longint ; override ;

                                procedure Write( var Buffer ; size : longint ) ;
                                    override ; stdcall ;

                                procedure Write_Line( Buffer : PChar ) ;
                                    override ; stdcall ;
                        end ;

// API...

function TNull_Streamer.At_End : boolean ;

begin
    Result := True ;
end ;


function TNull_Streamer.Facility_ID : longint ;

begin
    Result := -1 ;
end ;


procedure TNull_Streamer.Last_Error( var UEC : TUEC ) ;

begin
    fillchar( UEC, sizeof( UEC ), 0 ) ;
end ;


procedure TNull_Streamer.Read( var Buffer ; var Size : longint ) ;

begin
    Size := 0 ;
end ;


procedure TNull_Streamer.Read_Line( var Buffer ; var Size : longint ) ;

begin
    Size := 0 ;
end ;


procedure TNull_Streamer.Seek( Position : longint ) ;

begin
end ;


function TNull_Streamer.Size : longint ;

begin
    Result := 0 ;
end ;


procedure TNull_Streamer.Write( var Buffer ; size : longint ) ;

begin
    Write_Size := Write_Size + Size ;
end ;


procedure TNull_Streamer.Write_Line( Buffer : PChar ) ;

begin
    Write_Size := Write_Size + strlen( Buffer ) ;
end ;



type TOutput_Streamer = class( TCOM_Stream )
                            private // Instance data...
                                Address : int64 ;

                            public // API...
                                Code_Size : int64 ;

                                function At_End : boolean ; override ; stdcall ;

                                function Facility_ID : longint ;
                                    override ; stdcall ;

                                procedure Last_Error( var UEC : TUEC ) ;
                                    override ;

                                procedure Read( var Buffer ; var Size : longint ) ;
                                    override ; stdcall ;

                                procedure Read_Line( var Buffer ; var Size : longint ) ;
                                    override ; stdcall ;

                                procedure Seek( Position : longint ) ;
                                    override ; stdcall ;

                                function Size : longint ; override ;

                                procedure Write( var Buffer ; size : longint ) ;
                                    override ; stdcall ;

                                procedure Write_Line( Buffer : PChar ) ;
                                    override ; stdcall ;
                        end ;

// API...

function TOutput_Streamer.At_End : boolean ;

begin
    Result := True ;
end ;


function TOutput_Streamer.Facility_ID : longint ;

begin
    Result := -1 ;
end ;


procedure TOutput_Streamer.Last_Error( var UEC : TUEC ) ;

begin
    fillchar( UEC, sizeof( UEC ), 0 ) ;
end ;


procedure TOutput_Streamer.Read( var Buffer ; var Size : longint ) ;

begin
    // This is an output-only streamer
end ;


procedure TOutput_Streamer.Read_Line( var Buffer ; var Size : longint ) ;

begin
    // This is an output-only streamer
end ;


procedure TOutput_Streamer.Seek( Position : longint ) ;

begin
    Address := Position ;
end ;


function TOutput_Streamer.Size : longint ;

begin
    Size := Code_Size ;
end ;


procedure TOutput_Streamer.Write( var Buffer ; size : longint ) ;

var Value : integer ;
    P : PChar ;

begin
    Code_Size := Code_Size + Size ;
    P := PChar( @Buffer ) ;
    while( Size > 0 ) do
    begin
        Value := 0 ;
        move( P[ 0 ], Value, 1 ) ;
        Main_Form.Write_Memory( Address, Value ) ;
        inc( Address ) ;
        dec( Size ) ;
        inc( P ) ;
    end ;
end ;


procedure TOutput_Streamer.Write_Line( Buffer : PChar ) ;

var Loop : integer ;

begin
    Loop := 0 ;
    while( Buffer[ Loop ] <> CR ) do
    begin
        Write( Buffer[ Loop ], 1 ) ;
        inc( Loop ) ;
    end ;
end ;



// TPaint_Panel methods...

procedure TPaint_Panel.wmPaint( var Message ) ;

begin
    inherited ;
    
    Main_Form.Memory_BoxPaint( self ) ;
end ;



// TMemory_Array_Interface methods...

function TMemory_Array_Interface.Get_Byte( Index : int64 ) : byte ;

begin
    Result := Main_Form.Examine_Memory( Index ) ;
end ;


procedure TMemory_Array_Interface.Set_Byte( Index : int64 ; Value : byte ) ;

var UEC : TUEC ;

begin
    UEC := Main_Form.Deposit_Memory( Index, Value ) ;
    if( UEC.Code <> 0 ) then
    begin
        ShowMessage( Get_Error_Text( UEC, -1 ) ) ;
    end ;
end ;


function TMemory_Array_Interface.Read_Only : boolean ;

begin
    Result := False ;
end ;


function TMemory_Array_Interface.Low_Bound( Subscript : integer ) : int64 ;

begin
    if( Main_Form.Physical_Address ) then
    begin
        Result := Main_Form.Low_Physical_Address ;
    end else
    begin
        Result := Main_Form.Low_Address ;
    end ;
end ;


function TMemory_Array_Interface.High_Bound( Subscript : integer ) : int64 ;

begin
    if( Main_Form.Physical_Address ) then
    begin
        Result := Main_Form.High_Physical_Address ;
    end else
    begin
        Result := Main_Form.High_Address ;
    end ;
end ;


function TMemory_Array_Interface.Subscripts : integer ;

begin
    Result := 1 ;
end ;


// TMain_Form methods...

procedure TMain_Form.About1Click( Sender : TObject ) ;

begin
    About_Box.ShowModal ;
end ;


procedure TMain_Form.Help2Click( Sender : TObject ) ;

begin
    Application.HelpCommand( HELP_CONTENTS, 0 ) ;
end ;


procedure TMain_Form.Exit1Click( Sender : TObject ) ;

begin
    Close ;
end ;


procedure TMain_Form.Open1Click( Sender : TObject ) ;

begin
    if( Open_Dialog.Execute ) then
    begin
        Open_File( Open_Dialog.Filename ) ;
    end ;
end ;


procedure TMain_Form.Memory_BoxPaint( Sender : TObject ) ;

var Range : int64 ;

begin
    // Paint the memory panel...
    if( Main_Memory <> nil ) then
    begin
        try
            AD.Display ;
            Memory_Scrollbar.LargeChange := AD.LPP ;
            Range := AI.High_Bound( 0 ) ;
            Range := Range - AI.Low_Bound( 0 ) + 1 ;
            if( Range < 0 ) then // Overflow
            begin
                Range := $7FFFFFFF ;
            end ;
            Range := ( Range div AD.Max_Data ) * AD.LPP - 1 ;
            if( Range > $7FFFFFFF ) then
            begin
                Range := $7FFFFFFF ;
            end ;
            Memory_Scrollbar.Max := Range ;
        except
        end ;
    end ;
end ;


procedure TMain_Form.FormShow( Sender : TObject ) ;

var Editor : TEditor_Window ;

begin
    Editor := TEditor_Window.Create( TabSheet1 ) ;
    Editor.Parent := TabSheet1 ;
    Editor.Caption := '' ;
    Editor.BorderStyle := bsNone ;
    Editor.BorderIcons := [] ;
    Editor.Align := alClient ;
    Editor.SetFocus ;
    Editor.OnUpdateMenu := CB_Update_Menu ;
    Editor.On_State_Change := CB_State_Change ;
    TabSheet1.Editor := Editor ;

    Update_Disassembly ;
    Update_Stack ;

    Application.OnIdle := CB_Idle ;
end ; // TMain_Form.FormShow


procedure TMain_Form.FormDestroy( Sender : TObject ) ;

var Editor : TEditor_Window ;
    Loop : integer ;
    F : textfile ;
    Path : string ;

begin
    // Add currently open files to reopen menus so they are added to config file...
    for Loop := 0 to PageControl1.PageCount - 1 do
    begin
        if( TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor <> nil ) then
        begin
            Editor := TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor ;
            Add_To_Reopen( Editor.File_Name ) ;
        end ;
    end ;

    // Write configuration file...
    Path := paramstr( 0 ) ;
    Loop := length( Path ) ;
    while( ( Loop > 0 ) and ( pos( Path[ Loop ], ':\' ) = 0 ) ) do
    begin
        dec( Loop ) ;
    end ;
    Path := copy( Path, 1, Loop ) ;
    assignfile( F, Path + 'CEF.cfg' ) ;
    {$I-}
    rewrite( F ) ;
    {$I+}
    IOResult ;
    for Loop := 1 to 9 do
    begin
        if( Reopen_Menus[ Loop ].Visible ) then
        begin
            {$I-}
            writeln( F, 'F ' + Reopen_Menus[ Loop ].Caption ) ;
            {$I+}
            IOResult ;
        end ;
    end ;
    for Loop := 1 to 9 do
    begin
        if( EReopen_Menus[ Loop ].Visible ) then
        begin
            {$I-}
            writeln( F, 'E ' + EReopen_Menus[ Loop ].Caption ) ;
            {$I+}
            IOResult ;
        end ;
    end ;
    {$I-}
    closefile( F ) ;
    {$I+}
    IOResult ;

    Main_Memory.Free ;
    Main_Memory := nil ;
    if( Memory_DLL <> 0 ) then
    begin
        FreeLibrary( Memory_DLL ) ;
        Memory_DLL := 0 ;
    end ;
    UI.Free ;
    UI := nil ;
    AD.Free ;
    AD := nil ;
    Component_List.Free ;
    Component_List := nil ;
    Watchpoints.Free ;
    Watchpoints := nil ;
    Watchpoint_Size.Free ;
    Watchpoint_Size := nil ;
    Watchpoint_Access.Free ;
    Watchpoint_Access := nil ;
    Register_Watchpoints.Free ;
    Register_Watchpoint_Access.Free ;
    Register_Watchpoints := nil ;
    Register_Watchpoint_Access := nil ;
    Clear_Watches ;
    Watches.Free ;
    Watches := nil ;
    Execution_Watchpoints.Free ;
    Execution_Watchpoints := nil ;
    Port_Watchpoints.Free ;
    Port_Watchpoints := nil ;
    Port_Watchpoints_Access.Free ;
    Port_Watchpoints_Access := nil ;
    Traces.Free ;
    Traces := nil ;
    Parent_Component.Free ;
    Parent_Component := nil ;
end ; // TMain_Form.FormDestroy


procedure TMain_Form.FormCreate( Sender : TObject ) ;

var Loop : integer ;
    F : textfile ;
    P : function( Serial_Number : integer ; UI : TUI_Interface ) : TComponent ; stdcall ;
    Path, S : string ;
    Saved : integer ;

begin
    // Setup...
    TabSheet1 := TCEF_TabSheet.Create( self ) ;
    TabSheet1.PageControl := PageControl1 ;
    TabSheet1.Align := alClient ;
    TabSheet1.Caption := '' ;
    TabSheet1.TabVisible := False ;

    Disassembly_Sheet := TCEF_TabSheet.Create( self ) ;
    Disassembly_Sheet.PageControl := PageControl1 ;
    Disassembly_Sheet.Align := alClient ;
    Disassembly_Sheet.Caption := 'Disassembly' ;
    ScrollBar1 := TScrollbar.Create( Disassembly_Sheet ) ;
    ScrollBar1.Parent := Disassembly_Sheet ;
    ScrollBar1.Align := alRight ;
    ScrollBar1.Kind := sbVertical ;
    ScrollBar1.OnScroll := ScrollBar1Scroll ;
    ScrollBar1.TabStop := False ;
    Disassembly_List_Box := TListBox.Create( Disassembly_Sheet ) ;
    Disassembly_List_Box.Parent := Disassembly_Sheet ;
    Disassembly_List_Box.Align := alClient ;
    Disassembly_List_Box.TabOrder := 0 ;
    Disassembly_List_Box.Font.Name := 'Courier New' ;
    Disassembly_List_Box.OnKeyDown := Disassembly_List_BoxKeyDown ;
    Disassembly_List_Box.OnMouseUp := Disassembly_List_BoxMouseUp ;
    Disassembly_Sheet.OnResize := Disassembly_List_Resize ;

    Physical_Address := True ;
    High_Physical_Address := $7FFFFFFFFFFFFFFF ; // Default high address
    Paint_Panel := TPaint_Panel.Create( Owner ) ;
    Paint_Panel.Parent := Memory_Panel ;
    Paint_Panel.Align := alClient ;
    Paint_Panel.BevelOuter := bvNone ;
    Paint_Panel.PopupMenu := Popup_Menu ;
    Component_List := TStringList.Create ;
    Watchpoints := TInteger64_List.Create ;
    Watchpoint_Size := TInteger_List.Create ;
    Watchpoint_Access := TInteger_List.Create ;
    Register_Watchpoints := TInteger64_List.Create ;
    Register_Watchpoint_Access := TInteger_List.Create ;
    Watches := TList.Create ;
    Execution_Watchpoints := TInteger64_List.Create ;
    Port_Watchpoints := TInteger64_List.Create ;
    Port_Watchpoints_Access := TInteger_List.Create ;
    Traces := TStringList.Create ;

    Reopen_Menus[ 1 ] := N11 ;
    Reopen_Menus[ 2 ] := N21 ;
    Reopen_Menus[ 3 ] := N31 ;
    Reopen_Menus[ 4 ] := N41 ;
    Reopen_Menus[ 5 ] := N51 ;
    Reopen_Menus[ 6 ] := N61 ;
    Reopen_Menus[ 7 ] := N71 ;
    Reopen_Menus[ 8 ] := N81 ;
    Reopen_Menus[ 9 ] := N91 ;

    EReopen_Menus[ 1 ] := N13 ;
    EReopen_Menus[ 2 ] := N23 ;
    EReopen_Menus[ 3 ] := N33 ;
    EReopen_Menus[ 4 ] := N43 ;
    EReopen_Menus[ 5 ] := N53 ;
    EReopen_Menus[ 6 ] := N63 ;
    EReopen_Menus[ 7 ] := N73 ;
    EReopen_Menus[ 8 ] := N83 ;
    EReopen_Menus[ 9 ] := N93 ;

    Path := paramstr( 0 ) ;
    Loop := length( Path ) ;
    while( ( Loop > 0 ) and ( pos( Path[ Loop ], ':\' ) = 0 ) ) do
    begin
        dec( Loop ) ;
    end ;
    Path := copy( Path, 1, Loop ) ;
    Saved := FileMode ;
    FileMode := fmOpenRead ;
    assignfile( F, Path + 'CEF.cfg' ) ;
    {$I-}
    reset( F ) ;
    {$I+}
    FileMode := Saved ;
    if( IOResult = 0 ) then
    begin
        Loop := 1 ;
        while( not eof( F ) ) do
        begin
            {$I-}
            readln( F, S ) ;
            {$I+}
            if( IOResult = 0 ) then
            begin
                if( copy( S, 1, 2 ) = 'F ' ) then
                begin
                    Reopen_Menus[ Loop ].Caption := copy( S, 3, length( S ) ) ;
                    Reopen_Menus[ Loop ].Visible := True ;
                    inc( Loop ) ;
                end else
                if( copy( S, 1, 2 ) = 'E ' ) then
                begin
                    EReopen_Menus[ Loop ].Caption := copy( S, 3, length( S ) ) ;
                    EReopen_Menus[ Loop ].Visible := True ;
                    inc( Loop ) ;
                end ;
            end ;
        end ; // while( not eof( F ) )
        {$I-}
        closefile( F ) ;
        {$I+}
        IOResult ;
    end ; // if( IOResult = 0 )

    if( UI = nil ) then
    begin
        UI := TCEF32_Interface.Create ;
    end ;

    if( Main_Memory = nil ) then
    begin
        Memory_DLL := LoadLibrary( 'CEFMemory.DLL' ) ;
        if( Memory_DLL <> 0 ) then
        begin
            P := GetProcAddress( Memory_DLL, 'Make_Instance' ) ;
            if( assigned( P ) ) then
            begin
                Main_Memory := P( 0, UI ) ;
                Main_Memory.Tag := integer( TComponent_Info.Create ) ;
                TComponent_Info( Main_Memory.Tag ).DLL_Handle := Memory_DLL ;
                TComponent_Info( Main_Memory.Tag ).Menu :=
                    Configure_Component_Menus( Main_Memory, DefaultMemory1 ) ;
            end ;
        end ;
    end ;
    if( AI = nil ) then
    begin
        AI := TMemory_Array_Interface.Create ;
    end ;
    if( AD = nil ) then
    begin
        AD := TArray_Display.Create( Paint_Panel, AI, Font.Handle, clWindow,
            clWindowText ) ;
    end ;

    Parent_Component := TComponent_Parent.Create ;

    S := Command_Line ;
    Startup_Command_File := ( copy( S, 1, 1 ) = '@' ) ;
    if( Startup_Command_File ) then
    begin
        Open_Emulator( copy( S, 2, length( S ) ) ) ;
    end ;
end ; // TMain_Form.FormCreate


procedure TMain_Form.Internals1Click( Sender : TObject ) ;

begin
    Begin_Debugger ;
end ;


procedure TMain_Form.Memory_ScrollBarChange( Sender : TObject ) ;

var Start : int64 ;

begin
    Start := Memory_Scrollbar.Position ;
    Start := Start * AD.Max_Data ;
    Start := Start div AD.LPP ;
    AD.Home_Index := Start ;
    Paint_Panel.Invalidate ;
end ;


procedure TMain_Form.EBCDIC1Click( Sender : TObject ) ;

begin
    if( EBCDIC1.Caption = '&ASCII' ) then
    begin
        EBCDIC1.Caption := '&EBCDIC' ;
        AD.Ascii_Ebcdic := 0 ;
    end else
    begin
        EBCDIC1.Caption := '&ASCII' ;
        AD.Ascii_Ebcdic := 1 ;
    end ;
    Paint_Panel.Invalidate ;
end ;


procedure TMain_Form.Signed1Click( Sender : TObject ) ;

begin
    Signed1.Checked := not Signed1.Checked ;
    AD.Unsigned := not Signed1.Checked ;
    Paint_Panel.Invalidate ;
end ;


procedure TMain_Form.Binary1Click( Sender : TObject ) ;

begin
    AD.Base := 2 ;
    Paint_Panel.Invalidate ;
    Binary1.Checked := True ;
end ;


procedure TMain_Form.Octal1Click( Sender : TObject ) ;

begin
    AD.Base := 8 ;
    Paint_Panel.Invalidate ;
    Octal1.Checked := True ;
end ;


procedure TMain_Form.Decimal1Click( Sender : TObject ) ;

begin
    AD.Base := 10 ;
    Paint_Panel.Invalidate ;
    Decimal1.Checked := True ;
end ;


procedure TMain_Form.Hexadecimal1Click( Sender : TObject ) ;

begin
    AD.Base := 16 ;
    Paint_Panel.Invalidate ;
    Hexadecimal1.Checked := True ;
end ;


procedure TMain_Form.Other1Click( Sender : TObject ) ;

begin
    Radix_Form.Spin_Edit.Value := AD.Base ;
    if( Radix_Form.ShowModal = mrOK ) then
    begin
        AD.Base := Radix_Form.Spin_Edit.Value ;
        Paint_Panel.Invalidate ;
        case AD.Base of
            2 : Binary1.Checked := True ;
            8 : Octal1.Checked := True ;
            10 : Decimal1.Checked := True ;
            16 : Hexadecimal1.Checked := True ;
            else Other1.Checked := True ;
        end ;
    end ;
end ;


procedure TMain_Form.Byte1Click( Sender : TObject ) ;

begin
    AD.Number_Size := 1 ;
    Paint_Panel.Invalidate ;
    Byte1.Checked := True ;
end ;


procedure TMain_Form.Word1Click( Sender : TObject ) ;

begin
    AD.Number_Size := 2 ;
    Paint_Panel.Invalidate ;
    Word1.Checked := True ;
end ;


procedure TMain_Form.Long1Click( Sender : TObject ) ;

begin
    AD.Number_Size := 4 ;
    Paint_Panel.Invalidate ;
    Long1.Checked := True ;
end ;


procedure TMain_Form.Double1Click( Sender : TObject ) ;

begin
    AD.Number_Size := 8 ;
    Paint_Panel.Invalidate ;
    Double1.Checked := True ;
end ;


procedure TMain_Form.GotoAddress1Click( Sender : TObject ) ;

begin
    Goto_Address_Form.Base := AD.Base ;
    if( Goto_Address_Form.ShowModal = mrOK ) then
    begin
        AD.Home_Index := strtoint( Cvtb( AD.Base, 10, Goto_Address_Form.ComboBox1.Text ) ) ;
        Paint_Panel.Invalidate ;
    end ;
end ;


procedure TMain_Form.Find1Click( Sender : TObject ) ;

var B : char ;
    I : int64 ;
    Matched : integer ; // Number of bytes matched
    S : string ;

begin
    Find_Form.Base := AD.Base ;
    if( Find_Form.ShowModal = mrOK ) then
    begin
        S := Find_Form.Find_Image ;
        if( Find_Form.Literal_Text.Checked ) then
        begin
            if( not Find_Form.Case_Sensitive.Checked ) then
            begin
                S := uppercase( S ) ;
            end ;
            if( EBCDIC1.Caption = '&EBCDIC' ) then
            begin
                S := From_EBCDIC( S ) ;
            end ;
        end ;

        // Now search...
        I := AD.Home_Index ;
        Matched := 0 ;
        while( ( I >= 0 ) and ( I <= High_Address ) ) do
        begin
            B := char( AI.Get_Byte( I ) ) ;
            if( not Find_Form.Case_Sensitive.Checked ) then
            begin
                B := upcase( B ) ;
            end ;
            if( B <> S[ Matched + 1 ] ) then
            begin
                Matched := 0 ;
            end else
            begin
                inc( Matched ) ;
            end ;
            if( Matched = length( S ) ) then // Found entire data
            begin
                AD.Home_Index := I ;
                exit ;
            end ;
            I := I + 1 ;
        end ;
        ShowMessage( 'Nothing found' ) ;
    end ;
end ; // TMain_Form.Find1Click


procedure TMain_Form.Radix50Click( Sender : TObject ) ;

begin
    AD.Base := 50 ;
    Paint_Panel.Invalidate ;
    Radix50.Checked := True ;
end ;


procedure TMain_Form.Save1Click( Sender : TObject ) ;

var C : TComponent ;
    Stream : TFile_Streamer ;

begin
    C := TComponent( TMenuItem( Sender ).Tag ) ;
    if( Save_Memory_Dialog.Execute ) then
    begin
        Stream := TFile_Streamer.Create( Save_Memory_Dialog.FileName, True ) ;
        C.Save_Contents( Stream ) ;
        Stream.Free ;
    end ;
end ;


procedure TMain_Form.Restore1Click( Sender : TObject ) ;

var C : TComponent ;
    Stream : TFile_Streamer ;

begin
    C := TComponent( TMenuItem( Sender ).Tag ) ;
    if( Restore_Memory_Dialog.Execute ) then
    begin
        Stream := TFile_Streamer.Create( Restore_Memory_Dialog.FileName, False ) ;
        C.Restore_Contents( Stream ) ;
        Stream.Free ;
    end ;
end ;


procedure TMain_Form.Save2Click( Sender : TObject ) ;

var C : TComponent ;
    Stream : TFile_Streamer ;

begin
    C := TComponent( TMenuItem( Sender ).Tag ) ;
    if( Save_Memory_State_Dialog.Execute ) then
    begin
        Stream := TFile_Streamer.Create( Save_Memory_State_Dialog.FileName, True ) ;
        C.Save_State( Stream ) ;
        Stream.Free ;
    end ;
end ;


procedure TMain_Form.Restore2Click( Sender : TObject ) ;

var C : TComponent ;
    Stream : TFile_Streamer ;

begin
    C := TComponent( TMenuItem( Sender ).Tag ) ;
    if( Restore_Memory_State_Dialog.Execute ) then
    begin
        Stream := TFile_Streamer.Create( Restore_Memory_State_Dialog.FileName, False ) ;
        C.Restore_State( Stream ) ;
        Stream.Free ;
    end ;
end ;


procedure TMain_Form.Physical1Click( Sender : TObject ) ;

begin
    if( Physical1.Caption = '&Physical' ) then
    begin
        Physical1.Caption := '&Logical' ;
        Physical_Address := False ;
    end else
    begin
        Physical1.Caption := '&Physical' ;
        Physical_Address := True ;
    end ;
    Paint_Panel.Invalidate ;
    Update_Disassembly ;
end ;



procedure TMain_Form.New1Click( Sender : TObject ) ;

var Editor : TEditor_Window ;
    Tab_Control : TCEF_TabSheet ;

begin
    // Create a new tab with editor...
    Tab_Control := TCEF_TabSheet.Create( self ) ;
    Tab_Control.PageControl := PageControl1 ;
    Tab_Control.Align := alClient ;
    Tab_Control.Caption := 'Noname' ;

    Editor := TEditor_Window.Create( Tab_Control ) ;
    Editor.Parent := Tab_Control ;
    Editor.Caption := '' ;
    Editor.BorderStyle := bsNone ;
    Editor.BorderIcons := [] ;
    Editor.Align := alClient ;
    Tab_Control.Editor := Editor ;
    PageControl1.ActivePage := Tab_Control ;
    Editor.OnUpdateMenu := CB_Update_Menu ;
    Editor.On_Kill := CB_Kill ;
    Editor.On_State_Change := CB_State_Change ;
    Editor.SetFocus ;
end ; // TMain_Form.New1Click


procedure TMain_Form.Save3Click(Sender: TObject);

var Editor : TEditor_Window ;

begin
    Editor := TEditor_Window( PageControl1.ActivePage.Controls[ 0 ] ) ;
    if( ( Editor.File_Name = 'Noname' ) and ( Editor.Max_Line = 0 ) ) then
    begin
        exit ;
    end ;

    if( Editor.New_File ) then
    begin
        SaveAs1Click( Sender ) ;
    end else
    begin
        Editor.Save_File ;
    end ;
end ;


procedure TMain_Form.SaveAs1Click(Sender: TObject);

var Editor : TEditor_Window ;

begin
    Editor := TEditor_Window( PageControl1.ActivePage.Controls[ 0 ] ) ;
    Save_Dialog.FileName := Editor.File_Name ;
    if( Save_Dialog.Execute ) then
    begin
        Editor.File_Name := Save_Dialog.FileName ;
        PageControl1.ActivePage.Caption := Save_Dialog.FileName ;
        Editor.New_File := False ;
        Save3Click( Sender ) ;
    end ;
end ;


procedure TMain_Form.SaveAll1Click(Sender: TObject);

var Editor : TEditor_Window ;
    Loop : integer ;

begin
    for Loop := 0 to PageControl1.PageCount - 1 do
    begin
        Editor := TCEF_Tabsheet( PageControl1.Pages[ Loop ] ).Editor ;
        if(
            ( Editor <> nil )
            and
            ( ( Editor.File_Name <> 'Noname' ) or ( Editor.Max_Line > 0 ) )
          ) then
        begin
            if( Editor.New_File ) then
            begin
                Save_Dialog.FileName := Editor.File_Name ;
                if( Save_Dialog.Execute ) then
                begin
                    Editor.File_Name := Save_Dialog.FileName ;
                    PageControl1.Pages[ Loop ].Caption := Save_Dialog.FileName ;
                    Editor.New_File := False ;
                    Save3Click( Sender ) ;
                end ;
            end else
            begin
                Editor.Save_File ;
            end ;
        end ;
    end ;
end ;


procedure TMain_Form.OpenEmulator1Click( Sender : TObject ) ;

begin
    if( Open_Dialog.Execute ) then
    begin
        _Hide := False ;
        Open_Emulator( Open_Dialog.Filename ) ;
        if( _Hide ) then
        begin
            Hide ;
            _Hide := False ;
        end ;
    end ; // if( Open_Dialog.Execute )
end ; // TMain_Form.OpenEmulator1Click


procedure TMain_Form.Add_To_Reopen( const S : string ) ;

var Loop : integer ;

begin
    // First, see if file is already in a menu
    for Loop := 1 to 9 do
    begin
        if( Reopen_Menus[ Loop ].Visible ) then
        begin
            if( uppercase( copy( Reopen_Menus[ Loop ].Caption, 4, 255 ) ) = uppercase( S ) ) then
            begin
                exit ; // Already in menus
            end ;
        end ;
    end ;

    // Now find a place to add the file
    for Loop := 1 to 9 do
    begin
        if( not Reopen_Menus[ Loop ].Visible ) then
        begin
            Reopen_Menus[ Loop ].Visible := True ;
            Reopen_Menus[ Loop ].Caption := '&' + inttostr( Loop ) + ' ' + S ;
            exit ;
        end ;
    end ;

    // No room, so shift existing files and add at the end...
    for Loop := 2 to 9 do
    begin
        Reopen_Menus[ Loop - 1 ].Visible := Reopen_Menus[ Loop ].Visible ;
        Reopen_Menus[ Loop - 1 ].Caption := Reopen_Menus[ Loop ].Caption ;
    end ;
    Reopen_Menus[ 9 ].Visible := True ;
    Reopen_Menus[ 9 ].Caption := '&9 ' + S ;
end ; // Add_To_Reopen


procedure TMain_Form.Assemble2Click(Sender: TObject);

var Editor : TEditor_Window ;
    Info : TComponent_Info ;
    Loop : integer ;
    Out_Streamer : TOutput_Streamer ;
    T, F : PChar ;
    L, S : longint ;

begin
    if( In_Assembly or In_Execution ) then
    begin
        exit ;
    end ;
    In_Assembly := True ;
    Write_Errors := False ;
    StatusBar.Panels.Items[ 2 ].Text := 'Assembling' ;
    if( Master_Assembler <> nil ) then // Kill old assembler context
    begin
        Master_Assembler.Free ;
        Master_Assembler := nil ;
    end ;
    Info := TComponent_Info( Master_CPU.Tag ) ;
    if( Info.Assembler_Context <> nil ) then
    begin
        Info.Assembler_Context.Free ;
        Info.Assembler_Context := nil ;
    end ;
    Editor := TEditor_Window( PageControl1.ActivePage.Controls[ 0 ] ) ;
    Status := TCEF_Assembler_Status.Create ;
    Status.Current_File := Editor.File_Name ;
    Assembly_Statistics.Abort_Button.Caption := 'Abort' ;
    Assembly_Statistics.Show ;
    Assemble( Editor, Status ) ;
    if( ( Master_Assembler <> nil ) and ( not Assembly_Statistics.Aborted ) ) then
    begin
        Out_Streamer := TOutput_Streamer.Create ;
        Master_Assembler.Backpatch( Status, Out_Streamer ) ;
        Out_Streamer.Free ;
        Info.Assembler_Context := Master_Assembler.Assembler_Context ;
        Master_Assembler.Assembler_Context := nil ;
    end ;
    Assembly_Statistics.Code_Label.Caption := inttostr( Status.Code ) ;
    Assembly_Statistics.Data_Label.Caption := inttostr( Status.Data ) ;
    Assembly_Statistics.Abort_Button.Caption := 'Close' ;
    Assembly_Statistics.Visible := False ;
    Assembly_Statistics.ShowModal ;
    StatusBar.Panels.Items[ 2 ].Text := '' ;
    if( Status.Errors > 0 ) then
    begin
        Error_Dialog.List_Box.Clear ;
        Error_Dialog.Filenames.Clear ;
        Error_Dialog.Lines.Clear ;
        for Loop := 0 to Status.Error_List.Count - 1 do
        begin
            Error_Dialog.List_Box.Items.Add( Status.Error_List[ Loop ] ) ;
            Status.Get_Error( Loop, T, F, L, S ) ;
            Error_Dialog.Filenames.Add( string( F ) ) ;
            Error_Dialog.Lines.Add( L ) ;
        end ;
        Error_Dialog.Show ;
    end ;
    Status.Free ;
    Status := nil ;
    In_Assembly := False ;
    Disassembly_Top := -1 ;
    Stack_Top := -1 ;
    Update_Disassembly ;
    Update_CPU_State ;
end ; // TMain_Form.Assemble2Click


procedure TMain_Form.AssembleAll1Click( Sender : TObject ) ;

var Editor : TEditor_Window ;
    Info : TComponent_Info ;
    Loop : integer ;
    Out_Streamer : TOutput_Streamer ;
    T, F : PChar ;
    L, S : longint ;

begin
    if( In_Assembly or In_Execution ) then
    begin
        exit ;
    end ;
    In_Assembly := True ;
    Write_Errors := False ;
    StatusBar.Panels.Items[ 2 ].Text := 'Assembling' ;
    if( Master_Assembler <> nil ) then // Kill old assembler context
    begin
        Master_Assembler.Free ;
        Master_Assembler := nil ;
    end ;
    Info := TComponent_Info( master_CPU.Tag ) ;
    if( Info.Assembler_Context <> nil ) then
    begin
        Info.Assembler_Context.Free ;
        Info.Assembler_Context := nil ;
    end ;
    Status := TCEF_Assembler_Status.Create ;
    Assembly_Statistics.Abort_Button.Caption := 'Abort' ;
    Assembly_Statistics.Show ;
    try
        for Loop := 0 to PageControl1.PageCount - 1 do
        begin
            if( TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor <> nil ) then
            begin
                Editor := TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor ;
                Status.Current_File := Editor.File_Name ;
                if( not Assemble( Editor, Status ) ) then
                begin
                    exit ;
                end ;
                Assembly_Statistics.Code_Label.Caption := inttostr( Status.Code ) ;
                Assembly_Statistics.Data_Label.Caption := inttostr( Status.Data ) ;
                if( Status.Aborted ) then
                begin
                    exit ;
                end ;
            end ;
        end ;
    finally
        StatusBar.Panels.Items[ 2 ].Text := '' ;
        Assembly_Statistics.Visible := False ;
        Assembly_Statistics.Code_Label.Caption := inttostr( Status.Code ) ;
        Assembly_Statistics.Data_Label.Caption := inttostr( Status.Data ) ;
        Assembly_Statistics.Abort_Button.Caption := 'Close' ;
        Assembly_Statistics.ShowModal ;
        if( ( Master_Assembler <> nil ) and ( not Assembly_Statistics.Aborted ) ) then
        begin
            Out_Streamer := TOutput_Streamer.Create ;
            Master_Assembler.Backpatch( Status, Out_Streamer ) ;
            Out_Streamer.Free ;
            Info.Assembler_Context := Master_Assembler.Assembler_Context ;
            Master_Assembler.Assembler_Context := nil ;
        end ;
        if( Status.Errors > 0 ) then
        begin
            Error_Dialog.List_Box.Clear ;
            Error_Dialog.Filenames.Clear ;
            Error_Dialog.Lines.Clear ;
            for Loop := 0 to Status.Error_List.Count - 1 do
            begin
                Error_Dialog.List_Box.Items.Add( Status.Error_List[ Loop ] ) ;
                Status.Get_Error( Loop, T, F, L, S ) ;
                Error_Dialog.Filenames.Add( string( F ) ) ;
                Error_Dialog.Lines.Add( L ) ;
            end ;
            Error_Dialog.Show ;
        end ;
        Status.Free ;
        Status := nil ;
        In_Assembly := False ;
        Disassembly_Top := -1 ;
        Stack_Top := -1 ;
        Update_Disassembly ;
        Update_CPU_State ;
    end ;
end ; // TMain_Form.AssembleAll1Click


// Internal utility routines...

function TMain_Form.Assemble( Editor : TEditor_Window ;
    Status : TAssembler_Status ) : boolean ;

var In_Streamer : TEditor_Streamer ;
    Out_Streamer : TOutput_Streamer ;
    UEC : TUEC ;

begin
    if( Master_Assembler = nil ) then
    begin
        Master_Assembler := TCEF_Assembler.Create( Master_CPU, UI ) ;
    end ;
    In_Streamer := TEditor_Streamer.Create( Editor ) ;
    Out_Streamer := TOutput_Streamer.Create ;
    TCEF_Assembler_Status( Status ).In_Streamer := In_Streamer ;
    UEC := Master_Assembler.Assemble( In_Streamer, Out_Streamer, nil, Status ) ;
    In_Streamer.Free ;
    Result := ( UEC.Code = 0 ) ;
    Status.Code := Status.Code + Out_Streamer.Code_Size - Status.Data ;
    Out_Streamer.Free ;

    Paint_Panel.Invalidate ;
    Update_Watches ;
end ;


function TMain_Form.Configure_Component_Menus( C : TComponent ; M : TMenuItem ) : TMenuItem ;

var Menu : TMenuItem ;

begin
    Menu := TMenuItem.Create( M ) ;
    M.Tag := integer( C ) ;
    Result := Menu ;
    Menu.Tag := integer( C ) ;
    Menu.Caption := '&Reset' ;
    Menu.OnClick := Reset1Click ;
    M.Add( Menu ) ;

    if( C.Component_Type = Component_Type_CPU ) then
    begin
        Menu := TMenuItem.Create( M ) ;
        Menu.Tag := integer( C ) ;
        Menu.Caption := 'Res&tart' ;
        Menu.OnClick := Restart1Click ;
        M.Add( Menu ) ;
    end ;

    if( C.Component_Type = Component_Type_UI ) then
    begin
        Menu := TMenuItem.Create( M ) ;
        Menu.Tag := integer( C ) ;
        Menu.Caption := 'Embed' ;
        Menu.OnClick := ToggleEmbedClick ;
        M.Add( Menu ) ;
    end ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Caption := '-' ;
    M.Add( Menu ) ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Tag := integer( C ) ;
    Menu.Caption := 'Save Contents...' ;
    Menu.OnClick := Save1Click ;
    M.Add( Menu ) ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Tag := integer( C ) ;
    Menu.Caption := 'Restore Contents...' ;
    Menu.OnClick := Restore1Click ;
    M.Add( Menu ) ;

    if( C.Component_Type = Component_Type_Memory ) then
    begin
        Menu := TMenuItem.Create( M ) ;
        Menu.Tag := integer( C ) ;
        Menu.Caption := 'Dump...' ;
        Menu.OnClick := Dump1Click ;
        M.Add( Menu ) ;

        Menu := TMenuItem.Create( M ) ;
        Menu.Tag := integer( C ) ;
        Menu.Caption := 'Load...' ;
        Menu.OnClick := LoadMem1Click ;
        M.Add( Menu ) ;
    end ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Caption := '-' ;
    M.Add( Menu ) ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Tag := integer( C ) ;
    Menu.Caption := 'Save state...' ;
    Menu.OnClick := Save2Click ;
    M.Add( Menu ) ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Tag := integer( C ) ;
    Menu.Caption := 'Restore state...' ;
    Menu.OnClick := Restore2Click ;
    M.Add( Menu ) ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Caption := '-' ;
    M.Add( Menu ) ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Tag := integer( C ) ;
    Menu.Caption := '&Profile' ;
    Menu.OnClick := ProfileClick ;
    M.Add( Menu ) ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Tag := integer( C ) ;
    Menu.Caption := 'Profile report...' ;
    Menu.OnClick := ProfileReportClick ;
    M.Add( Menu ) ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Caption := '-' ;
    M.Add( Menu ) ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Tag := integer( C ) ;
    Menu.Caption := '&Connections...' ;
    Menu.OnClick := ConnectionsClick ;
    M.Add( Menu ) ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Tag := integer( C ) ;
    Menu.Caption := 'Condition &handling...' ;
    Menu.OnClick := ConditionsClick ;
    M.Add( Menu ) ;

    Menu := TMenuItem.Create( M ) ;
    Menu.Tag := integer( C ) ;
    Menu.Caption := 'Con&figure...' ;
    Menu.OnClick := ConfigureClick ;
    M.Add( Menu ) ;

    if( C <> Main_Memory ) then
    begin
        Menu := TMenuItem.Create( M ) ;
        Menu.Tag := integer( C ) ;
        Menu.Caption := '&Unload' ;
        Menu.OnClick := UnloadClick ;
        M.Add( Menu ) ;
    end ;
end ; // TMain_Form.Configure_Component_Menusend ;


procedure TMain_Form.Open_Emulator( Filename : string ) ;

    function Find_Component( S : string ) : TComponent ;

    var Loop : integer ;

    begin
        S := uppercase( S ) ;
        if( S = 'DEFAULT MEMORY' ) then
        begin
            Result := Main_Memory ;
            exit ;
        end ;
        Result := nil ;
        for Loop := 0 to Component_List.Count - 1 do
        begin
            if( S = uppercase( Component_List[ Loop ] ) ) then
            begin
                Result := TComponent( Component_List.Objects[ Loop ] ) ;
                exit ;
            end ;
        end ;
    end ;

var C, C1 : TComponent ;
    Dummy : integer ;
    F : file ;
    Loop : integer ;
    Name, S, S1 : string ;
    Parser : TString_Parser ;
    Saved : integer ;

begin
    if( Extension_Pos( Filename ) = 0 ) then
    begin
        Filename := Filename + '.cef' ;
    end ;
    Saved := FileMode ;
    FileMode := fmOpenRead ;
    assignfile( F, Filename ) ;
    {$I-}
    reset( F, 1 ) ;
    {$I+}
    FileMode := Saved ;
    Dummy := IOResult ;
    if( Dummy <> 0 ) then
    begin
        ShowMessage( ERT( Dummy ) + ' while opening ' + Filename ) ;
        exit ;
    end ;
    setlength( S, filesize( F ) ) ;
    {$I-}
    blockread( F, S[ 1 ], length( S ) ) ;
    {$I+}
    Dummy := IOResult ;
    {$I-}
    closefile( F ) ;
    {$I+}
    Clear_IOResult ;
    if( Dummy <> 0 ) then
    begin
        ShowMessage( ERT( Dummy ) + ' while reading ' + Filename ) ;
        exit ;
    end ;
    Start_Execution := False ;

    // Load emulator definition
    Parser := TString_Parser.Create ;
    try
        Parser.Set_Source( S ) ;
        S := uppercase( Parser.Token ) ;
        while( S <> '' ) do
        begin
            if( S = ';' ) then // Comment
            begin
                Parser.Grab_Line ;
            end else
            if( S = 'ASCII' ) then
            begin
                EBCDIC1.Caption := '&ASCII' ;
                AD.Ascii_Ebcdic := 0 ;
                Paint_Panel.Invalidate ;
            end else
            if( S = 'BYTE' ) then
            begin
                AD.Number_Size := 1 ;
                Paint_Panel.Invalidate ;
                Byte1.Checked := True ;
            end else
            if( S = 'CAPTION' ) then
            begin
                Caption := Trim_Quotes( Parser.Token ) ;
            end else
            if( S = 'CONNECT' ) then
            begin
		S := Trim_Quotes( Parser.Token ) ;
                S1 := Trim_Quotes( Parser.Token ) ;
                C := Find_Component( S ) ;
                C1 := Find_Component( S1 ) ;
                if( C = nil ) then
                begin
                    ShowMessage( 'Cannot find component ' + S ) ;
                    exit ;
                end ;
                if( C1 = nil ) then
                begin
                    ShowMessage( 'Cannot find component ' + S1 ) ;
                    exit ;
                end ;
                C.Connect_Output( C1 ) ;
                C1.Connect_Input( C ) ;
                C.Connect_Input( C1 ) ;
                C1.Connect_Output( C ) ;
            end else
            if( S = 'DISCONNECT' ) then
            begin
		S := Trim_Quotes( Parser.Token ) ;
                S1 := Trim_Quotes( Parser.Token ) ;
                C := Find_Component( S ) ;
                C1 := Find_Component( S1 ) ;
                if( C = nil ) then
                begin
                    ShowMessage( 'Cannot find component ' + S ) ;
                    exit ;
                end ;
                if( C1 = nil ) then
                begin
                    ShowMessage( 'Cannot find component ' + S1 ) ;
                    exit ;
                end ;
                C.Disconnect_Output( C1 ) ;
                C1.Disconnect_Output( C ) ;
                C.Disconnect_Input( C1 ) ;
                C1.Disconnect_Input( C ) ;
            end else
            if( S = 'DOUBLE' ) then
            begin
                AD.Number_Size := 8 ;
                Paint_Panel.Invalidate ;
                Double1.Checked := True ;
            end else
            if( S = 'EBCDIC' ) then
            begin
                EBCDIC1.Caption := '&EBCDIC' ;
                AD.Ascii_Ebcdic := 1 ;
                Paint_Panel.Invalidate ;
            end else
            if( S = 'HIDE' ) then
            begin
                _Hide := True ;
            end else
            if( S = 'HIGH' ) then
            begin
                S := Parser.Token ;
                if( not Valid_Base( S, AD.Base ) ) then
                begin
                    ShowMessage( S + ' is not a valid number in radix ' + inttostr( AD.Base ) ) ;
                    exit ;
                end ;
                High_Physical_Address := strtoint64( CvtB( AD.Base, 10, S ) ) ;
                Paint_Panel.Invalidate ;
            end else
            if( S = 'IMMEDIATE' ) then
            begin
                S := Parser.Token ;
                if( ( copy( S, 1, 1 ) = '"' ) or ( copy( S, 1, 1 ) = #39 ) ) then
                begin
                    if( copy( S, length( S ), 1 ) = S[ 1 ] ) then
                    begin
                        setlength( S, length( S ) - 1 ) ;
                    end ;
                    S := copy( S, 2, length( S ) ) ;
                end ;
                Immediate_Mode_Edit.Text := S ;
                Runimmediate1Click( nil ) ;
                Immediate_Mode_Edit.Text := '' ;
            end else
            if( S = 'LOAD' ) then
            begin
                Name := '' ;
                S := Parser.Token ;
                S1 := Parser.Token ;
                if( S1 = '/' ) then
                begin
                    S1 := uppercase( Parser.Token ) ;
                    if( S1 = 'NAME' ) then
                    begin
                        S1 := Parser.Token ;
                        if( S1 <> '=' ) then
                        begin
                            ShowMessage( 'Expected "=", found "' + S1 + '"' ) ;
                            exit ;
                        end ;
                        Name := Parser.Token ; // Get component name
                    end else
                    begin
                        ShowMessage( S1 + ' is not a valid switch on LOAD' ) ;
                        exit ;
                    end ;
                    S1 := Parser.Token ;
                end ;
                if( copy( S1, 1, 1 ) <> '"' ) then
                begin
                    Parser.Put_Token( S1 ) ;
                    S1 := '' ;
                end ;
                if( not Load_Component( S, S1, Name ) ) then
                begin
                    exit ;
                end ;
            end else
            if( S = 'LONG' ) then
            begin
                AD.Number_Size := 4 ;
                Paint_Panel.Invalidate ;
                Long1.Checked := True ;
            end else
            if( S = 'LOW' ) then
            begin
                S := Parser.Token ;
                if( not Valid_Base( S, AD.Base ) ) then
                begin
                    ShowMessage( S + ' is not a valid number in radix ' + inttostr( AD.Base ) ) ;
                    exit ;
                end ;
                Low_Physical_Address := strtoint64( CvtB( AD.Base, 10, S ) ) ;
                Low_Address := Low_Physical_Address ;
                Paint_Panel.Invalidate ;
            end else
            if( S = 'RADIX' ) then
            begin
                S := Parser.Token ;
                try
                    Dummy := strtoint( S ) ;
                except
                    Dummy := -1 ;
                end ;
                if( ( Dummy < 2 ) or ( Dummy > 50 ) ) then
                begin
                    ShowMessage( 'Invalid radix ' + S ) ;
                    exit ;
                end ;
                AD.Base := Dummy ;
                Paint_Panel.Invalidate ;
                case Dummy of
                    2 : Binary1.Checked := True ;
                    8 : Octal1.Checked := True ;
                    10 : Decimal1.Checked := True ;
                    16 : Hexadecimal1.Checked := True ;
                    else Other1.Checked := True ;
                end ;
            end else
            if( S = 'RUN' ) then
            begin
                Start_Execution := True ;
            end else
            if( S = 'SIGNED' ) then
            begin
                Signed1.Checked := True ;
                AD.Unsigned := not Signed1.Checked ;
                Paint_Panel.Invalidate ;
            end else
            if( S = 'UNLOAD_ALL' ) then
            begin
                UnloadAll1Click( nil ) ;
            end else
            if( S = 'UNLOAD' ) then
            begin
                S := Parser.Token ;
                Dummy := Component_List.IndexOf( S ) ;
                if( Dummy = -1 ) then
                begin
                    ShowMessage( 'Unknown component on Unload: ' + S ) ;
                    exit ;
                end else
                begin
                    Remove_Component( Dummy, True ) ;
                end ;
            end else
            if( S = 'UNSIGNED' ) then
            begin
                Signed1.Checked := False ;
                AD.Unsigned := not Signed1.Checked ;
                Paint_Panel.Invalidate ;
            end else
            if( S = 'WORD' ) then
            begin
                AD.Number_Size := 2 ;
                Paint_Panel.Invalidate ;
                Word1.Checked := True ;
            end else
            begin
                ShowMessage( 'Unknown emulator command: ' + S ) ;
                exit ;
            end ;
            S := uppercase( Parser.Token ) ;
        end ;
    finally
        Parser.Free ;

        for Loop := 1 to 9 do
        begin
            if( EReopen_Menus[ Loop ].Visible ) then
            begin
                if( uppercase( copy( EReopen_Menus[ Loop ].Caption, 4, 255 ) ) = uppercase( FileName ) ) then // Already in list
                begin
                    Filename := '' ;
                    break ;
                end ;
            end ;
        end ;
        if( length( Filename ) > 0 ) then
        begin
            for Loop := 1 to 9 do
            begin
                if( not EReopen_Menus[ Loop ].Visible ) then
                begin
                    EReopen_Menus[ Loop ].Visible := True ;
                    EReopen_Menus[ Loop ].Caption := '&' + inttostr( Loop ) + ' ' +
                        Filename ;
                    break ;
                end ;
            end ;
        end ;
    end ; // try
end ; // TMain_Form.Open_Emulator


procedure TMain_Form.Open_File( Name : string ) ;

var Editor : TEditor_Window ;
    Dummy, Loop : integer ;

begin
    // Open the file...
    New1Click( self ) ; // Create a new edit window
    Editor := TEditor_Window( PageControl1.ActivePage.Controls[ 0 ] ) ;
    Editor.Open_File( Name ) ;
    PageControl1.ActivePage.Caption := Editor.File_Name ;
    Editor.FormResize( nil ) ;

    // Remove from reopen menus...
    for Loop := 1 to 9 do
    begin
        if( not Reopen_Menus[ Loop ].Visible ) then
        begin
            break ; // Past current files
        end ;
        if( copy( Reopen_Menus[ Loop ].Caption, 4, 255 ) = Name ) then
        begin
            Reopen_Menus[ Loop ].Visible := False ;
            for Dummy := Loop to 8 do
            begin
                Reopen_Menus[ Dummy ].Caption := Reopen_Menus[ Dummy + 1 ].Caption ;
                Reopen_Menus[ Dummy ].Visible := Reopen_Menus[ Dummy + 1 ].Visible ;
            end ;
            break ;
        end ;
    end ;
end ; // TMain_Form.Open_File


procedure TMain_Form.ConnectionsClick( Sender : TObject ) ;

var Component : TComponent ;

begin
    Component := TComponent( TMenuItem( Sender ).Tag ) ;
    Component_Connection_Manager.Components := Component_List ;
    Component_Connection_Manager.Set_Component( string( Component.Name ) ) ;
    Component_Connection_Manager.ShowModal ;
end ;


procedure TMain_Form.ConditionsClick( Sender : TObject ) ;

begin
    Conditions_Form.Component := TComponent( TMenuItem( Sender ).Tag ) ;
    Conditions_Form.ShowModal ;
end ;


procedure TMain_Form.ConfigureClick( Sender : TObject ) ;

var Active_Value : boolean ;
    B : boolean ;
    C : TComponent ;
    CB : TCheckBox ;
    Info : TComponent_Info ;
    Loop, Dummy : integer ;
    M : TMenuItem ;
    Y : integer ;
    Low, High : int64 ;

begin
    // Setup...
    M := TMenuItem( Sender ) ;
    C := TComponent( M.Tag ) ;

    // Intialize configuration dialog with component's attributes...
    Component_Configuration_Dialog.CPU.Visible :=
        ( C.Component_Type = Component_Type_CPU ) ;
    Component_Configuration_Dialog.Read_Latency.Value := C.Get_Read_Latency ;
    Component_Configuration_Dialog.Write_Latency.Value := C.Get_Write_Latency ;
    if( C.Component_Type = Component_Type_CPU ) then
    begin
        Component_Configuration_Dialog.Clock.Value := C.CPU.Get_Clock_Speed ;
    end ;
    Component_Configuration_Dialog.Memory.Visible :=
        ( C.Component_Type = Component_Type_Memory ) ;
    if( C.Component_Type = Component_Type_Memory ) then
    begin
        Component_Configuration_Dialog.Memory.Left := 8 ;
        C.Memory.Get_Address_Range( Low, High ) ;
        Component_Configuration_Dialog.Low_Address.Value := Low ;
        Component_Configuration_Dialog.High_Address.Value := High ;
    end else
    begin
        // Do this so the OK button will be enabled
        Component_Configuration_Dialog.Low_Address.Value := 0 ;
        Component_Configuration_Dialog.High_Address.Value := 0 ;
    end ;

    // Do signal processing...
    Delete_All_Children( Component_Configuration_Dialog.Signals_Tab_Sheet ) ;
    Dummy := C.Signal_Count ;
    Component_Configuration_Dialog.Signals_Tab_Sheet.Visible := ( Dummy > 0 ) ;
    Y := 8 ;
    for Loop := 0 to Dummy - 1 do
    begin
        CB := TCheckBox.Create( Component_Configuration_Dialog ) ;
        CB.Parent := Component_Configuration_Dialog.Signals_Tab_Sheet ;
        CB.Left := 8 ;
        CB.Top := Y ;
        Y := Y + CB.Height + 2 ;
        CB.Caption := C.Signal_Name( Loop ) ;
        Active_Value := not C.Signal_Active_Low( Loop ) ;
        if( C.Signal_Out( Loop ) ) then
        begin
            C.Get_Signal( PChar( CB.Caption ), B ) ;
        end else
        begin
            Info := TComponent_Info( C.Tag ) ;
            B := Info.Signal_Set( Dummy ) ;
        end ;
        CB.Checked := ( B = Active_Value ) ;
        CB.Enabled := not C.Signal_Out( Loop ) ;
    end ;
    Component_Configuration_Dialog.TabSheet1.BringToFront ;

    // Now show user...
    if( Component_Configuration_Dialog.ShowModal = mrOK ) then
    begin
        // Latency...
        C.Set_Read_Latency( Component_Configuration_Dialog.Read_Latency.Value ) ;
        C.Set_Write_Latency( Component_Configuration_Dialog.Write_Latency.Value ) ;

        // Component-specific settings...
        if( C.Component_Type = Component_Type_CPU ) then
        begin
            C.CPU.Set_Clock_Speed( Component_Configuration_Dialog.Clock.Value ) ;
        end ;
        if( C.Component_Type = Component_Type_Memory ) then
        begin
            Low := Component_Configuration_Dialog.Low_Address.Value ;
            High := Component_Configuration_Dialog.High_Address.Value ;
            C.Memory.Set_Address_Range( Low, High ) ;
        end ;

        // Signals...
        for Loop := 0 to Component_Configuration_Dialog.Signals_Tab_Sheet.ControlCount - 1 do
        begin
            if( not C.Signal_Out( Loop ) ) then
            begin
                CB := TCheckBox( Component_Configuration_Dialog.Signals_Tab_Sheet.Controls[ Loop ] ) ;
                if( CB.Enabled ) then
                begin
                    B := CB.Checked ;
                    if( C.Signal_Active_Low( Loop ) ) then
                    begin
                        B := not B ;
                    end ;
                    C.Set_Signal( PChar( CB.Caption ), B )
                end ; // if( CB.Enabled )
            end ;
        end ; // for Loop
    end ; // if( Component_Configuration_Dialog.ShowModal = mrOK )
end ; // TMain_Form.ConfigureClick


function TMain_Form.Get_File_Stream( Name : string ) : TCOM_Stream ;

var _Assembler : TAssembler ;
    Editor : TEditor_Window ;
    Loop : integer ;
    S : string ;
    UEC : TUEC ;

begin
    // Setup...
    Result := nil ;
    Name := uppercase( Name ) ;
    if( Extension_Pos( Name ) = 0 ) then
    begin
        if( Master_CPU = nil ) then
        begin
            Name := Name + '.asm' ;
        end else
        begin
            _Assembler := Master_CPU.CPU.Get_Assembler( nil ) ;
            S := string( _Assembler.Source_Extensions ) + '|' ;
            Loop := pos( '|', S ) ;
            S := copy( S, 1, Loop - 1 ) ;
            if( copy( S, 1, 1 ) <> '.' ) then
            begin
                S := '.' + S ;
            end ;
            Name := Name + S ;
            _Assembler.Terminate ;
        end ;
    end ; // if( Extension_Pos( Name ) = 0 )

    // See if file is opened
    for Loop := 0 to PageControl1.PageCount - 1 do
    begin
        if( TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor <> nil ) then
        begin
            Editor := TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor ;
            if( uppercase( Editor.File_Name ) = Name ) then
            begin
                Result := TEditor_Streamer.Create( Editor ) ;
                exit ;
            end ;
        end ;
    end ;

    // Try to open the file...
    Result := Create_File_Stream( Name, UEC ) ;
    if( Result = nil ) then
    begin
        ShowMessage( 'Cannot open file ' + Name + ': ' + ERT( UEC.Code ) ) ;
    end ;
end ; // TMain_Form.Get_File_Stream


procedure TMain_Form.ProfileClick( Sender : TObject ) ;

var B : boolean ;
    C : TComponent ;
    M : TMenuItem ;

begin
    case Application.MessageBox( 'Include children in change?', 'Profile', MB_YESNOCANCEL ) of
        ID_YES : B := True ;
        ID_NO : B := False ;
        else exit ;
    end ;
    M := TMenuItem( Sender ) ;
    M.Checked := not M.Checked ;
    C := TComponent( M.Tag ) ;
    C.Set_Profiling( M.Checked, B ) ;
end ;


procedure TMain_Form.ProfileReportClick( Sender : TObject ) ;

var C : TComponent ;
    M : TMenuItem ;

begin
    M := TMenuItem( Sender ) ;
    C := TComponent( M.Tag ) ;
    Report_Profile( C ) ;
end ;


procedure TMain_Form.UnloadClick( Sender : TObject ) ;

var C : TComponent ;
    Index : integer ;
    Loop : integer ;

begin
    // Setup...
    if( In_Assembly or In_Execution ) then
    begin
        exit ;
    end ;
    C := TComponent( TMenuItem( Sender ).Tag ) ;
    Index := -1 ;
    for Loop := 0 to Component_List.Count - 2 do
    begin
        if( Component_List.Objects[ Loop ] = C ) then
        begin
            Index := Loop ;
            break ;
        end ;
    end ;
    Remove_Component( Index, True ) ;
end ;


function TMain_Form.Load_Component( Filename, Setup, Name : string ) : boolean ;

var _Assembler : TAssembler ;
    C : TComponent ;
    Dummy : integer ;
    F : function( Serial_Number : integer ; UI : TUI_Interface ) : TComponent ; stdcall ;
    M : TMenuItem ;
    Module : integer ;
    E, S, Temp : string ;

begin
    // Strip quotes...
    if( copy( Filename, 1, 1 ) = '"' ) then
    begin
        Filename := copy( Filename, 2, length( Filename ) ) ;
        if( copy( Filename, length( Filename ), 1 ) = '"' ) then
        begin
            setlength( Filename, length( Filename ) - 1 ) ;
        end ;
    end ;
    if( copy( Name, 1, 1 ) = '"' ) then
    begin
        Name := copy( Name, 2, length( Name ) ) ;
        if( copy( Name, length( Name ), 1 ) = '"' ) then
        begin
            setlength( Name, length( Name ) - 1 ) ;
        end ;
    end ;
    if( copy( Setup, 1, 1 ) = '"' ) then
    begin
        Setup := copy( Setup, 2, length( Setup ) ) ;
        if( copy( Setup, length( Setup ), 1 ) = '"' ) then
        begin
            setlength( Setup, length( Setup ) - 1 ) ;
        end ;
    end ;

    // Default the extension
    if( Extension_Pos( Filename ) = 0 ) then
    begin
        Filename := Filename + '.dll' ;
    end ;

    // Load the DLL...
    Result := True ; // Assume success
    Module := LoadLibrary( PChar( FileName ) ) ;
    if( Module = 0 ) then
    begin
        ShowMessage( 'Load failure for ' + FileName ) ;
        Result := False ;
        exit ;
    end ;
    F := GetProcAddress( Module, 'Make_Instance' ) ;
    if( @F = nil ) then
    begin
        FreeLibrary( Module ) ;
        ShowMessage( 'Not a valid CEF component: ' + Filename ) ;
        Result := False ;
        exit ;
    end ;
    C := F( Get_Serial_Number, UI ) ;
    if( C = nil ) then
    begin
        FreeLibrary( Module ) ;
        ShowMessage( 'Component creation failure: ' + Filename ) ;
        Result := False ;
        exit ;
    end ;

    // Set up component...
    if( Name <> '' ) then
    begin
        S := Name ;
    end else
    begin
        S := C.Name ;
    end ;
    C.Tag := integer( TComponent_Info.Create ) ;
    TComponent_Info( C.Tag ).DLL_Handle := Module ;
    if( Component_List.Indexof( S ) <> -1 ) then // Duplicate name
    begin
        Dummy := 2 ;
        while( Component_List.Indexof( S + inttostr( Dummy ) ) <> -1 ) do
        begin
            inc( Dummy ) ;
        end ;
        S := S + inttostr( Dummy ) ;
    end ;
    Component_List.Add( S ) ;
    Component_List.Objects[ Component_List.Count - 1 ] := C ;
    C.Parent := Parent_Component ;
    if( C.Component_Type = Component_Type_CPU ) then // CPU
    begin
        Set_Master_CPU( C ) ;
        if( Master_Assembler <> nil ) then
        begin
            Master_Assembler.Free ;
            Master_Assembler := nil ;
        end ;
        Update_CPU_State ;
        Update_Watches ;
        if( Master_Assembler = nil ) then
        begin
            Master_Assembler := TCEF_Assembler.Create( Master_CPU, UI ) ;
        end ;
        _Assembler := Master_CPU.CPU.Get_Assembler( Master_Assembler ) ;
        try
            if( _Assembler.Source_Extensions <> nil ) then
            begin
                E := string( _Assembler.Source_Extensions ) ;
                Temp := '' ;
                while( length( E ) > 0 ) do
                begin
                    Dummy := pos( '|', E + '|' ) ;
                    if( length( Temp ) > 0 ) then
                    begin
                        Temp := Temp + '|' ;
                    end ;
                    Temp := Temp + 'Source files|*.' + copy( E, 1, Dummy - 1 ) ;
                    E := copy( E, Dummy + 1, length( E ) ) ;
                end ;
                if( length( Temp ) > 0 ) then
                begin
                    Open_Dialog.Filter := Temp ;
                end ;
            end ;
        finally
            _Assembler.Terminate ;
        end ;
    end ;
    if( C.Component_Type <> Component_Type_Memory ) then
    begin
        C.Connect_Output( Main_Memory ) ;
        Main_Memory.Connect_Input( C ) ;
    end ;

    Dummy := 3 ;
    while( Components1.Items[ Dummy ].Caption <> '-' ) do
    begin
        inc( Dummy ) ;
    end ;
    M := TMenuItem.Create( Components1 ) ;
    M.Caption := S ;
    M.Enabled := True ;
    try
        Components1.Insert( Dummy, M ) ;
    except
    end ;
    TComponent_Info( C.Tag ).Menu := Configure_Component_Menus( C, M ) ;

    if( length( Setup ) <> 0 ) then
    begin
        C.Set_up( PChar( Setup ) ) ;
    end ;
end ; // TMain_Form.Load_Component


procedure TMain_Form.Log_Trace( Component : TComponent ; Description : string ) ;

begin
    Description := Component_Name( Component ) + ': ' + Description ;
    if( Traces.Count = 0 ) then // Tracing is disabled
    begin
        exit ;
    end ;
    if( Trace_Position = Traces.Count ) then // Need to wrap position
    begin
        Trace_Position := 0 ;
    end ;
    Traces[ Trace_Position ] := Description ;
    inc( Trace_Position ) ;
end ;


procedure TMain_Form.Update_Disassembly ;

var Byte_Size : integer ;

    function Pad( S : string ) : string ;

    begin
        while( length( S ) < Byte_Size ) do
        begin
            S := '0' + S ;
        end ;
        Result := S ;
    end ;

var Address : int64 ;
    Address_Size : integer ;
    _Assembler : TAssembler ;
    B : byte ;
    Count, I, Len, Loop : integer ;
    NP : PChar ;
    PC : int64 ;
    S : string ;
    Saved : integer ;
    Sg : integer ;
    Status : TCEF_Assembler_Status ;
    Stream : TCOM_String_Stream ;

begin
    // Setup...
    Saved := Disassembly_List_Box.ItemIndex ;
    Disassembly_List_Box.Clear ;
    Count := Disassembly_List_Box.ClientHeight div Disassembly_List_Box.ItemHeight ;
    if( Physical_Address ) then
    begin
        Address_Size := length( CVTB( 10, AD.Base, inttostr( High_Physical_Address ) ) ) ;
    end else
    begin
        Address_Size := length( CVTB( 10, AD.Base, inttostr( High_Address ) ) ) ;
    end ;
    Byte_Size := length( CVTB( 10, AD.Base, '255' ) ) ;
    if( ( Disassembly_Top = -1 ) and ( Master_CPU <> nil ) ) then
    begin
        Address := Master_CPU.CPU.Get_Current_Address( 0, True ) ;
    end else
    begin
        Address := Disassembly_Top ;
    end ;
    if( Master_CPU <> nil ) then
    begin
        Stream := TCOM_String_Stream.Create ;
        Status := TCEF_Assembler_Status.Create ;
        if( Master_Assembler = nil ) then
        begin
            Master_Assembler := TCEF_Assembler.Create( Master_CPU, UI ) ;
        end ;
        _Assembler := Master_CPU.CPU.Get_Assembler( Master_Assembler ) ;
    end ;

    // Show disassembly
    try
        for Loop := 0 to Count - 1 do
        begin
            if( Physical_Address ) then
            begin
                if( Address > High_Physical_Address ) then
                begin
                    break ;
                end ;
            end else
            begin
                if( Address > High_Address ) then
                begin
                    break ;
                end ;
            end ;
            S := CvtB( 10, AD.Base, inttostr( Address ) ) ;
            while( length( S ) < Address_Size ) do
            begin
                S := '0' + S ;
            end ;
            S := S + ': ' ;
            if( Master_CPU = nil ) then // No CPU
            begin
                B := _Examine_Memory( Address, True, 0 ) ;
                Disassembly_List_Box.Items.Add( S + Pad( CvtB( 10, AD.Base, inttostr( B ) ) ) +
                    '       .DB   ' + CvtB( 10, AD.Base, inttostr( B ) ) ) ;
                inc( Address ) ;
            end else
            begin
                Master_CPU.CPU.Disassemble( Address, 10, 1, Stream ) ;
                _Assembler.Assemble( Stream.As_String, NP, NP, Len, PC, Sg, Status ) ;
                if( Len = 0 ) then // This indicates a bug in CPU component
                begin
                    Len := 1 ; // Don't let component bug prevent us from working
                end ;
                for I := 1 to Len do
                begin
                    B := _Examine_Memory( Address + I - 1, True, 0 ) ;
                    S := S + Pad( CvtB( 10, AD.Base, inttostr( B ) ) ) ;
                end ;
                for I := Len + 1 to 4 do
                begin
                    S := S + '  ' ;
                end ;
                Stream.Clear ;
                Master_CPU.CPU.Disassemble( Address, 0, 1, Stream ) ;
                Disassembly_List_Box.Items.Add( S + ' ' + string( Stream.As_String ) ) ;
                Address := Address + Len ;
                Stream.Clear ;
                if( Loop = 0 ) then
                begin
                    Disassembly_Second := Address ;
                end ;
            end ;
        end ; // for Loop := 0 to Count - 1
        Disassembly_Next := Address ;
        Disassembly_List_Box.ItemIndex := Saved ;
    finally
        // Clean up
        if( Master_CPU <> nil ) then
        begin
            Stream.Free ;
            Status.Free ;
            Status := nil ;
            _Assembler.Terminate ;  
        end ;
    end ;
end ; // TMain_Form.Update_Disassembly


procedure TMain_Form.Update_Stack ;

var Byte_Size : integer ;

    function Pad( S : string ) : string ;

    begin
        while( length( S ) < Byte_Size ) do
        begin
            S := '0' + S ;
        end ;
        Result := S ;
    end ;

var Address : int64 ;
    Address_Size : integer ;
    B : byte ;
    S : string ;
    Saved : integer ;

begin
    // Setup...
    Saved := Stack_List_Box.ItemIndex ;
    Stack_List_Box.Clear ;
    if( Physical_Address ) then
    begin
        Address_Size := length( CVTB( 10, AD.Base, inttostr( High_Physical_Address ) ) ) ;
    end else
    begin
        Address_Size := length( CVTB( 10, AD.Base, inttostr( High_Address ) ) ) ;
    end ;
    Byte_Size := length( CVTB( 10, AD.Base, '255' ) ) ;

    if( ( Stack_Top = -1 ) and ( Master_CPU <> nil ) ) then
    begin
        Address := Master_CPU.CPU.Top_Of_Stack( 0 ) ;
    end else
    begin
        Address := Stack_Top ;
    end ;

    // Build stack...
    if( Master_CPU <> nil ) then
    begin
        while( Address >= 0 ) do
        begin
            if( Stack_List_Box.Count > 1000 ) then
            begin
                break ;
            end ;
            if( Physical_Address ) then
            begin
                if( Address > High_Physical_Address ) then
                begin
                    break ;
                end ;
            end else
            begin
                if( Address > High_Address ) then
                begin
                    break ;
                end ;
            end ;
            S := CvtB( 10, AD.Base, inttostr( Address ) ) ;
            while( length( S ) < Address_Size ) do
            begin
                S := '0' + S ;
            end ;
            S := S + ': ' ;
            B := _Examine_Memory( Address, True, 0 ) ;
            S := S + Pad( CvtB( 10, AD.Base, inttostr( B ) ) ) + '  ' + chr( B ) ;
            Stack_List_Box.Items.Add( S ) ;
            Address := Address + 1 ;
        end ; // while( Address >= 0 ) 
    end ; // if( Master_CPU <> nil )
    Stack_List_Box.ItemIndex := Saved ;
end ; // TMain_Form.Update_Stack


procedure TMain_Form.Map_Source( Force : boolean ) ;

    function Open_Tab( S : string ) : boolean ;

    var Dummy : integer ;
        Editor : TEditor_Window ;
        Loop : integer ;

    begin
        Result := True ;
        S := uppercase( S ) ;
        for Loop := 0 to PageControl1.PageCount - 1 do
        begin
            if( TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor <> nil ) then
            begin
                Editor := TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor ;
                if( uppercase( Editor.File_Name ) = S ) then
                begin
                    PageControl1.ActivePage := PageControl1.Pages[ Loop ] ;
                    exit ;
                end ;
            end ;
        end ;

        // If we get here, the file is not currently open...
        Dummy := PageControl1.PageCount ;
        Open_File( S ) ;
        if( Dummy = PageControl1.PageCount ) then // Open failed
        begin
            Result := False ;
        end ;
    end ;


var Active_Page : TCEF_TabSheet ;
    Editor : TEditor_Window ;
    Info : TComponent_Info ;
    P : string ;
    Line : integer ;
    Was_CPU_View : boolean ;

begin
    Info := nil ;
    Line := -1 ;
    Active_Page := TCEF_TabSheet( PageControl1.ActivePage ) ;
    Was_CPU_View := ( not Force ) and ( Active_Page = Disassembly_Sheet ) ;
    if( Master_CPU <> nil ) then
    begin
        Info := TComponent_Info( Master_CPU.Tag ) ;
    end ;
    if( ( Info <> nil ) and ( Info.Assembler_Context <> nil ) ) then
    begin
        Line := Info.Assembler_Context.Mapping( Master_CPU.CPU.Get_Current_Address( 0, True ), P ) ;
        if( Line > 0 ) then // Found a mapping
        begin
            if( not Open_Tab( P ) ) then
            begin
                Line := -1 ; // Cannot find source file
            end else
            begin
                // Position editor...
                Editor := TEditor_Window( PageControl1.ActivePage.Controls[ 0 ] ) ;
                Editor.Select_Line( Line ) ;
                Editor.Bring_Into_View ;
            end ;
        end ;
    end ;
    if( ( Was_CPU_View ) or ( Line < 1 ) ) then // Source not found or else in disassembly
    begin
        PageControl1.ActivePage := Disassembly_Sheet ;
    end ;
end ; // TMain_Form.Map_Source


procedure TMain_Form.Report_Profile( Component : TComponent ) ;

begin
    Profile_Report_Form.Set_Component( Component ) ;
    Profile_Report_Form.ShowModal ;
end ;


procedure TMain_Form.Reset1Click( Sender : TObject ) ;

var C : TComponent ;

begin
    C := TComponent( TMenuItem( Sender ).Tag ) ;
    C.Reset ;
    Paint_Panel.Invalidate ;
    Update_Disassembly ;
    Update_Stack ;
    Map_Source( False ) ;
end ;


procedure TMain_Form.Restart1Click( Sender : TObject ) ;

var C : TComponent ;

begin
    C := TComponent( TMenuItem( Sender ).Tag ) ;
    C.CPU.Restart ;
    Paint_Panel.Invalidate ;
    Update_Disassembly ;
    Update_Stack ;
    Map_Source( False ) ;
end ;


procedure TMain_Form.ToggleEmbedClick( Sender : TObject ) ;

var C : TComponent ;
    M : TMenuItem ;
    T : TWinControl ;
    TS : TCEF_TabSheet ;

begin
    M := TMenuItem( Sender ) ;
    C := TComponent( M.Tag ) ;
    M.Checked := not M.Checked ; // Toggle checkmark
    if( M.Checked ) then // Change to embedded
    begin
        TS := TCEF_TabSheet.Create( self ) ;
        TS.PageControl := PageControl1 ;
        TS.UI := C ;
        C.User_Interface.Set_Parent_Window( TS.Handle ) ;
        TS.Align := alClient ;
        TS.Caption := C.User_Interface.Get_Caption ;
    end else
    begin
        T := FindControl( C.User_Interface.Get_Parent_Window ) ;
        C.User_Interface.Set_Parent_Window( 0 ) ;
        if( T <> nil ) then
        begin
            if( T is TCEF_TabSheet ) then
            begin
                TCEF_TabSheet( T ).UI := nil ;
            end ;
            T.Free ;
        end ;
    end ;
end ;


procedure TMain_Form.Set_Master_CPU( CPU : TComponent ) ;

var Loop : integer ;
    M : TMenuItem ;
    P : PChar ;

begin
    Master_CPU := CPU ;
    if( Master_CPU = nil ) then
    begin
        Physical_Address := True ;
    end ;
    Run1.Enabled := ( CPU <> nil ) ;
    Assemble1.Enabled := Run1.Enabled ;
    Immediate_Mode_Edit.Enabled := Run1.Enabled ;
    CPU_Status.Enabled := Run1.Enabled ;

    if( CPU <> nil ) then
    begin
        P := CPU.CPU.Memory_Space_Description( 1, Physical_Address ) ;
    end else
    begin
        P := nil ;
    end ;
    AddressSpace1.Visible := ( P <> nil ) ;
    Current_Address_Space := 0 ;
    for Loop := AddressSpace1.Count - 1 downto 0 do // Remove all address space subitmes
    begin
        AddressSpace1.Items[ Loop ].Free ;
    end ;

    // Rebuild address space subitems...
    Loop := 0 ;
    while( P <> nil ) do
    begin
        P := CPU.CPU.Memory_Space_Description( Loop, Physical_Address ) ;
        inc( Loop ) ;
        M := TMenuItem.Create( AddressSpace1 ) ;
        M.Caption := string( P ) ;
        M.OnClick := CB_Address_Space_Click ;
        M.Tag := Loop ;
        if( Loop = 0 ) then
        begin
            M.Checked := True ;
        end ;
    end ;
end ; // TMain_Form.Set_Master_CPU


function TMain_Form._Examine_Memory( Address : int64 ;
    Physical_Address : boolean ; Address_Space : integer ) : byte ;

var B : byte ;
    C : TComponent ;
    Loop : integer ;
    Low, High : int64 ;
    Size : integer ;

begin
    if( ( Master_CPU <> nil ) and not Physical_Address ) then
    begin
        Address := Master_CPU.CPU.Translate( Address_Space, Address ) ;
    end ;
    Size := 1 ;
    for Loop := 0 to Component_List.Count - 1 do
    begin
        try
            C := TComponent( Component_List.Objects[ Loop ] ) ;
            if( C.Component_Type = Component_Type_Memory ) then
            begin
                C.Memory.Get_Address_Range( Low, High ) ;
                if( ( Address >= Low ) and ( Address <= High ) ) then
                begin
                    C.Examine( Address, Size, @B, True ) ;
                    Result := B ;
                    exit ;
                end ;
            end ;
        except
        end ;
    end ;
    Main_Memory.Examine( Address, Size, @B, True ) ;
    Result := B ;
end ;


procedure TMain_Form.Dump1Click( Sender : TObject ) ;

var Address : int64 ;
    C : TComponent ;
    File_Name : string ;
    Size : int64 ;

    procedure _Dump_Image ;

    var Buffer : pointer ;
        Dummy : integer ;
        F : file ;

    begin
        Buffer := allocmem( Size ) ;
        try
            C.Memory.Dump( Address, Size, Buffer ) ;
            assignfile( F, File_Name ) ;
            {$I-}
            rewrite( F, 1 ) ;
            {$I+}
            Dummy := IOResult ;
            if( Dummy <> 0 ) then
            begin
                ShowMessage( ERT( Dummy ) ) ;
                exit ;
            end ;
            try
                {$I-}
                blockwrite( F, Buffer^, Size ) ;
                {$I+}
                Dummy := IOResult ;
                if( Dummy <> 0 ) then
                begin
                    ShowMessage( ERT( Dummy ) ) ;
                end ;
            finally
                {$I-}
                closefile( F ) ;
                {$I+}
                IOResult ; // Ignore close errors
            end ;
        finally
            freemem( Buffer ) ;
        end ;
    end ;


    procedure _Dump_Ent ;

    var Dummy : integer ;
        F : textfile ;
        Item : integer ;
        S : string ;

    begin
        assignfile( F, File_Name ) ;
        {$I-}
        rewrite( F ) ;
        {$I+}
        Dummy := IOResult ;
        if( Dummy <> 0 ) then
        begin
            ShowMessage( ERT( Dummy ) ) ;
            exit ;
        end ;
        try
            // Write the entry point...
            {$I-}
            writeln( F, 'EN ', CVTB( Dump_Memory_Form.Base, 16, Dump_Memory_Form.Starting_Address.Text ) ) ;
            {$I+}
            if( Dummy <> 0 ) then
            begin
                ShowMessage( ERT( Dummy ) ) ;
                exit ;
            end ;

            // Start first line...
            S := CVTB( 10, 16, inttostr( Address ) ) ;
            while( length( S ) < 4 ) do
            begin
               S := '0' + S ;
            end ;
            {$I-}
            write( F, S, ':' ) ;
            {$I+}
            Dummy := IOResult ;
            if( Dummy <> 0 ) then
            begin
                ShowMessage( ERT( Dummy ) ) ;
                exit ;
            end ;

            // Write the data...
            Item := 1 ;
            while( Size > 0 ) do
            begin
                S := CVTB( 10, 16, inttostr( Examine_Memory( Address ) ) ) ;
                if( length( S ) = 1 ) then
                begin
                    S := '0' + S ;
                end ;
                {$I-}
                write( F, ' ', S ) ;
                {$I+}
                Dummy := IOResult ;
                if( Dummy <> 0 ) then
                begin
                    ShowMessage( ERT( Dummy ) ) ;
                    exit ;
                end ;
                Address := Address + 1 ;
                Size := Size - 1 ;
                inc( Item ) ;
                if( ( Item > 16 ) and ( Size > 0 ) ) then
                begin
                    Item := 1 ;
                    {$I-}
                    writeln( F ) ;
                    {$I+}
                    Dummy := IOResult ;
                    if( Dummy <> 0 ) then
                    begin
                        ShowMessage( ERT( Dummy ) ) ;
                        exit ;
                    end ;
                    S := CVTB( 10, 16, inttostr( Address ) ) ;
                    while( length( S ) < 4 ) do
                    begin
                       S := '0' + S ;
                    end ;
                    {$I-}
                    write( F, S, ':' ) ;
                    {$I+}
                    Dummy := IOResult ;
                    if( Dummy <> 0 ) then
                    begin
                        ShowMessage( ERT( Dummy ) ) ;
                        exit ;
                    end ;
                end ;
            end ;

            // End the file...
            {$I-}
            writeln( F, '/' ) ;
            {$I+}
            Dummy := IOResult ;
            if( Dummy <> 0 ) then
            begin
                ShowMessage( ERT( Dummy ) ) ;
                exit ;
            end ;
        finally
            {$I-}
            closefile( F ) ;
            {$I+}
            IOResult ; // Ignore close errors
        end ;
    end ;


var Dummy : integer ;

begin
    C := TComponent( TMenuItem( Sender ).Tag ) ;
    if( ( AD.Base > 1 ) and ( AD.Base < 50 ) ) then
    begin
        Dump_Memory_Form.Base := AD.Base ;
    end else
    begin
        Dump_Memory_Form.Base := 10 ;
    end ;
    if( Dump_Memory_Form.ShowModal = mrOK ) then
    begin
        File_Name := Dump_Memory_Form.File_Name.Text ;
        Dummy := Extension_Pos( File_Name ) ;
        if( Dummy = 0 ) then
        begin
            Dummy := length( File_Name ) + 1 ;
        end ;
        Address := strtoint( CVTB( Dump_Memory_Form.Base, 10, uppercase( Dump_Memory_Form.Starting_Address.Text ) ) ) ;
        Size := strtoint( Dump_Memory_Form.Size.Text ) ;
        if( uppercase( copy( File_Name, Dummy + 1, 4 ) ) = 'ENT' ) then
        begin
            _Dump_Ent ;
        end else
        begin
            _Dump_Image ;
        end ;
    end ;
end ;


procedure TMain_Form.LoadMem1Click( Sender : TObject ) ;

var Buffer : PChar ;
    C : TComponent ;
    Dummy : integer ;
    F : file ;
    F1 : textfile ;
    File_Name : string ;


    procedure _Load_Image ;

    begin
        Buffer := Allocmem( filesize( F ) ) ;
        try
            {$I-}
            blockread( F, Buffer[ 0 ], filesize( F ) ) ;
            {$I+}
            Dummy := IOResult ;
            if( Dummy <> 0 ) then
            begin
                ShowMessage( ERT( Dummy ) ) ;
                exit ;
            end ;
            C.Memory.Load( strtoint( CVTB( Load_Memory_Form.Base, 10, Load_Memory_Form.Starting_Address.Text ) ), filesize( F ), Buffer ) ;
        finally
            freemem( Buffer ) ;
        end ;
    end ;


    procedure _Load_Ent ;

    var Address : int64 ;
        Dummy : integer ;
        Entry_Point : int64 ;
        S, S1 : string ;
        Value : int64 ;
        
    begin
        if( Master_CPU <> nil ) then
        begin
            Entry_Point := Master_CPU.CPU.Get_Current_Address( 0, True ) ;
        end ;
        assignfile( F1, File_Name ) ;
        {$I-}
        reset( F1 ) ;
        {$I+}
        Dummy := IOResult ;
        if( Dummy <> 0 ) then
        begin
            ShowMessage( ERT( Dummy ) ) ;
            exit ;
        end ;
        try
            // Read entry point...
            {$I-}
            readln( F1, S ) ;
            {$I+}
            Dummy := IOResult ;
            if( Dummy <> 0 ) then
            begin
                ShowMessage( ERT( Dummy ) ) ;
                exit ;
            end ;
            S := Edit( S, 8 or 16 or 32 or 128 ) ;
            if( copy( S, 1, 2 ) = 'EN' ) then
            begin
                S := copy( S, 3, length( S ) ) ;
                S := Edit( S, 8 ) ;
                if( Valid_Base( S, 16 ) ) then
                begin
                    Entry_Point := strtoint( CvtB( 16, 10, S ) ) ;
                end ;
            end ;
            Address := strtoint( CVTB( Load_Memory_Form.Base, 10, Load_Memory_Form.Starting_Address.Text ) ) ;
            while( not eof( F1 ) ) do
            begin
                {$I-}
                readln( F1, S ) ;
                {$I+}
                Dummy := IOResult ;
                if( Dummy <> 0 ) then
                begin
                    ShowMessage( ERT( Dummy ) ) ;
                    exit ;
                end ;
                Dummy := pos( ':', S ) ;
                S := copy( S, Dummy + 1, length( S ) ) ;
                S := Edit( S, 8 or 16 or 32 or 128 ) ;
                while( length( S ) > 0 ) do
                begin
                    Dummy := pos( ' ', S + ' ' ) ;
                    S1 := copy( S, 1, Dummy - 1 ) ;
                    S := copy( S, Dummy + 1, length( S ) ) ;
                    S := Edit( S, 8 ) ;
                    if( copy( S1, length( S1 ), 1 ) = '/' ) then // End of data
                    begin
                        S1 := copy( S1, 1, length( S1 ) - 1 ) ;
                        if( not Valid_Base( S1, 16 ) ) then
                        begin
                            ShowMessage( 'File contains invalid hexadecimal value(s)' ) ;
                            exit ;
                        end ;
                        Value := strtoint( CVTB( 16, 10, S1 ) ) ;
                        C.Deposit( Address, ( length( S1 ) + 1 ) div 2, @Value, True ) ;
                        break ;
                    end else
                    begin
                        Value := strtoint( CVTB( 16, 10, S1 ) ) ;
                        if( not Valid_Base( S1, 16 ) ) then
                        begin
                            ShowMessage( 'File contains invalid hexadecimal value(s)' ) ;
                            exit ;
                        end ;
                        C.Deposit( Address, ( length( S1 ) + 1 ) div 2, @Value, True ) ;
                        Address := Address + ( ( length( S1 ) + 1 ) div 2 ) ;
                    end ;
                end ;
            end ;
        finally
            closefile( F1 ) ;
        end ;
        if( Master_CPU <> nil ) then
        begin
            Master_CPU.CPU.Set_Current_Address( 0, True, Entry_Point ) ;
        end ;
    end ; // _Load_Ent

var Saved : integer ;

begin
    C := TComponent( TMenuItem( Sender ).Tag ) ;
    if( ( AD.Base > 1 ) and ( AD.Base < 50 ) ) then
    begin
        Load_Memory_Form.Base := AD.Base ;
    end else
    begin
        Load_Memory_Form.Base := 10 ;
    end ;
    if( Load_Memory_Form.ShowModal = mrOK ) then
    begin
        Saved := FileMode ;
        FileMode := fmOpenRead ;
        File_Name := Load_Memory_Form.File_Name.Text ;
        try
            assignfile( F, File_Name ) ;
            {$I-}
            reset( F, 1 ) ;
            {$I+}
            Dummy := IOResult ;
            if( Dummy <> 0 ) then
            begin
                ShowMessage( ERT( Dummy ) ) ;
                exit ;
            end ;
            Dummy := Extension_Pos( File_Name ) ;
            if( Dummy = 0 ) then
            begin
                Dummy := length( File_Name ) + 1 ;
            end ;
            try
                if( uppercase( copy( File_Name, Dummy + 1, 4 ) ) = 'ENT' ) then
                begin
                    _Load_Ent ;
                end else
                begin
                    _Load_Image ;
                end ;
            finally
                {$I-}
                closefile( F ) ;
                {$I+}
                IOResult ;
            end ;
        finally
            FileMode := Saved ;
        end ;
        Disassembly_Top := -1 ;
        Stack_Top := -1 ;
        Update_Disassembly ;
    end ; // if( Load_Memory_Form.ShowModal = mrOK )
end ; // TMain_Form.LoadMem1Click


procedure TMain_Form.Remove_Component( Index : integer ; _Free : boolean ) ;

    procedure Disconnect( C : TComponent ) ;

    var Loop : integer ;
        This_Component : TComponent ;

    begin
        for Loop := 0 to Component_List.Count - 1 do
        begin
            This_Component := TComponent( Component_List.Objects[ Loop ] ) ;
            This_Component.Disconnect_Input( C ) ;
            This_Component.Disconnect_Output( C ) ;
            C.Disconnect_Input( This_Component ) ;
            C.Disconnect_Output( This_Component ) ;
        end ;
    end ;

var C : TComponent ;
    Info : TComponent_Info ;
    Loop : integer ;

begin
    // Setup...
    C := TComponent( Component_List.Objects[ Index ] ) ;
    if( C = Main_Memory ) then
    begin
        exit ; // Cannot remove default memory
    end ;

    // Remove from notice list
    UI.Want_Signals( C, False ) ;

    // Find corresponding menu and remove it
    for Loop := 0 to Components1.Count - 1 do
    begin
        if( TComponent( Components1.Items[ Loop ].Tag ) = C ) then
        begin
            Components1.Items[ Loop ].Free ;
            break ;
        end ;
    end ;

    // If unloading a CPU, choose another master CPU...
    if( C = Master_CPU ) then
    begin
        Set_Master_CPU( nil ) ;
        Register_Watchpoints.Clear ;
        Register_Watchpoint_Access.Clear ;
        Execution_Watchpoints.Clear ;
        Port_Watchpoints.Clear ;
        Port_Watchpoints_Access.Clear ;
    end ;
    if( C.Component_Type = Component_Type_CPU ) then
    begin
        for Loop := 0 to Component_List.Count - 1 do
        begin
            if( Loop <> Index ) then
            begin
                if( TComponent( Component_List.Objects[ Loop ] ).Component_Type = Component_Type_CPU ) then
                begin
                    Set_Master_CPU( TComponent( Component_List.Objects[ Loop ] ) ) ;
                    break ;
                end ;
            end ;
        end ;
        Update_Disassembly ;
        Update_CPU_State ;
        Update_Stack ;
        Update_Watches ;
    end ;

    // Disconnect this component from all others and remove menu...
    Info := TComponent_Info( C.Tag ) ;
    Disconnect( C ) ;

    // Finally, remove it from the component list and free it...
    Component_List.Objects[ Index ] := nil ;
    Component_List.Delete( Index ) ;
    if( _Free ) then
    begin
        C.Terminate ;
        FreeLibrary( Info.DLL_Handle ) ; // Unload DLL
    end ;
    Info.Free ;

    Paint_Panel.Invalidate ;
    Update_Disassembly ;
    Update_Stack ;
end ; // TMain_Form.Remove_Component


procedure TMain_Form.Update_CPU_State ;

var Index : integer ;
    P : pointer ;
    PC : PChar ;
    S, S1 : string ;
    Size : integer ;
    Value : int64 ;

begin
    CPU_Status.Clear ;
    if( Master_CPU = nil ) then
    begin
        CPU_Caption.Caption := '' ;
    end else
    begin
        // Do caption...
        Index := Component_List.IndexOfObject( Master_CPU ) ;
        S := Component_List[ Index ] ;
        if( Master_CPU.CPU.Halted ) then
        begin
            S := S + '  (halted)' ;
        end ;
        CPU_Caption.Caption := S ;

        // Do registers...
        Index := 0 ;
        while( True ) do
        begin
            Size := Master_CPU.CPU.Register_Size( Index ) ;
            if( Size = 0 ) then
            begin
                break ;
            end ;
            S := Master_CPU.CPU.Register_Name( Index ) + ' ' ;
            while( length( S ) < 6 ) do
            begin
                S := S + ' ' ;
            end ;
            Value := 0 ;
            P := @Value ;
            Master_CPU.Examine( Index, Size, P, False ) ;
            S1 := CVTB( 10, Master_CPU.CPU.Default_Base, inttostr( Value ) ) ;
            S1 := Number_Format( Master_CPU.CPU.Default_Base, Size, S1 ) ;
            S := S + S1 ;
            PC := Master_CPU.CPU.Register_Description( Index ) ;
            if( PC <> nil ) then
            begin
                S := S + '    ' + string( PC ) ;
            end ;
            CPU_Status.Items.Add( S ) ;
            inc( Index ) ;
        end ; // while( True )
    end ; // if( Master_CPU = nil )
end ; // TMain_Form.Update_CPU_State


procedure TMain_Form.Update_Watches ;

var Loop, Loop1, Index : integer ;
    I : int64 ;
    S, S1 : string ;
    Size : integer ;
    Value : record
                case integer of
                    0 : ( I : int64 ) ;
                    1 : ( B : array[ 0..sizeof( extended ) - 1 ] of byte ) ;
                    2 : ( S : single ) ;
                    3 : ( D : double ) ;
                    4 : ( E : extended ) ;
            end ;
    W : TWatch ;

begin
    Watch_List_Box.Items.Clear ;
    for Loop := 0 to Watches.Count - 1 do
    begin
        W := TWatch( Watches[ Loop ] ) ;
        S := CvtB( 10, AD.Base, Num1( W.Address ) ) + ':  ' ;
        Loop1 := 0 ;
        while( Loop1 < W.Size ) do
        begin
            Value.I := 0 ;
            Index := 0 ;
            if( W.Base = -10 ) then
            begin
                Size := sizeof( Extended ) ;
            end else
            begin
                Size := sizeof( int64 ) ;
            end ;
            while( ( Index < Size ) and ( Index + Loop1 < W.Size ) ) do
            begin
                Value.B[ Index ] := Examine_Memory( W.Address + Loop1 + Index ) ;
                inc( Index ) ;
            end ;
            case W.Base of
                0 : // ASCII
                    begin
                        setlength( S1, Index ) ;
                        move( Value.I, S1[ 1 ], Index ) ;
                        S := S + S1 ;
                    end ;
                1 : // EBCDIC
                    begin
                        setlength( S1, Index ) ;
                        move( Value.I, S1[ 1 ], Index ) ;
                        S := S + From_EBCDIC( S1 ) ;
                    end ;
                50 : // Radix-50
                    begin
                        S := S + Rad( Value.I ) ;
                    end ;
                -4 : // Single
                    begin
                        try
                            S := S + floattostr( Value.S ) ;
                        except
                            S := S + 'Invalid floating point format' ;
                        end ;
                    end ;
                -8 : // Double
                    begin
                        try
                            S := S + floattostr( Value.D ) ;
                        except
                            S := S + 'Invalid floating point format' ;
                        end ;
                    end ;
                -10 : // Extended
                    begin
                        try
                            S := S + floattostr( Value.E ) ;
                        except
                            S := S + 'Invalid floating point format' ;
                        end ;
                    end ;
                else
                    begin
                        if( W.Base = 10 ) then
                        begin
                            Index := 1 ;
                        end else
                        begin
                            case W.Size - Loop1 of
                                1 : I := 255 ;
                                2 : I := 65535 ;
                                3 : I := $FFFFFF ;
                                4 : I := $FFFFFFFF ;
                                5 : I := $FFFFFFFFFF ;
                                6 : I := $FFFFFFFFFFFF ;
                                7 : I := $FFFFFFFFFFFFFF ;
                                else I := $7FFFFFFFFFFFFFFF ;
                            end ;
                            Index := length( CvtB( 10, AD.Base, Num1( I ) ) ) ;
                        end ;
                        S1 := CvtB( 10, AD.Base, Num1( Value.I ) ) ;
                        while( length( S1 ) < Index ) do
                        begin
                            S1 := '0' + S1 ;
                        end ;
                        S := S + S1 + ' ' ;
                    end ; // else
            end ; // case W.Base
            Loop1 := Loop1 + sizeof( int64 ) ;
        end ; // while( Loop1 < W.Size )
        Watch_List_Box.Items.Add( S ) ;
    end ;
    DeleteAll1.Enabled := ( Watches.Count > 0 ) ;
    Delete1.Enabled := ( Watches.Count > 0 ) ;
    Edit1.Enabled := ( Watches.Count > 0 ) ;
end ; // TMain_Form.Update_Watches


// Callbacks...

procedure TMain_Form.CB_Address_Space_Click( Sender : TObject ) ;

begin
    Current_Address_Space := TMenuItem( Sender ).Tag ;
    Memory_Panel.Invalidate ;
end ;


procedure TMain_Form.CB_Update_Menu( Sender : TObject ) ;

begin
//    UpdateMenuItems( Application.MainForm ) ;  // copy click
end ;


procedure TMain_Form.CB_Kill( Sender : TObject )  ;

var Editor : TEditor_Window ;

begin
    Editor := TEditor_Window( Sender ) ;
    Add_To_Reopen( Editor.File_Name ) ;
    PageControl1.ActivePage.Free ;
end ;


procedure TMain_Form.CB_Idle( Sender : TObject ; var Done : boolean ) ;

begin
    if( _Hide ) then
    begin
        Hide ;
        _Hide := False ;
    end ;
    if( Start_Execution ) then
    begin
        Start_Execution := False ;
        Execute1Click( nil ) ;
    end ;
    if( Terminate_Requested ) then
    begin
        Terminate_Base_Time := GetTickCount ;
        Terminate_Requested := False ;
        Terminate_Wait := True ;
    end else
    if( Terminate_Wait ) then
    begin
        if( GetTickCount < Terminate_Base_Time ) then
        begin
            Terminate_Base_Time := GetTickCount ; // Had a time rollover
        end else
        if( Terminate_Base_Time - GetTickCount > 500 ) then
        begin
            Terminate_Wait := False ;
            if( not Startup_Command_File ) then
            begin
                UnloadAll1Click( nil ) ;
            end else
            begin
                Close ;
            end ;
        end ;
    end ;
end ;


procedure TMain_Form.CB_State_Change( Sender : TObject ) ;

var Editor : TEditor_Window ;

begin
    if( StatusBar = nil ) then
    begin
        exit ; // In setup phase
    end ;
    Editor := TEditor_Window( Sender ) ;
    if( Editor.Modified ) then
    begin
        StatusBar.Panels.Items[ 1 ].Text := 'Modified' ;
    end else
    begin
        StatusBar.Panels.Items[ 1 ].Text := '' ;
    end ;
    StatusBar.Panels.Items[ 0 ].Text := inttostr( Editor.Current_Row ) +
        ':' + inttostr( Editor.Current_Column ) ;
end ;


procedure TMain_Form.Printersetup1Click( Sender : TObject ) ;

begin
    PrinterSetupDialog1.Execute ;
end ;


procedure TMain_Form.Print1Click(Sender: TObject);

var Editor : TEditor_Window ;

begin
    Editor := TEditor_Window( PageControl1.ActivePage.Controls[ 0 ] ) ;
    Editor.Print ;
end ;


procedure TMain_Form.Close1Click(Sender: TObject);

var Editor : TEditor_Window ;

begin
    Editor := TEditor_Window( PageControl1.ActivePage.Controls[ 0 ] ) ;
    if( Editor.Modified ) then
    begin
        Save_Modified_Dialog.Label1.Caption := 'Save changes to ' + Editor.File_Name ;
        case Save_Modified_Dialog.ShowModal of
            mrCancel: exit ;
	    mrYes: Editor.Save_File ;
        end ;
    end ;
    Add_To_Reopen( Editor.File_Name ) ;
    Editor.Close ;
end ;


procedure TMain_Form.CloseAll1Click( Sender : TObject ) ;

var Editor : TEditor_Window ;
    Loop : integer ;

begin
    for Loop := 0 to PageControl1.PageCount - 1 do
    begin
        if( TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor <> nil ) then
        begin
            Editor := TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor ;
            Add_To_Reopen( Editor.File_Name ) ;
            Editor.Close ;
        end ;
    end ;
end ;


procedure TMain_Form.Reopen_File( Sender : TObject ) ;

var Menu : TMenuItem ;

begin
    Menu := TMenuItem( Sender ) ;
    if( Menu.Visible ) then
    begin
        Open_File( copy( Menu.Caption, 4, 255 ) ) ;
        exit ;
    end ;
end ;


procedure TMain_Form.Reopen_Emulator( Sender : TObject ) ;

var Menu : TMenuItem ;

begin
    Menu := TMenuItem( Sender ) ;
    if( Menu.Visible ) then
    begin
        _Hide := False ;
        Open_Emulator( copy( Menu.Caption, 4, 255 ) ) ;
        if( _Hide ) then
        begin
            Hide ;
            _Hide := False ;
        end ;
    end ;
end ;


procedure TMain_Form.Load1Click( Sender : TObject ) ;

begin
    if( Open_Component_Dialog.Execute ) then
    begin
        Load_Component( Open_Component_Dialog.Filename, '', '' ) ;
    end ; 
end ; // TMain_Form.Load1Click


procedure TMain_Form.FormCloseQuery( Sender : TObject ;
    var CanClose : Boolean ) ;

var Editor : TEditor_Window ;
    Loop : integer ;

begin
    CanClose := False ;
    for Loop := 0 to PageControl1.PageCount - 1 do
    begin
        Editor := TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor ;
        if( ( Editor <> nil ) and Editor.Modified ) then
        begin
            Save_Modified_Dialog.Label1.Caption :=
                'Save changes to ' + Editor.File_Name ;
            case Save_Modified_Dialog.ShowModal of
                mrCancel: exit ;
                mrYes: Editor.Save_File ;
            end ;
        end ;
    end ;
    CanClose := True ;
    for Loop := 0 to PageControl1.PageCount - 1 do
    begin
        Editor := TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor ;
        if( Editor <> nil ) then
        begin
            Editor.On_Kill := nil ;
        end ;
    end ;
    UnloadAll1Click( nil ) ;
end ; // TMain_Form.FormCloseQuery


procedure TMain_Form.CPU_StatusDblClick( Sender : TObject ) ;

var Dummy, Len, Size, Value : integer ;
    S : string ;

begin
    if( CPU_Status.ItemIndex <> -1 ) then
    begin
        Size := Master_CPU.CPU.Register_Size( CPU_Status.ItemIndex ) ;
        S := CPU_Status.Items[ CPU_Status.ItemIndex ] ;
        Dummy := pos( ' ', S + ' ' ) ;
        S := copy( S, 1, Dummy - 1 ) ;
        Modify_Register.Caption := 'Modify Register ' + S ;
        Modify_Register.Base := Master_CPU.CPU.Default_Base ;
        Modify_Register.Size := Size ;
        Value := 0 ;
        Len := Size ;
        Master_CPU.Examine( CPU_Status.ItemIndex, Len, @Value, False ) ;
        Modify_Register.Edit1.Text := CVTB( 10, Master_CPU.CPU.Default_Base, inttostr( Value ) ) ;
        Modify_Register.OK_Button.Enabled := True ;
        Modify_Register.Value := Value ;
        if( Modify_Register.ShowModal = mrOK ) then
        begin
            Master_CPU.Deposit( CPU_Status.ItemIndex, Size, @Modify_Register.Value, False ) ;
            Update_CPU_State ;
        end ;
    end ;
end ;


procedure TMain_Form.Modify1Click( Sender : TObject ) ;

var Address : int64 ;
    Base : integer ;
    Data, Work : string ;
    Dummy : integer ;
    V : int64 ;

begin
    Modify_Memory_Dialog.Data.Text :=
        CVTB( 10, AD.Base, inttostr( AI.Get_Byte( Modify_Memory_Dialog.Address_Value ) ) ) ;
    Modify_Memory_Dialog.Base := AD.Base ;
    Modify_Memory_Dialog.OK_Button.Enabled := True ;
    if( Modify_Memory_Dialog.ShowModal = mrOK ) then
    begin
        Address := Modify_Memory_Dialog.Address_Value ;
        Data := Modify_Memory_Dialog.Data.Text ;
        if( Modify_Memory_Dialog.Literal_Text.Checked ) then
        begin
            for Dummy := 1 to length( Data ) do
            begin
                AI.Set_Byte( Address + Dummy - 1, ord( Data[ Dummy ] ) ) ;
            end ;
        end else
        begin
            while( length( Data ) > 0 ) do
            begin
                Dummy := pos( ' ', Data + ' ' ) ;
                Work := copy( Data, 1, Dummy - 1 ) ;
                Data := copy( Data, Dummy + 1, length( Work ) ) ;
                Base := AD.Base ;
                Translate_Value( Work, 0, Base, V ) ;
                AI.Set_Byte( Address, V and $FF ) ;
                V := V shr 8 ;
                while( V <> 0 ) do
                begin
                    inc( Address ) ;
                    AI.Set_Byte( Address, V and $FF ) ;
                    V := V shr 8 ;
                end ;
            end ;
        end ;
        Paint_Panel.Invalidate ;
        Update_Disassembly ;
        Update_Stack ;
    end ;
end ; // TMain_Form.Modify1Click


procedure TMain_Form.Createnew1Click( Sender : TObject ) ;

var C : TComponent ;
    Loop : integer ;
    Low, High : int64 ;

begin
    for Loop := 0 to Component_List.Count - 1 do
    begin
        C := TComponent( Component_List.Objects[ Loop ] ) ;
        if( C.Component_Type = Component_Type_Memory ) then
        begin
            C.Memory.Get_Address_Range( Low, High ) ;
            if( ( AD.Base >= Low ) and ( AD.Base <= High ) ) then
            begin
                New_Watchpoint.High := High_Address ;
                Add_Watchpoint( C, Watchpoints, Watchpoint_Size,
                    Watchpoint_Access, AD.Base, AD.Number_Size, True ) ;
                exit ;
            end ;
        end ;
    end ;
end ;


procedure TMain_Form.View1Click( Sender : TObject ) ;

begin
    Memory_Watchpoints_Dialog.CPU := nil ;
    Memory_Watchpoints_Dialog.Set_Data( Watchpoints, Watchpoint_Size,
        Watchpoint_Access, False ) ;
    Memory_Watchpoints_Dialog.ShowModal ;
end ;


procedure TMain_Form.Execute1Click(Sender: TObject);

begin
    if( In_Assembly or In_Execution ) then
    begin
        exit ;
    end ;
    StatusBar.Panels.Items[ 2 ].Text := 'Executing' ;
    In_Execution := True ;
    Master_CPU.CPU.Run ;
    In_Execution := False ;
    StatusBar.Panels.Items[ 2 ].Text := 'Stopped' ;
    Update_CPU_State ;
    Update_Watches ;
    Disassembly_Top := -1 ;
    Stack_Top := -1 ;
    Update_Disassembly ;
    Update_Stack ;
    Map_Source( False ) ;
    Paint_Panel.Invalidate ;
end ;


procedure TMain_Form.StepOver1Click(Sender: TObject);

begin
    if( In_Assembly or In_Execution ) then
    begin
        exit ;
    end ;
    StatusBar.Panels.Items[ 2 ].Text := 'Executing' ;
    In_Execution := True ;
    Master_CPU.CPU.Step( False ) ;
    In_Execution := False ;
    StatusBar.Panels.Items[ 2 ].Text := 'Stopped' ;
    Update_CPU_State ;
    Update_Watches ;
    Disassembly_Top := -1 ;
    Stack_Top := -1 ;
    Update_Disassembly ;
    Update_Stack ;
    Map_Source( False ) ;
    Paint_Panel.Invalidate ;
end ;


procedure TMain_Form.StepInto1Click(Sender: TObject);

begin
    if( In_Assembly or In_Execution ) then
    begin
        exit ;
    end ;
    StatusBar.Panels.Items[ 2 ].Text := 'Executing' ;
    In_Execution := True ;
    Master_CPU.CPU.Step( True ) ;
    In_Execution := False ;
    StatusBar.Panels.Items[ 2 ].Text := 'Stopped' ;
    Update_CPU_State ;
    Update_Watches ;
    Disassembly_Top := -1 ;
    Stack_Top := -1 ;
    Update_Disassembly ;
    Update_Stack ;
    Map_Source( False ) ;
    Paint_Panel.Invalidate ;
end ;


procedure TMain_Form.Runimmediate1Click( Sender : TObject ) ;

var B : byte ;
    In_Streamer, Out_Streamer : TLine_Streamer ;
    Loop : integer ;
    Old : int64 ;
    S : string ;
    Size : integer ;
    Status : TCEF_Assembler_Status ;

begin
    if( In_Assembly or In_Execution ) then
    begin
        exit ;
    end ;
    S := Immediate_Mode_Edit.Text ;
    if( Master_Assembler = nil ) then
    begin
        Master_Assembler := TCEF_Assembler.Create( Master_CPU, UI ) ;
    end ;
    In_Streamer := TLine_Streamer.Create ;
    Out_Streamer := TLine_Streamer.Create ;
    Status := TCEF_Assembler_Status.Create ;
    TCEF_Assembler_Status( Status ).In_Streamer := In_Streamer ;
    In_Streamer.Write( S[ 1 ], length( S ) ) ;
    In_Streamer.Seek( 0 ) ;
    Master_Assembler.Assemble( In_Streamer, Out_Streamer, nil, Status ) ;
    if( Status.Errors > 0 ) then
    begin
        ShowMessage( Status.Get_Error_Text ) ;
        In_Streamer.Free ;
        Out_Streamer.Free ;
        Status.Free ;
        exit ;
    end ;
    Old := Master_CPU.CPU.Get_Current_Address( 0, True ) ;
    Out_Streamer.Seek( 0 ) ;
    if( Status.Data > 0 ) then
    begin
        for Loop := 0 to Out_Streamer.Size - 1 do
        begin
            Size := 1 ;
            Out_Streamer.Read( B, Size ) ;
            Deposit_Memory( Old, B ) ;
            inc( Old ) ;
        end ;
    end else
    if( Out_Streamer.Size > 0 ) then // Have code to execute
    begin
        StatusBar.Panels.Items[ 2 ].Text := 'Executing' ;
        In_Execution := True ;
        Master_CPU.CPU.Run_From_Stream( Out_Streamer ) ;
        In_Execution := False ;
        StatusBar.Panels.Items[ 2 ].Text := 'Stopped' ;
    end ;
    In_Streamer.Free ;
    Out_Streamer.Free ;
    Status.Free ;
    Paint_Panel.Invalidate ;
    if( Old <> Master_CPU.CPU.Get_Current_Address( 0, True ) ) then // Position changed by user
    begin
        Disassembly_Top := -1 ;
    end ;
    Stack_Top := -1 ;
    Update_Disassembly ;
    Update_Stack ;
    Update_CPU_State ;
    Update_Watches ;
    Map_Source( False ) ;
end ; // TMain_Form.Runimmediate1Click


procedure TMain_Form.UnloadAll1Click( Sender : TObject ) ;

var Loop : integer ;

begin
    Pause1Click( nil ) ; // Terminate execution
    if( In_Assembly or In_Execution ) then
    begin
        exit ;
    end ;
    for Loop := Component_List.Count - 1 downto 0 do
    begin
        Remove_Component( Loop, True ) ;
    end ;
    Low_Physical_Address := 0 ;
    High_Physical_Address := $7FFFFFFFFFFFFFFF ; // Default high address
    Physical_Address := True ;
    Caption := 'CEF32' ;
end ;


procedure TMain_Form.Write_Memory( Address : int64 ; Value : byte ) ;

var C : TComponent ;
    Loop : integer ;
    Low, High : int64 ;
    UEC : TUEC ;

begin
    for Loop := 0 to Component_List.Count - 1 do
    begin
        C := TComponent( Component_List.Objects[ Loop ] ) ;
        if( C.Component_Type = Component_Type_Memory ) then
        begin
            C.Memory.Get_Address_Range( Low, High ) ;
            if( ( Address >= Low ) and ( Address <= High ) ) then
            begin
                UEC := C.Write( Address, Value, 1, IO_Type_Memory ) ;
            end ;
        end ;
    end ;
    if( Main_Memory <> nil ) then
    begin
        UEC := Main_Memory.Write( Address, Value, 1, IO_Type_Memory ) ;
    end ;
    if( In_Assembly and ( not Write_Errors ) ) then
    begin
        if( Examine_Memory( Address ) <> Value ) then
        begin
            Write_Errors := True ;
            Status.Log_Error( 'Could not modify memory', nil, -1, Severity_Fatal ) ;
        end ;
    end ;
end ; // TMain_Form.Write_Memory


function TMain_Form.Deposit_Memory( Address : int64 ; Value : byte ) : TUEC ;

var C : TComponent ;
    Loop : integer ;
    Low, High : int64 ;

begin
    if( ( Master_CPU <> nil ) and not Physical_Address ) then
    begin
        Address := Master_CPU.CPU.Translate( Current_Address_Space, Address ) ;
    end ;
    fillchar( Result, sizeof( Result ), 0 ) ;
    for Loop := 0 to Component_List.Count - 1 do
    begin
        C := TComponent( Component_List.Objects[ Loop ] ) ;
        if( C.Component_Type = Component_Type_Memory ) then
        begin
            C.Memory.Get_Address_Range( Low, High ) ;
            if( ( Address >= Low ) and ( Address <= High ) ) then
            begin
                Result := C.Deposit( Address, 1, @Value, True ) ;
                if( Result.Code <> 0 ) then
                begin
                    exit ;
                end ;
            end ;
        end ;
    end ;
    if( Main_Memory <> nil ) then
    begin
        Result := Main_Memory.Deposit( Address, 1, @Value, True ) ;
    end ;
end ;


function TMain_Form.Examine_Memory( Address : int64 ) : byte ;

begin
    Result := _Examine_Memory( Address, Physical_Address, Current_Address_Space ) ;
end ;


procedure TMain_Form.Show_Error( Sender : TListBox ) ;

var Editor : TEditor_Window ;
    Filename : string ;
    Index, Line, Loop : longint ;

begin
    Index := Sender.ItemIndex ;
    Filename := Error_Dialog.Filenames[ Index ] ;
    Line := Error_Dialog.Lines[ Index ] ;
    for Loop := 0 to PageControl1.PageCount - 1 do
    begin
        if( TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor <> nil ) then
        begin
            Editor := TCEF_TabSheet( PageControl1.Pages[ Loop ] ).Editor ;
            if( Editor.File_Name = Filename ) then
            begin
                Editor.Select_Line( Line ) ;
                exit ;
            end ;
        end ;
    end ;
end ;


function TMain_Form.Menu_For_Component( Component : TComponent ) : TMenuItem ;

var Loop : integer ;
    M : TMenuItem ;

begin
    Result := nil ; // Assume failure
    for Loop := 0 to Components1.Count - 1 do
    begin
        M := Components1[ Loop ] ;
        if( M.Tag = integer( Component ) ) then
        begin
            Result := M ;
            exit ;
        end ;
    end ;
end ;


procedure TMain_Form.ScrollBar1Scroll( Sender : TObject ;
    ScrollCode : TScrollCode ; var ScrollPos : Integer ) ;

var R : double ;

begin
    if( High_Address = 0 ) then // Memory bounds not set
    begin
        ScrollPos := 0 ;
        exit ;
    end ;
    case ScrollCode of
        scLineUp :
            begin
                if( Disassembly_Top <= Low_Address ) then
                begin
                    exit ;
                end ;
                dec( Disassembly_Top ) ;
            end ;
        scLineDown :
            begin
                Disassembly_Top := Disassembly_Second ;
            end ;
        scPageUp :
            begin
                if( Disassembly_Top <= Low_Address ) then
                begin
                    exit ;
                end ;
                Disassembly_Top :=
                    Disassembly_Top - ( Disassembly_List_Box.ClientHeight div Disassembly_List_Box.ItemHeight ) ;
                if( Disassembly_Top <= Low_Address ) then
                begin
                    Disassembly_Top := Low_Address ;
                end ;
                R := Disassembly_Top - Low_Address ;
                if( High_Address = Low_Address ) then
                begin
                    R := 0 ;
                end else
                begin
                    R := R / ( High_Address - Low_Address ) ;
                end ;
                R := int( R * 10000 ) ;
                ScrollPos := trunc( R ) ;
            end ;
        scPageDown :
            begin
                if( Disassembly_Next >= High_Address ) then
                begin
                    exit ;
                end ;
                Disassembly_Top := Disassembly_Next ;
            end ;
        scPosition :
            begin
                R := ScrollPos ;
                R := R / 10000.0 ;
                R := R * ( High_Address - Low_Address ) ;
                R := int( R + Low_Address ) ;
                Disassembly_Top := trunc( R ) ;
            end ;
        scTop :
            begin
                Disassembly_Top := Low_Address ;
            end ;
        scBottom :
            begin
                Disassembly_Top := High_Address ;
            end ;
        else exit ;
    end ;
    Update_Disassembly ;
end ; // TMain_Form.ScrollBar1Scroll


procedure TMain_Form.Disassembly_List_BoxKeyDown(Sender: TObject;
    var Key: Word; Shift: TShiftState) ;

var ScrollPos : Integer ;

begin
    case Key of
        VK_UP :
            begin
                if( ssCtrl in Shift ) then
                begin
                    exit ;
                end ;
                if( Disassembly_List_Box.ItemIndex = 0 ) then
                begin
                    ScrollBar1Scroll( ScrollBar1, scLineUp, ScrollPos ) ;
                end ;
            end ;
        VK_DOWN :
            begin
                if( ssCtrl in Shift ) then
                begin
                    exit ;
                end ;
                if( Disassembly_List_Box.ItemIndex = Disassembly_List_Box.ClientHeight div Disassembly_List_Box.ItemHeight - 1 ) then
                begin
                    ScrollBar1Scroll( ScrollBar1, scLineDown, ScrollPos ) ;
                end ;
            end ;
        VK_NEXT :
            begin
                Key := 0 ;
                if( ssCtrl in Shift ) then
                begin
                    ScrollBar1Scroll( ScrollBar1, scBottom, ScrollPos ) ;
                    exit ;
                end ;
                ScrollBar1Scroll( ScrollBar1, scPageDown, ScrollPos ) ;
            end ;
        VK_PRIOR :
            begin
                Key := 0 ;
                if( ssCtrl in Shift ) then
                begin
                    ScrollBar1Scroll( ScrollBar1, scTop, ScrollPos ) ;
                    exit ;
                end ;
                ScrollBar1Scroll( ScrollBar1, scPageUp, ScrollPos ) ;
            end ;
        VK_HOME :
            begin
                if( ssCtrl in Shift ) then
                begin
                    Key := 0 ;
                    ScrollBar1Scroll( ScrollBar1, scTop, ScrollPos ) ;
                end ;
            end ;
        VK_END :
            begin
                if( ssCtrl in Shift ) then
                begin
                    Key := 0 ;
                    ScrollBar1Scroll( ScrollBar1, scBottom, ScrollPos ) ;
                end ;
            end ;
    end ;
end ;


procedure TMain_Form.Immediate_Mode_PanelResize( Sender : TObject ) ;

begin
    Immediate_Mode_Edit.Width :=
        Immediate_Mode_Panel.Width - Immediate_Mode_Edit.Left ;
end ;


procedure TMain_Form.Immediate_Mode_EditKeyDown(Sender: TObject;
    var Key: Word; Shift: TShiftState);

begin
    if( Key = VK_RETURN ) then
    begin
        Key := 0 ;
        Runimmediate1Click( nil ) ;
        Immediate_Mode_Edit.Text := '' ;
    end ;
end ;


procedure TMain_Form.Pause1Click( Sender : TObject ) ;

begin
    if( Master_CPU <> nil ) then
    begin
        Master_CPU.CPU.Stop ;
    end ;
end ;


procedure TMain_Form.Increment1Click( Sender : TObject ) ;

var Index, Size : integer ;
    P : pointer ;
    Value : int64 ;

begin
    Index := CPU_Status.ItemIndex ;
    if( Index <> -1 ) then
    begin
        Size := Master_CPU.CPU.Register_Size( Index ) ;
        Value := 0 ;
        P := @Value ;
        Master_CPU.Examine( Index, Size, P, False ) ;
        inc( Value ) ;
        Master_CPU.Deposit( Index, Size, P, False ) ;
        Update_CPU_State ;
        CPU_Status.ItemIndex := Index ;
    end ;
end ;


procedure TMain_Form.Decrement1Click( Sender : TObject ) ;

var Index, Size : integer ;
    P : pointer ;
    Value : int64 ;

begin
    Index := CPU_Status.ItemIndex ;
    if( Index <> -1 ) then
    begin
        Size := Master_CPU.CPU.Register_Size( Index ) ;
        Value := 0 ;
        P := @Value ;
        Master_CPU.Examine( Index, Size, P, False ) ;
        dec( Value ) ;
        Master_CPU.Deposit( Index, Size, P, False ) ;
        Update_CPU_State ;
        CPU_Status.ItemIndex := Index ;
    end ;
end ;


procedure TMain_Form.Change1Click( Sender : TObject ) ;

var Dlg : TGenNum_Form ;
    Dummy, Index : integer ;
    P : pointer ;
    S : string ;
    Size : integer ;
    Value : int64 ;

begin
    Index := CPU_Status.ItemIndex ;
    if( Index <> -1 ) then
    begin
        Dlg := TGenNum_Form.Create( self ) ;
        Dlg.Base := Master_CPU.CPU.Default_Base ;
        Size := Master_CPU.CPU.Register_Size( Index ) div 8 ;
        Dlg.Max_Size := Size ;
        case Size of
            1 : begin
                    Dlg.Maximum := 255 ;
                    Dlg.Minimum := -128 ;
                end ;
            2 : begin
                    Dlg.Maximum := 65535 ;
                    Dlg.Minimum := -32768 ;
                end ;
            3 : begin
                    Dlg.Maximum := $FFFFFF ;
                    Dlg.Minimum := -($1000000) ;
                end ;
            4 : begin
                    Dlg.Maximum := $FFFFFFFF ;
                    Dlg.Minimum := -($100000000) ;
                end ;
            5 : begin
                    Dlg.Maximum := $FFFFFFFFFF ;
                    Dlg.Minimum := -($10000000000) ;
                end ;
            6 : begin
                    Dlg.Maximum := $FFFFFFFFFFFF ;
                    Dlg.Minimum := -($1000000000000) ;
                end ;
            7 : begin
                    Dlg.Maximum := $FFFFFFFFFFFFFF ;
                    Dlg.Minimum := -($100000000000000) ;
                end ;
            8 : begin
                    Dlg.Maximum := $7FFFFFFFFFFFFFFF ;
                    Dlg.Minimum := -Dlg.Maximum - 1 ;
                end ;
        end ;
        S := Edit( CPU_Status.Items[ Index ], 128 ) ;
        Dummy := pos( ' ', S ) ;
        if( Dummy > 0 ) then
        begin
            S := Edit( copy( S, Dummy, length( S ) ), 8 ) ;
        end ;
        Dlg.Value_Edit.Text := S ;
        if( Dlg.ShowModal = mrOK ) then
        begin
            Value := Dlg.Value ;
            P := @Value ;
            Master_CPU.Deposit( Index, Size * 8, P, False ) ;
            Update_CPU_State ;
        end ;
    end ;
end ; // TMain_Form.Change1Click



procedure TMain_Form.CPU_StatusMouseUp( Sender : TObject ;
    Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer ) ;

var Index : integer ;

begin
    if( Button = mbRight ) then
    begin
        Index := CPU_Status.ItemAtPos( Point( X, Y ), True ) ;
        if( Index <> -1 ) then
        begin
            CPU_Status.ItemIndex := Index ;
        end ;
        CPU_PopupMenu.Popup( Mouse.CursorPos.X, Mouse.CursorPos.Y ) ;
    end ;
end ;


procedure TMain_Form.Zero1Click( Sender : TObject ) ;

var Index, Size : integer ;
    P : pointer ;
    Value : int64 ;

begin
    Index := CPU_Status.ItemIndex ;
    if( Index <> -1 ) then
    begin
        Size := Master_CPU.CPU.Register_Size( Index ) ;
        Value := 0 ;
        P := @Value ;
        Master_CPU.Deposit( Index, Size, P, False ) ;
        Update_CPU_State ;
        CPU_Status.ItemIndex := Index ;
    end ;
end ;


procedure TMain_Form.PageControl1Change( Sender : TObject ) ;

var T : TCEF_TabSheet ;
    V : boolean ;

begin
    T := TCEF_TabSheet( PageControl1.ActivePage ) ;
    V := ( T.Editor <> nil ) ;
    Assemble2.Enabled := V ;
    Tabsheet1.Editor.Edit1.Enabled := V ;
end ;


procedure TMain_Form.AddWatch1Click( Sender : TObject ) ;

var P : TWatch ;

begin
    if( New_Watch_Dialog = nil ) then
    begin
        New_Watch_Dialog := TNew_Watch_Dialog.Create( self ) ;
    end ;
    if( Physical_Address ) then
    begin
        New_Watch_Dialog.Minimum := Low_Physical_Address ;
        New_Watch_Dialog.Maximum := High_Physical_Address ;
    end else
    begin
        New_Watch_Dialog.Minimum := Low_Address ;
        New_Watch_Dialog.Maximum := High_Address ;
    end ;
    New_Watch_Dialog.Base := AD.Base ;
    New_Watch_Dialog._Assembler := TComponent_Info( Master_CPU.Tag ).Assembler_Context ;

    if( New_Watch_Dialog.ShowModal = mrOK ) then
    begin
        P := TWatch.Create ;
        P.Address := New_Watch_Dialog.Value ;
        P.Size := New_Watch_Dialog.Size.Value ;
        if( New_Watch_Dialog.Binary_RB.Checked ) then
        begin
            P.Base := 2 ;
        end else
        if( New_Watch_Dialog.Octal_RB.Checked ) then
        begin
            P.Base := 8 ;
        end else
        if( New_Watch_Dialog.Decimal_RB.Checked ) then
        begin
            P.Base := 10 ;
        end else
        if( New_Watch_Dialog.Hexadecimal_RB.Checked ) then
        begin
            P.Base := 16 ;
        end else
        if( New_Watch_Dialog.Other_RB.Checked ) then
        begin
            P.Base := New_Watch_Dialog.Base_Spin.Value ;
        end else
        if( New_Watch_Dialog.ASCII_RB.Checked ) then
        begin
            P.Base := 0 ;
        end else
        if( New_Watch_Dialog.EBCDIC_RB.Checked ) then
        begin
            P.Base := 1 ;
        end else
        if( New_Watch_Dialog.Radix50_RB.Checked ) then
        begin
            P.Base := 50 ;
        end else
        if( New_Watch_Dialog.Single_RB.Checked ) then
        begin
            P.Base := -4 ;
        end else
        if( New_Watch_Dialog.Double_RB.Checked ) then
        begin
            P.Base := -8 ;
        end else
        if( New_Watch_Dialog.Extended_RB.Checked ) then
        begin
            P.Base := -10 ;
        end ;
        Watches.Add( P ) ;
        Update_Watches ;
    end ;
end ;


procedure TMain_Form.AddBreakpoint1Click( Sender : TObject ) ;

begin
    if( Master_CPU <> nil ) then
    begin
        Add_Breakpoint( Master_CPU, Execution_Watchpoints, nil, AD.Base,
            AD.Number_Size, False ) ;
    end ;
end ;


procedure TMain_Form.AddRegisterBreakpoint1Click(Sender: TObject);

begin
    Add_Watchpoint( Master_CPU, Register_Watchpoints, nil,
        Register_Watchpoint_Access, AD.Base, AD.Number_Size, False ) ;
end ;


procedure TMain_Form.RegisterBreakpoints1Click( Sender : TObject ) ;

begin
    Memory_Watchpoints_Dialog.CPU := Master_CPU ;
    Memory_Watchpoints_Dialog.Set_Data( Register_Watchpoints, nil, Register_Watchpoint_Access, False ) ;
    Memory_Watchpoints_Dialog.ShowModal ;
end ;


procedure TMain_Form.Edit1Click(Sender: TObject);

var P : TWatch ;

begin
    if( New_Watch_Dialog = nil ) then
    begin
        New_Watch_Dialog := TNew_Watch_Dialog.Create( self ) ;
    end ;
    P := TWatch( Watches[ Watch_List_Box.ItemIndex ] ) ;
    New_Watch_Dialog.Size.Value := P.Size ;
    New_Watch_Dialog.Minimum := Low_Address ;
    New_Watch_Dialog.Maximum := High_Address ;
    New_Watch_Dialog.Base := P.Base ;
    New_Watch_Dialog._Assembler := TComponent_Info( Master_CPU.Tag ).Assembler_Context ;
    case P.Base of
        2 : New_Watch_Dialog.Binary_RB.Checked := True ;
        8 : New_Watch_Dialog.Octal_RB.Checked := True ;
        10 : New_Watch_Dialog.Decimal_RB.Checked := True ;
        16 : New_Watch_Dialog.Hexadecimal_RB.Checked := True ;
        0 : New_Watch_Dialog.ASCII_RB.Checked := True ;
        1 : New_Watch_Dialog.EBCDIC_RB.Checked := True ;
        50 : New_Watch_Dialog.Radix50_RB.Checked := True ;
        -4 : New_Watch_Dialog.Single_RB.Checked := True ;
        -8 : New_Watch_Dialog.Double_RB.Checked := True ;
        -10 : New_Watch_Dialog.Extended_RB.Checked := True ;
        else
            begin
                New_Watch_Dialog.Other_RB.Checked := True ;
                New_Watch_Dialog.Base_Spin.Value := P.Base ;
            end ;
    end ;
    New_Watch_Dialog.Value := P.Address ;
    if( New_Watch_Dialog.ShowModal = mrOK ) then
    begin
        P.Address := New_Watch_Dialog.Value ;
        P.Size := New_Watch_Dialog.Size.Value ;
        if( New_Watch_Dialog.Binary_RB.Checked ) then
        begin
            P.Base := 2 ;
        end else
        if( New_Watch_Dialog.Octal_RB.Checked ) then
        begin
            P.Base := 8 ;
        end else
        if( New_Watch_Dialog.Decimal_RB.Checked ) then
        begin
            P.Base := 10 ;
        end else
        if( New_Watch_Dialog.Hexadecimal_RB.Checked ) then
        begin
            P.Base := 16 ;
        end else
        if( New_Watch_Dialog.Other_RB.Checked ) then
        begin
            P.Base := New_Watch_Dialog.Base_Spin.Value ;
        end else
        if( New_Watch_Dialog.ASCII_RB.Checked ) then
        begin
            P.Base := 0 ;
        end else
        if( New_Watch_Dialog.EBCDIC_RB.Checked ) then
        begin
            P.Base := 1 ;
        end else
        if( New_Watch_Dialog.Radix50_RB.Checked ) then
        begin
            P.Base := 50 ;
        end else
        if( New_Watch_Dialog.Single_RB.Checked ) then
        begin
            P.Base := -4 ;
        end else
        if( New_Watch_Dialog.Double_RB.Checked ) then
        begin
            P.Base := -8 ;
        end else
        if( New_Watch_Dialog.Extended_RB.Checked ) then
        begin
            P.Base := -10 ;
        end ;
        Update_Watches ;
    end ;
end ; // TMain_Form.Edit1Click


procedure TMain_Form.Delete1Click( Sender : TObject ) ;

begin
    if( Watch_List_Box.ItemIndex <> -1 ) then
    begin
        Watches.Delete( Watch_List_Box.ItemIndex ) ;
        Watch_List_Box.Items.Delete( Watch_List_Box.ItemIndex ) ;
        Update_Watches ;
    end ;
end ;


procedure TMain_Form.DeleteAll1Click(Sender: TObject);

begin
    if( MessageBox( 0, 'Delete all watches?', 'CEF', MB_YESNO ) = IDYES ) then
    begin
        Clear_Watches ;
        Update_Watches ;
    end ;
end ;


procedure TMain_Form.Watch_List_BoxMouseUp( Sender : TObject ;
    Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer ) ;

var Index : integer ;

begin
    if( Button = mbRight ) then
    begin
        Index := Watch_List_Box.ItemAtPos( Point( X, Y ), True ) ;
        if( Index <> -1 ) then
        begin
            Watch_List_Box.ItemIndex := Index ;
        end ;
        Watches_Popup_Menu.Popup( Mouse.CursorPos.X, Mouse.CursorPos.Y ) ;
    end ;
end ;


procedure TMain_Form.Watch_List_BoxDblClick( Sender : TObject ) ;

begin
    if( Watch_List_Box.ItemIndex = -1 ) then
    begin
        AddWatch1Click( Sender ) ;
    end else
    begin
        Edit1Click( nil ) ;
    end ;
end ;


procedure TMain_Form.Watch_List_BoxKeyDown( Sender : TObject ; var Key : Word ;
    Shift : TShiftState ) ;

begin
    if( ( Key = VK_Delete ) and ( Watch_List_Box.ItemIndex <> -1 ) ) then
    begin
        Delete1Click( nil ) ;
    end ;
end ;


procedure TMain_Form.ExecutionBreakpoints1Click( Sender : TObject ) ;

begin
    if( Master_CPU <> nil ) then
    begin
      Memory_Watchpoints_Dialog.CPU := nil ;
      Memory_Watchpoints_Dialog.Set_Data( Execution_Watchpoints, nil, nil,
          False ) ;
      Memory_Watchpoints_Dialog.ShowModal ;
    end ;
end ;


procedure TMain_Form.AddPortBreakpoint1Click( Sender : TObject ) ;

begin
    if( Master_CPU <> nil ) then
    begin
        Add_Breakpoint( Master_CPU, Port_Watchpoints, Port_Watchpoints_Access,
            AD.Base, AD.Number_Size, True ) ;
    end ;
end ;


procedure TMain_Form.PortBreakpoints1Click( Sender : TObject ) ;

begin
    if( Master_CPU <> nil ) then
    begin
        Memory_Watchpoints_Dialog.CPU := nil ;
        Memory_Watchpoints_Dialog.Set_Data( Port_Watchpoints, nil, Port_Watchpoints_Access, True ) ;
        Memory_Watchpoints_Dialog.ShowModal ;
    end ;
end ;


procedure TMain_Form.Clear_Watches ;

var Loop : integer ;

begin
    for Loop := 0 to Watches.Count - 1  do
    begin
        TWatch( Watches[ Loop ] ).Free ;
    end ;
    Watches.Clear ;
    Update_Watches ;
end ;


procedure TMain_Form.Profiling1Click( Sender : TObject ) ;

begin
    Profiling1.Checked := not Profiling1.Checked ;
    Master_CPU.Set_Profiling( Profiling1.Checked, False ) ;
end ;


procedure TMain_Form.ProfileReport1Click(Sender: TObject);

begin
    Report_Profile( Master_CPU ) ;
end ;


procedure TMain_Form.TraceLog1Click( Sender : TObject ) ;

var Loop : integer ;
    S : string ;

begin
    Trace_Log_Form.List_Box.Clear ;
    for Loop := Trace_Position to Traces.Count - 1 do
    begin
        S := Traces[ Loop ] ;
        if( length( S ) > 0 ) then
        begin
            Trace_Log_Form.List_Box.Items.Add( S ) ;
        end ;
    end ;
    for Loop := 0 to Trace_Position -1 do
    begin
        Trace_Log_Form.List_Box.Items.Add( Traces[ Loop ] ) ;
    end ;
    Trace_Log_Form.ShowModal ;
end ;


procedure TMain_Form.Trace1Click( Sender : TObject ) ;

var CB_List : TList ;
    Y : integer ;

    procedure Configure_Component( Component : TComponent ) ;

    var CB : TCheckBox ;
        S : string ;

    begin
        CB := TCheckBox.Create( Trace_Form ) ;
        CB.Parent := Trace_Form.Main_Panel ;
        CB.Left := 8 ;
        CB.Width := 256 ;
        CB.Top := Y ;
        Y := Y + CB.Height + 4 ;
        S := string( Component.Name ) ;
        if(
            ( Component.Input_Component( 0 ) = nil )
            and
            ( Component.Output_Component( 0 ) = nil )
          ) then
        begin
            S := S + ' (no connections)' ;
        end ;
        CB.Caption := S ;
        CB.Checked := Component.Get_Trace ;
        CB_List.Add( CB ) ;
    end ;

var CB : TCheckBox ;
    Component : TComponent ;
    Loop : integer ;

begin
    if( Traces.Count > 0 ) then
    begin
        Trace_Form.Count.Value := Traces.Count ;
    end else
    begin
        Trace_Form.Count.Value := 10 ;
    end ;
    Delete_All_Children( Trace_Form.Main_Panel ) ;
    Y := 3 ;
    CB_List := TList.Create ;
    for Loop := 0 to Component_List.Count - 1 do
    begin
        Component := TComponent( Component_List.Objects[ Loop ] ) ;
        Configure_Component( Component ) ;
    end ;
    Configure_Component( Main_Memory ) ;

    if( Trace_Form.ShowModal = mrOK ) then
    begin
        if( Traces.Count <> Trace_Form.Count.Value ) then
        begin
            Traces.Clear ;
            while( Traces.Count < Trace_Form.Count.Value ) do
            begin
                Traces.Add( '' ) ;
            end ;
            Trace_Position := 0 ;
        end ;
        for Loop := 0 to Component_List.Count - 1 do
        begin
            Component := TComponent( Component_List.Objects[ Loop ] ) ;
            CB := TCheckBox( CB_List[ Loop ] ) ;
            Component.Set_Trace( CB.Checked ) ;
        end ;
        Main_Memory.Set_Trace( TCheckBox( CB_List[ CB_List.Count - 1 ] ).Checked ) ;
    end ;
    CB_List.Free ;
end ; // TMain_Form.Trace1Click



procedure TMain_Form.Disassembly_List_BoxMouseUp( Sender : TObject ;
    Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer ) ;

var Point : TPoint ;

begin
    if( Button = mbRight ) then
    begin
        Point.X := X ;
        Point.Y := Y ;
        Point := Disassembly_List_Box.ClientToScreen( Point ) ;
        Disassembly_Popup.Popup( Point.X, Point.Y ) ;
    end ;
end ;


procedure TMain_Form.Disassembly_List_Resize( Sender : TObject ) ;

begin
    Update_Disassembly ;
end ;


procedure TMain_Form.Showsource1Click( Sender : TObject ) ;

begin
    Map_Source( True ) ;
end ;


procedure TMain_Form.GotoCurrent1Click( Sender : TObject ) ;

begin
    Disassembly_Top := -1 ;
    Update_Disassembly ;
    Disassembly_List_Box.ItemIndex := 0 ;
end ;


procedure TMain_Form.Gotoaddress2Click( Sender : TObject ) ;

begin
    if( Master_CPU <> nil ) then
    begin
        Goto_Address_Form.Base := AD.Base ;
        Goto_Address_Form.ComboBox1.Text :=
            Cvtb( 10, Ad.Base, inttostr( Master_CPU.CPU.Get_Current_Address( 0, True ) ) ) ;
        if( Goto_Address_Form.ShowModal = mrOK ) then
        begin
            Disassembly_Top :=
                strtoint( Cvtb( AD.Base, 10, Goto_Address_Form.ComboBox1.Text ) ) ;
            Update_Disassembly ;
        end ;
    end ;
end ;


procedure TMain_Form.TopofStack1Click(Sender: TObject);

begin
    Update_Stack ;
    Stack_List_Box.ItemIndex := 0 ;
end ;


procedure TMain_Form.Gotoaddress3Click(Sender: TObject);

begin
    if( Master_CPU <> nil ) then
    begin
        Goto_Address_Form.Base := AD.Base ;
        Goto_Address_Form.ComboBox1.Text :=
            Cvtb( 10, Ad.Base, inttostr( Master_CPU.CPU.Top_Of_Stack( 0 ) ) ) ;
        if( Goto_Address_Form.ShowModal = mrOK ) then
        begin
            Stack_Top :=
                strtoint( Cvtb( AD.Base, 10, Goto_Address_Form.ComboBox1.Text ) ) ;
            Update_Stack ;
        end ;
    end ;
end ;



end.
