{
              Program Name : HELP
              Package Name : LB
              Purpose      : General-purpose help routine
              Institution  : Conroy & Conroy
              Original Date: 18-Aug-88
              Date Written : 02-Jun-1991
              Written By   : Alan Conroy
              Version      : 2.1

              Copyright (C) 1988 by Alan Conroy.  Released to the public domain.

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *     DATE      BY             REASON                   *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          This procedure provides help from .HLP files.
}

unit Helps ;

interface

procedure Help( Command, Command1 : string ) ;

implementation

{$I EDEFINES.INC}

uses { Borland... }
{$IFDEF DELPHI}
     SysUtils, { strpas }
{$ELSE}
     Strings, { strpas }
{$ENDIF}

     { Conroy & Conroy Co... }
     CommonUt, { Edit }
     Standard, { Extension_Pos }
     ASCIIDef,
     Files,
     GetChars,
     SMU,
     ErrMastr ;

procedure Help ;

label Try_Again ;

var Column : Integer ; { Column count }
    Header : Boolean ; { True if header displayed }
    Help_File : TSFile ; { Main help file }
    Help_Files : array[ 0..39 ] of string[ 32 ] ; { Help filenames per level }
    Help_Line : array[ 0..39 ] of Integer ; { Line in help file for "*" }
    Icf, T : Boolean ;
    Level : Integer ; { Current help file level }
    Line_Count : Integer ;
    { Number of lines displayed on screen since last input }
    Lr : Integer ; { Count of lines read }
    Screen_Length : Integer ;
    Topics : array[ 1..39 ] of string ; { Help topics per level }
    Wildcard : Integer ;

function Out( X : string ) : boolean ; { Output a line of text }

var A : Integer ;
    B : Char ;

begin
    Out := False ;
    if( ( Length( X ) > 0 ) and ( Ord( X[ 1 ] ) = 12 ) ) then
    begin
        Line_Count := Screen_Length - 1 ;
    end else { FF is end of screen }
    begin
        if( ( Length( X ) > 0 ) and ( Level > 1 ) ) then for A := 2 to Level do
        begin
	    Output_Text( '  ' ) ;
        end ;
        Output_Text( X + CRLF ) ;
        Line_Count := Line_Count + 1 ;
    end ;
    if( Line_Count = Screen_Length - 1 ) then
    begin
        Output_Text( 'Press any key to continue...' ) ;
	Update_Window( Current_Window ) ;
        B := Default_Input.Get_Char( 0 ) ;
        Output_Text( CR + '                            ' + CR ) ;
	if( ( B = ETX ) or ( B = EM ) or ( B = SUB ) or ( B = ESC ) ) then
	begin
	    Out := True ;
	    exit ;
	end ;
	Update_Window( Current_Window ) ;
        Line_Count := 0
    end ;
end ; { Out }


procedure Further ; { Display subtopic names }

begin
    Column := 0 ;
    Header := False ;
    while( not Help_File.Eof ) do
    begin
        Help_File.Readln( Command ) ;
        Lr := Lr + 1 ;
        if( Copy( Command, 1, 1 ) = '*' ) then
        begin
            if( Copy( Command, 2, 1 ) <> '|' ) then
            begin
                If( not Header ) then
                begin
                    if( Out( '' ) ) then
		    begin
			exit ;
		    end ;
                    Output_Text( 'Further help is available on:' + CRLF ) ;
                    if( Out( '' ) ) then
		    begin
			exit ;
		    end ;
                    if( Out( '' ) ) then
		    begin
			exit ;
		    end ;
                    Header := True
                end ;
                if( Column > 72 ) then
                begin
                    if( Out( '' ) ) then
		    begin
			exit ;
		    end ;
                    Column := 0
                end ;
                while( ( Column and 7 ) <> 0 ) do
                begin
                    Column := Column + 1 ;
                    Output_Text( ' ' )
                end ;
                Column := Column + Length( Command ) ;
                if( Column > 79 ) then
                begin
                    if( Out( '' ) ) then
		    begin
			exit ;
		    end ;
                    Column := Length( Command )
                end ;
                Output_Text( Copy( Command, 2, Length( Command ) - 1 ) + ' ' ) ;
            end ;
        end ;
    end ;
    if( Header ) then
    begin
	Out( '' ) ;
    end ;
end ; { Further }


function Print_Help( X : string ) : Boolean ;
{ Display help for current topic - return TRUE if OK, FALSE if error }

var Dummy : Integer ; { Dummy loop variable }
    Lc : Integer ; { Lines printed, lines read count }
    Topic, Z : string ;

label Done, Next_Line, Next_Line1, Prompt, Prompt1, Start ;

begin
    if( Current_Window = nil ) then
    begin
        Screen_Length := 24 ;
    end else
    begin
	Screen_Length := Current_Window^.Rows ;
    end ;
Start:
    Icf := False ;
    Print_Help := True ;
    Help_File.Reset( Help_File.FileName ) ;
    Lr := 0 ;
    if( Length( X ) = 0 ) then {Initial state}
    begin
        while( not Help_File.Eof ) do
        begin
            Help_File.Readln( Z ) ;
            Lr := Lr + 1 ;
            if( Copy( Z, 1, 1 ) = '*' ) then
            begin
                goto Prompt ;
            end ;
            if( Out( Z ) ) then
	    begin
		break ;
	    end ;
        end ;
        goto Prompt ;
    end ;
    Lc := Pos( ' ', X + ' ' ) ;
    Topic := Copy( X, 1, Lc - 1 ) ; { Get topic }
    Topics[ Level ] := Topic ;
    X := Copy( X, Lc + 1, Length( X ) - Lc ) ; { Get sub-topic(s) }
    if( Topic = '*' ) then
    begin
	if( Wildcard > Level ) then
	begin
	    Wildcard := Level ;
	end ;
    end ;
Next_Line:
    if( Help_File.Eof ) then { No match found }
    begin
        if( Topic <> '*' ) then
        begin
            Output_Text( 'Sorry, no help for ' + Topic + ' found at this level.' + CRLF ) ;
            Print_Help := False
        end ;
        Exit ;
    end ;
    Help_File.Readln( Z ) ;
    Lr := Lr + 1 ;
    Z := Edit( Z, 188 ) ;
    if( Copy( Z, 1, 1 ) <> '*' ) then
    begin
        goto Next_Line ;
    end ;
    if( ( Topic <> '*' ) and ( Z <> '*' + Topic ) and ( Z <> '*|' + Topic ) ) then
    begin
        goto Next_Line ;
    end ;
    if( Topic = '*' ) then
    begin
	Topics[ Level ] := Copy( Z, 2, Length( Z ) - 1 ) ;
    end ;
    Out( Topics[ Level ] ) ;
    Out( '' ) ;
Next_Line1:
    while( not Help_File.Eof ) do { Find and display text for this topic }
    begin
        Help_File.Readln( Command ) ;
        Lr := Lr + 1 ;
        if( Copy( Command, 1, 1 ) = '@' ) then { Indirect help }
        begin
            if( Level = 40 ) then
            begin
                Output_Text( '%Nesting exceeds 40 levels' + CRLF ) ;
                Help_File.Close ;
                Exit ;
            end ;
            Icf := True ;
            Command := Copy( Command, 2, Length( Command ) - 1 ) ; { Strip @ }
            if( Extension_Pos( Command ) = 0 ) then
            begin
                Command := Command + '.HLP' ;
            end ;
            { Default extension is .HLP }
            if( ( Pos( ':', Command ) = 0 ) and ( Pos( '\', Command ) = 0 ) ) then
	    begin
                Command := FileName( Command ) ; { Find file }
	    end ;
            Help_Line[ Level - 1 ] := Lr ;
            Help_File.Reset( Command ) ;
            Lr := 0 ;
            if( Help_File.IO_Error.Code <> 0 ) then
            begin
                Output_Text( strpas( Get_Error_Text( Help_File.IO_Error, -1 ) ) + ' - ' + Command + CRLF ) ;
                { Open previous file }
                Help_File.Reset( Help_Files[ Level ] ) ;
                Lr := 0 ;
                if( Help_Line[ Level ] > 0 ) then
		begin
                    for Dummy := 1 to Help_Line[ Level ] do
                    begin
                        Help_File.Readln( Z ) ;
                    end ;
		end ;
                Lr := Help_Line[ Level ] ;
                Exit ;
            end ;
            Help_Files[ Level ] := Command ;
        end else
        begin
            if( ( Copy( Command, 1, 1 ) = '*' ) and ( Command[ 2 ] <> '|' ) ) then
            begin
                if( Topic = '*' ) then { Wildcard topic match }
                begin
                    if( Icf ) then { Sub-topic was in a separate file }
                    begin
                        Further ; { Display further topics }
                        Icf := False ;
                        Help_File.Close ;
                        Help_File.Reset( Help_Files[ Level - 1 ] ) ;
                        Lr := Help_Line[ Level - 1 ] ;
                        for Dummy := 1 to Lr do
                        begin
                            Help_File.Readln( Z ) ;
                        end ;
                        Command := Z ;
                    end else
                    begin
                        if( Out( '' ) ) then
			begin
			    exit ;
			end ;
                        if( Out( '' ) ) then
			begin
			    exit ;
			end ;
                        if( Out( Copy( Command, 2, Length( Command ) - 1 ) ) ) then
			begin
			    exit ;
			end ;
                    end ;
                    if( Out( '' ) ) then
		    begin
			exit ;
		    end ;
                    goto Next_Line1 ;
                end ;
                if( ( not Icf ) and ( Level > 0 ) and ( Topic <> '?' ) ) then
		begin
		    exit ;
		end ;
                goto Prompt ;
            end ;
            if( Copy( Command, 1, 1 ) <> '*' ) then
            begin
                if( Length( X ) > 0 ) then { Sub topics specified }
                begin
                    Help_Line[ Level ] := Lr ;
                    Level := Level + 1 ;
                    T := Print_Help( X ) ;
		    if( ( Kb_Buffer = Chr( 3 ) ) Or ( Kb_Buffer = Chr( 25 ) ) ) then
                    begin
                        Exit ;
                    end ;
                    Level := Level - 1 ;
                    if( not T ) then
                    begin
                        Print_Help := False ;
                        Exit ; { Error on a subtopic }
                    end ;
                    Help_Line[ Level ] := Lr ;
                    Help_File.Reset( Help_Files[ Level ] ) ;
                    Lr := 0 ;
                    if( Topic = '*' ) then
                    begin
                        for Dummy := 1 to Help_Line[ Level ] do
                        begin
                            Help_File.Readln( Z ) ;
                        end ;
                        Lr := Help_Line[ Level ]
                    end ;
                    goto Done ;
                end ;
                if( Out( Command ) ) then
		begin
		    exit ;
		end ;
            end ;
        end ;
    end ; { Eof }
    if( ( Topic = '*' ) and Icf ) then { Eof with wildcard }
    begin
        Help_File.Close ;
        Help_File.Reset( Help_Files[ Level - 1 ] ) ;
        Icf := False ;
        Lr := Help_Line[ Level - 1 ] ;
        for Dummy := 1 to Lr do
        begin
            Help_File.Readln( Z ) ;
        end ;
        goto Next_Line ;
    end ;
Done:
    if( Topic = '*' ) then
    begin
        Exit ; { end of file on wild-card so back up }
    end ;
Prompt:
    if( Wildcard < Level ) then
    begin
        Exit ;
    end ;
    Help_File.Reset( Help_File.FileName ) ;
    Lr := 0 ;
    Further ; { Display further topics }
Prompt1:
    if( Level > 0 ) then
    begin
	for Dummy := 1 to Level do
        begin
            Output_Text( Topics[ Dummy ] + ' ' ) ;
        end ;
    end ;
    Output_Text( 'Topic? ' ) ;
    Update_Window( Current_Window ) ;
    Window_Read ;
    X := Kb_Buffer ;
    Line_Count := 0 ;
    X := Edit( X, 188 ) ;
    if( Length( X ) = 0 ) then
    begin
	Exit ;
    end ;
    if( X = '?' ) then
    begin
        X := '' ;
        goto Start ; { Re-display current help }
    end ;
    if( ( X = Chr( 26 ) ) Or ( X = Chr( 3 ) ) Or ( X = Chr( 25 ) ) ) then
    begin
        Exit ; { Exit on control-C or control-Y }
    end ;
    if( Level > 0 ) then
    begin
        for Dummy := 1 to Level do
        begin
            if( Out( Topics[ Dummy ] ) ) then
            begin
                goto Prompt1 ;
            end ;
            if( Out( '' ) ) then
            begin
                goto Prompt1 ;
            end ;
        end ;
    end ;
    Help_Line[ Level ] := Lr ;
    Level := Level + 1 ;
    T := Print_Help( X ) ;
    if( ( Kb_Buffer = Chr( 3 ) ) or ( Kb_Buffer = Chr( 25 ) ) ) then
    begin
        Exit ;
    end ;
    Level := Level - 1 ;
    {$I-}
    Help_File.Reset( Help_Files[ Level ] ) ;
    {$I+}
    if( Help_File.IO_Error.Code <> 0 ) then
    begin
        writeln( strpas( Get_Error_Text( Help_File.IO_Error, -1 ) ) + ' while opening ' + Help_Files[ Level ] ) ;
        halt ;
    end ;
    Lr := 0 ;
    goto Prompt1 ;
end ; { Print_Help }


begin
    Help_File.File_Mode := FSOM_Read_Only ;
    Help_File.Init( nil, True, 1 ) ;
Try_Again:
    Command := FileName( Command ) ; { Find help file }
    {$I-}
    Help_File.Reset( Command ) ;
    {$I+}
    if( Help_File.IO_Error.Code <> 0 ) then
    begin
        If Pos( '.', Command ) = 0 then
        begin
            Command := Command + '.HLP' ; { Default extension }
            goto Try_Again ;
        end ;
        Output_Text( 'Help not available' + CRLF ) ;
        Exit ;
    end ;
    Help_Files[ 0 ] := Command ;
    Level := 0 ;
    Command := Command1 ; { Get input }
    Command := Edit( Command, 188 ) ;
    if( Length( Command ) > 0 ) then
    begin
        Level := 1 ;
    end ;
    Wildcard := 255 ;
    Line_Count := 0 ;
    T := Print_Help( Command ) ;
end ;



end.
