{
        Program Name : RPG_Character
        Package Name :
        Purpose      : Generic RPG character object
        Institution  : Conroy & Conroy Co.
        Date Written : 01-Aug-1999
        Written By   : Alan Conroy
        Version      : 1.0

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  This unit defines the TRPG_Character and related classes.
}

unit RPG_Character ;

interface

uses // Borland...
     Windows, // HBitmap

     // C&C...
     COMInter ; // TCommon_COM_Interface

type TGender = ( Gender_Male, Gender_Female ) ;

     TCharacter_Object = class ;

     TCharacter = class( TCommon_COM_Interface ) // All reality character types descend from this
         public
             function Get_Bitmap : HBitmap ; virtual ; stdcall ; abstract ;
             procedure Set_Bitmap( Value : HBitmap ) ;
                 virtual ; stdcall ; abstract ;
             function Get_Object : TCharacter_Object ;
                 virtual ; stdcall ; abstract ;
             procedure Set_Object( Value : TCharacter_Object ) ;
                 virtual ; stdcall ; abstract ;

             procedure Assign( Instance : TCharacter ) ;
                 virtual ; stdcall ; abstract ;
             function Name_Matches( X : PChar ) : boolean ;
                 virtual ; stdcall ; abstract ;
             function Serialize : PChar ; virtual ; stdcall ; abstract ;
             procedure Deserialize( Buffer : PChar ) ;
                 virtual ; stdcall ; abstract ;
             function Get_Gender : TGender ; virtual ; stdcall ; abstract ;
             procedure Set_Gender( Value : TGender ) ;
                 virtual ; stdcall ; abstract ;
             function Get_Name : PChar ; virtual ; stdcall ; abstract ;
             function Description : PChar ; virtual ; stdcall ; abstract ;
             function Status : PChar ; virtual ; stdcall ; abstract ;

             property Bitmap : HBITMAP
                          read Get_Bitmap
                          write Set_Bitmap ;
             property _Object : TCharacter_Object
                          read Get_Object
                          write Set_Object ;
             property Gender : TGender
                 read Get_Gender
                 write Set_Gender ;
     end ; // TCharacter

     TCharacter_Object = class
                             protected // Property handlers...
                                 function Get_Data : PChar ;
                                     virtual ; stdcall ; abstract ;
                                 function Get_Is_Party_Member : boolean ;
                                     virtual ; stdcall ; abstract ;
                                 procedure Set_Data( Value : PChar ) ;
                                     virtual ; stdcall ; abstract ;
                                 procedure Set_Is_Party_Member( Value : boolean ) ;
                                     virtual ; stdcall ; abstract ;
                                 function Get_Character : TCharacter ;
                                     virtual ; stdcall ; abstract ;
                                 procedure Set_Character( Value : TCharacter ) ;
                                     virtual ; stdcall ; abstract ;

                             public // API...
                                 property Character : TCharacter
                                     read Get_Character
                                     write Set_Character ;
                                 property Data : PChar
                                     read Get_Data
                                     write Set_Data ;

                                 procedure Terminate ;
                                     virtual ; stdcall ; abstract ;
                        end ;

implementation

end.
