{$N+}
{$E+}
{
        Program Name : _APM
        Package Name : Subroutine Library - Layer 1
        Purpose      : Abstract Application Performance Monitor
        Institution  : Conroy & Conroy Co.
        Date Written : 31-January-2005
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2005 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          The classes in this unit are used to provide an OO performance monitor
        for an application.
}

unit _APM ;

interface

uses { Subroutine Library - Layer 0... }
     Common, { TBase_Object }
     ComInter, { TCommon_COM_Interface }
     _DebugIn ; { PDebug_Interface }

{$I EDEFINES.INC}

{$IFDEF DELPHI}
type TApplication_Performance_Monitor = class( TBase_Delphi_Object )
                                            public { API... }
                                                function Begin_Transaction : integer ;
                                                    virtual ; abstract ;
                                                procedure End_Transaction( TN, Max : integer ;
                                                    const Title : string ) ;
                                                    virtual ; abstract ;
                                                procedure Set_Multiplier( Value : double ) ;
                                                    virtual ; abstract ;
                                                function Get_Multiplier : double ;
                                                    virtual ; abstract ;

                                                property Multiplier : double
                                                    read Get_Multiplier
                                                    write Set_Multiplier ;
                                        end ;

type TCOM_Application_Performance_Monitor = class( TCommon_COM_Interface )
                                                public { API... }
                                                    function Begin_Transaction : integer ;
                                                        virtual ; stdcall ; abstract ;
                                                    procedure End_Transaction( TN, Max : integer ;
                                                        const Title : string ) ;
                                                        virtual ; stdcall ; abstract ;
                                                    procedure Set_Multiplier( Value : double ) ;
                                                        virtual ; stdcall ; abstract ;
                                                    function Get_Multiplier : double ;
                                                        virtual ; stdcall ; abstract ;

                                                    property Multiplier : double
                                                        read Get_Multiplier
                                                        write Set_Multiplier ;
                                            end ;
{$ENDIF}

type TSApplication_Performance_Monitor = object( TBase_Object )
                                             public { Constructors and destructors... }
                                                 constructor Init ;

                                             public { API... }
                                                 function Begin_Transaction : integer ;
                                                     virtual ;
                                                 procedure End_Transaction( TN, Max : integer ;
                                                     const Title : string ) ;
                                                     virtual ;
                                                 procedure Set_Multiplier( Value : double ) ;
                                                     virtual ;
                                                 function Get_Multiplier : double ;
                                                     virtual ;
                                                 function Debugger : PSDebug_Interface ;
                                                     virtual ;
                                         end ;
     PSApplication_Performance_Monitor = ^TSApplication_Performance_Monitor ;

implementation

uses { Subroutine Library - Layer 0... }
     _Common ; { Abstract_Error }

{ TApplication_Event_Logger methods... }

{ Constructors and destructors... }

constructor TSApplication_Performance_Monitor.Init ;

begin
    { Default does nothing }

    inherited Init ;
end ;


{ API... }

function TSApplication_Performance_Monitor.Debugger : PSDebug_Interface ;

begin
    Debugger := nil ;
end ;


function TSApplication_Performance_Monitor.Begin_Transaction : integer ;

begin
    Begin_Transaction := 0 ;
    Abstract_Error ;
end ;


procedure TSApplication_Performance_Monitor.End_Transaction( TN, Max : integer ;
    const Title : string ) ;

begin
    Abstract_Error ;
end ;


procedure TSApplication_Performance_Monitor.Set_Multiplier( Value : double ) ;

begin
    Abstract_Error ;
end ;


function TSApplication_Performance_Monitor.Get_Multiplier : double ;

begin
    Get_Multiplier := 0 ;
    Abstract_Error ;
end ;



end.
