{
        Program Name : Internet_Util
        Package Name : LB
        Purpose      : Internet utility routines
        Institution  : Conroy & Conroy Co.
        Date Written : 16-Dec-2002
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2002 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          These routines provide various Internet-related utilities.
}

unit Internet_Util ;

interface

function Connected_To_Internet : boolean ;
function Get_Web_File( Name : string ) : string ;

implementation

uses
  Windows,
  WinInet,
  WinSock,
  NMHttp,

  TypeDefs ; // Max_Memory

type TPInAddr_Array = array[ 0..Max_Memory div sizeof( PInAddr ) ] of PInAddr ;
     pTPInAddr_Array = ^TPInAddr_Array ;

function Connected_To_Internet : boolean ;

var A : pTPInAddr_Array ;
    Buffer : array[ 0..63 ] of char ;
    Dummy : integer ;
    Found : boolean ;
    P : PHostEnt ;
    S : string ;
    Temp : DWORD ;
    WSA_Data : TWSAData ;

begin
    // See if user is actually connected to the Internet...
    Result := False ; // Assume failure
    Found := False ;
    if( WSAStartup( $201, WSA_Data ) <> 0 ) then
    begin
        exit ;
    end ;
    try
        if( GetHostName( @Buffer, sizeof( Buffer ) ) <> 0 ) then // Some sort of network error (like no network connection)
        begin
            exit ;
        end ;
        P := GetHostByName( @Buffer ) ;
        if( P = nil ) then
        begin
            Exit ;
        end ;
        A := pTPInAddr_Array( P^.h_addr_list ) ;
        Dummy := 0 ;
        while( A^[ Dummy ] <> nil ) do
        begin
            S := inet_ntoa( A^[ Dummy ]^ ) ; // Translate address to string
            if( ( S <> '' ) and ( S <> '127.0.0.1' ) ) then
            begin
                Found := True ;
                break ;
            end ;
            Inc( Dummy ) ;
        end ;
    finally
        WSACleanup ;
    end ;

    try
        if( not Found ) then
        begin
            Temp :=
                INTERNET_CONNECTION_MODEM +
                INTERNET_CONNECTION_LAN +
                INTERNET_CONNECTION_PROXY ;
            if( not InternetGetConnectedState( @Temp, 0 ) ) then
            begin
                exit ;
            end ;
        end ;
        Result := True ;
    except
    end ;
end ; // Connected_To_Internet


function Get_Web_File( Name : string ) : string ;

var NMHTTP1 : TNMHTTP ;

begin
    // Read in the current version of the notice file...
    NMHTTP1 := TNMHTTP.Create( nil ) ;
    try
        NMHTTP1.Body := '' ;
        try
            NMHTTP1.Get( Name ) ;
        except
            Result := '' ;
            exit ;
        end ;
        Result := NMHTTP1.Body ;
    finally
        NMHTTP1.Free ;
    end ;
end ;


end.
