{
        Program Name : TCOM_List
        Package Name : LB
        Purpose      : COM list class
        Institution  : Conroy & Conroy Co.
        Date Written : 1-Nov-2006
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2006 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit Lists ;

interface

{$I EDEFINES.INC}

{$IFDEF DELPHI}
uses { C&C... }
     COMInter,

     { Borland... }
     Classes ; { TList }

type TCOM_List = class( TCommon_COM_Interface )
                     public { Constructors and destructors... }
                         constructor Create ;
                         destructor Destroy ; override ;

                     private { Instance data... }
                         _List : TList ;

                     public { API... }
                         function Add( Value : longint ) : longint ;
                             virtual ; stdcall ;
                         function Count : longint ;
                             virtual ; stdcall ;
                         function Get_Item( Index : longint ) : longint ;
                             virtual ; stdcall ;
                         procedure Set_Item( Index, Value : longint ) ;
                             virtual ; stdcall ;
                 end ;
{$ENDIF}

implementation

{$IFDEF DELPHI}
{TCOM_List methods... }

{ Constructors and destructors... }

constructor TCOM_List.Create ;

begin
    inherited Create ;

    _List := TList.Create ;
end ;


destructor TCOM_List.Destroy ;

begin
    _List.Free ;
    _List := nil ;

    inherited Destroy ;
end ;


{ API... }

function TCOM_List.Add( Value : longint ) : longint ;

begin
    _List.Add( pointer( Value ) ) ;
    Result := _List.Count - 1 ;
end ;


function TCOM_List.Count : longint ;

begin
    Result := _List.Count ;
end ;


function TCOM_List.Get_Item( Index : longint ) : longint ;

begin
    Result := longint( _List[ Index ] ) ;
end ;


procedure TCOM_List.Set_Item( Index, Value : longint ) ;

begin
    _List[ Index ] := pointer( Value ) ;
end ;
{$ENDIF}



end.

