{
        Program Name : Media
        Package Name : LB
        Purpose      : Multimedia support
        Institution  : Conroy & Conroy Co.
        Date Written : 18-Dec-2002
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2002 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit Media ;

interface

type TMP3_ID3 = packed record { Last 128 bytes of a .MP3 file, if present }
                    Tag : array[ 0..2 ] of Char ; { "TAG" }
                    Title,
                    Artist,
                    Comment,
                    Album : array[ 0..29 ] of Char ;
                    Year : array[ 0..3 ] of Char ;
                    Genre : Byte ;
                end ; { TMP3_ID3 }

     TMP3_Genre = ( MP3G_Blues, MP3G_Classic_Rock, MP3G_Country, MP3G_Dance,
                    MP3G_Disco, MP3G_Funk, MP3G_Grunge, MP3G_Hip_Hop, MP3G_Jazz,
                    MP3G_Metal, MP3G_New_Age, MP3G_Oldies, MP3G_Other, MP3G_Pop,
                    MP3G_R_B, MP3G_Rap, MP3G_Reggae, MP3G_Rock, MP3G_Techno,
                    MP3G_Industrial, MP3G_Alternative, MP3G_Ska,
                    MP3G_Death_Metal, MP3G_Pranks, MP3G_Soundtrack,
                    MP3G_Euro_Techno, MP3G_Ambient, MP3G_Trip_Hop, MP3G_Vocal,
                    MP3G_Jazz_Funk, MP3G_Fusion, MP3G_Trance, MP3G_Classical,
                    MP3G_Instrumental, MP3G_Acid, MP3G_House, MP3G_Game,
                    MP3G_Sound_Clip, MP3G_Gospel, MP3G_Noise, MP3G_AlternRock,
                    MP3G_Bass, MP3G_Soul, MP3G_Punk, MP3G_Space,
                    MP3G_Meditative, MP3G_Instrumental_Pop,
                    MP3G_Instrumental_Rock, MP3G_Ethnic, MP3G_Gothic,
                    MP3G_Darkwave, MP3G_Techno_Industrial, MP3G_Electronic,
                    MP3G_Pop_Folk, MP3G_Eurodance, MP3G_Dream,
                    MP3G_Southern_Rock, MP3G_Comedy, MP3G_Cult, MP3G_Gangsta,
                    MP3G_Top_40, MP3G_Christian_Rap, MP3G_Pop_Funk, MP3G_Jungle,
                    MP3G_Native_American, MP3G_Cabaret, MP3G_New_Wave,
                    MP3G_Psychadelic, MP3G_Rave, MP3G_Showtunes, MP3G_Trailer,
                    MP3G_Lo_Fi, MP3G_Tribal, MP3G_Acid_Punk, MP3G_Acid_Jazz,
                    MP3G_Polka, MP3G_Retro, MP3G_Musical, MP3G_Rock_n_Roll,
                    MP3G_Hard_Rock, MP3G_Folk, MP3G_Folk_Rock,
                    MP3G_National_Folk, MP3G_Swing, MP3G_Fast_Fusion,
                    MP3G_Bebob, MP3G_Latin, MP3G_Revival, MP3G_Celtic,
                    MP3G_Bluegrass, MP3G_Avantgarde, MP3G_Gothic_Rock,
                    MP3G_Progressive_Rock, MP3G_Psychadelic_Rock,
                    MP3G_Symphonic_Rock, MP3G_Slow_Rock, MP3G_Big_Band,
                    MP3G_Chorus, MP3G_Easy_Listening, MP3G_Acoustic, MP3G_Humor,
                    MP3G_Speech, MP3G_Chanson, MP3G_Opera, MP3G_Chamber_Music,
                    MP3G_Sonata, MP3G_Symphony, MP3G_Booty_Bass, MP3G_Primus,
                    MP3G_Porn_Groove, MP3G_Satire, MP3G_Slow_Jam, MP3G_Club,
                    MP3G_Tango, MP3G_Samba, MP3G_Folklore, MP3G_Ballad,
                    MP3G_Power_Ballad, MP3G_Rhythmic_Soul, MP3G_FreeStyle,
                    MP3G_Duet, MP3G_Punk_Rock, MP3G_Drum_Solo, MP3G_Acapella,
                    MP3G_Euro_House, MP3G_Dance_Hall, MP3G_Goa,
                    MP3G_Drum_n_Bass, MP3G_Club_House, MP3G_Hardcore,
                    MP3G_Terror, MP3G_Indie, MP3G_Britpop, MP3G_Negerpunk,
                    MP3G_Polsk_Punk, MP3G_Beat, MP3G_Christian_Gangsta_Rap,
                    MP3G_Heavy_Metal, MP3G_Black_Metal, MP3G_Crossover,
                    MP3G_Contemporary_Christian, MP3G_Christian_Rock,
                    MP3G_Merengue, MP3G_Salsa, MP3G_Trash_Metal, MP3G_Anime,
                    MP3G_JPop, MP3G_Synthpop, MP3G_Unknown ) ;
const MP3_Genre : array[ TMP3_Genre ] of string = (
    'Blues', 'Classic Rock', 'Country', 'Dance', 'Disco', 'Funk', 'Grunge',
    'Hip-Hop', 'Jazz', 'Metal', 'New Age', 'Oldies', 'Other', 'Pop', 'R&B',
    'Rap', 'Reggae', 'Rock', 'Techno', 'Industrial', 'Alternative', 'Ska',
    'Death Metal', 'Pranks', 'Soundtrack', 'Euro-Techno', 'Ambient', 'Trip-Hop',
    'Vocal', 'Jazz+Funk', 'Fusion', 'Trance', 'Classical', 'Instrumental',
    'Acid', 'House', 'Game', 'Sound Clip', 'Gospel', 'Noise', 'AlternRock',
    'Bass', 'Soul', 'Punk', 'Space', 'Meditative', 'Instrumental Pop',
    'Instrumental Rock', 'Ethnic', 'Gothic', 'Darkwave', 'Techno-Industrial',
    'Electronic', 'Pop-Folk', 'Eurodance', 'Dream', 'Southern Rock', 'Comedy',
    'Cult', 'Gangsta', 'Top 40', 'Christian Rap', 'Pop/Funk', 'Jungle',
    'Native American', 'Cabaret', 'New Wave', 'Psychadelic', 'Rave',
    'Showtunes', 'Trailer', 'Lo-Fi', 'Tribal', 'Acid Punk', 'Acid Jazz',
    'Polka', 'Retro', 'Musical', 'Rock & Roll', 'Hard Rock', 'Folk',
    'Folk-Rock', 'National Folk', 'Swing', 'Fast Fusion', 'Bebob', 'Latin',
    'Revival', 'Celtic', 'Bluegrass', 'Avantgarde', 'Gothic Rock',
    'Progressive Rock', 'Psychadelic Rock', 'Symphonic Rock', 'Slow Rock',
    'Big Band', 'Chorus', 'Easy Listening', 'Acoustic', 'Humor', 'Speech',
    'Chanson', 'Opera', 'Chamber Music', 'Sonata', 'Symphony', 'Booty Bass',
    'Primus', 'Porn Groove', 'Satire', 'Slow Jam', 'Club', 'Tango', 'Samba',
    'Folklore', 'Ballad', 'Power Ballad', 'Rhythmic Soul', 'Freestyle', 'Duet',
    'Punk Rock', 'Drum Solo', 'Acapella', 'Euro-House', 'Dance Hall', 'Goa',
    'Drum & Bass', 'Club-House', 'Hardcore', 'Terror', 'Indie', 'BritPop',
    'Negerpunk', 'Polsk Punk', 'Beat', 'Christian Gangsta Rap', 'Heavy Metal',
    'Black Metal', 'Crossover', 'Contemporary Christian', 'Christian Rock',
    'Merengue', 'Salsa', 'Trash Metal', 'Anime', 'Jpop', 'Synthpop', 'Unknown'
  );

implementation

end.
