extern char Kb_Buffer[ 256 ] ;

#ifndef _SMU_H
#define _SMU_H
struct Window_Record
{
    struct Window *Pointer ;
    short int Id ;
} ;


struct Window /* Data for window */
{
    int Level ; /* Level of window */
    short int Attribute ; /* Current attribute value */
    short int Rows, Columns ; /* Window row and column count */
    short int Map_Row, Map_Column, Map_Rows, Map_Columns ;
    /* Row and column positions and sizes on physical screen */
    short int View_Row, View_Column ;
    /* Upper-left-hand corner of window visible in view-port */
    short int Position_Row, Position_Column ;
    /* Current character position */
    int Low_Update, High_Update ;
    /* Low and high offsets defining what needs to be updated */
    int Size ; /* Window size (columns*rows) */
    int Flags ; /* Flags for window:
        AND   1 = No scroll - vertical wrap
        AND   2 = 100% occluded
        AND   4 = No wrap
        AND   8 = No auto-update
        AND  16 = 100% unoccluded
        AND  32 = Cursor is disabled in this window
        AND  64 = Graphics window
	AND 128 = NCM on input
        AND 256-32768 = reserved */
    char *Data_Pointer ;
    char *Attribute_Pointer ;
    struct Window *Next_Window ; /* Pointer to next screen in list */
    int Id ; /* Window ID */
} ;
#endif

int	Window_Mapped( struct Window *Window_Pointer ) ;
void	Get_Default_Window( struct Window_Record *X ) ;
void	Set_Default_Window( struct Window_Record X ) ;
short int Get_Model() ;
void	End_Smu() ;
struct Window *Create_Window( int Row_Count, int Column_Count, int Flag ) ;
void	Unmap_Window( struct Window *Window_P ) ;
void	Map_Window( struct Window *Window_P, short int Row,
	    short int Row_Count, short int Column, short int Column_Count,
	    short int View_R, short int View_C, short int Level ) ;
void	Delete_Window( struct Window *Wp ) ;
void	Clear_Window( struct Window *Window_P ) ;
void	Update_Window( struct Window *Window_P ) ;
void	Update_Screen() ;
void	Refresh_Window( struct Window *Window_P ) ;
void	Refresh_Screen() ;
void	Init_Smu( int X, int Y, int Z, int A ) ;
void	Set_Screen( int Model, int Printer_Model, int Input_Buffers, int Mode ) ;
void	Set_Cursor( int Vr, int Vc ) ;
void	Clear_Cursor( int Vr, int Vc ) ;
void	Set_Window( struct Window *Window_P, int Row, int Column, int Flag,
	    int Attributes ) ;
void	Select_Window( struct Window *Window_P ) ;
void	Erase_Eow( struct Window *Window_P ) ;
void	Erase_Eol( struct Window *Window_P ) ;
void	Insert_Line( struct Window *Window_P, short int Direction ) ;
void	Delete_Line( struct Window *Window_P, short int Direction ) ;
short int Get_Window_Attribute( int R, int C ) ;
char	Get_Screen( int Row, int Col ) ;
void	Window_Input_Line( struct Window *Window_P, int Flags ) ;
void	Window_Read() ;
void	Window_Read_Input( int Flags ) ;
void	Load_Driver( char *X ) ;
char	Get_Window_Char( int R, int C ) ;
void	Set_Viewport( short int Row, short int Column ) ;
struct Window *Current_Window() ;
void	Window_Output( char *Buffer ) ;

