{
        Program Name : TPanel
        Package Name : LB
        Purpose      : Transparent panel component
        Institution  : Conroy & Conroy Co.
        Date Written : 10-July-2005
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2005 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TTransparent_Panel is a Delphi TPanel which doesn't erase it's
        background on paint, provides a paint delegation, and makes its canvas
        available for painting.
}

unit tpanels ;

interface

uses // Borland...
     Classes, // TNotifyEvent
     Messages, // TMessage
     ExtCtrls ; // TPanel

type TTransparent_Panel = class( TPanel )
                              private // Instance data...
                                  _OnPaint : TNotifyEvent ;

                              public // Message handlers...
                                  procedure wmerasebkgnd( var Msg : TMessage ) ;
                                      message WM_Erasebkgnd ;

                              public // API...
                                  procedure Paint ; override ;

                                  property OnPaint : TNotifyEvent
                                      read _OnPaint
                                      write _OnPaint ;

                              published
                                  property Canvas ;
                          end ;

implementation

uses // Borland...
     Graphics ; // psDash

// TTransparent_Panel methods...

// Message handlers...

procedure TTransparent_Panel.wmerasebkgnd( var Msg : TMessage ) ;

begin
    Msg.Result := 1 ;
end ;


// API...

procedure TTransparent_Panel.Paint ;

begin
    Canvas.Font := Font ;
    Canvas.Brush.Color := Color ;
    if csDesigning in ComponentState then
    begin
        with Canvas do
        begin
            Pen.Style := psDash ;
            Brush.Style := bsClear ;
            Rectangle( 0, 0, Width, Height ) ;
        end ;
    end ;
    if Assigned( _OnPaint ) then
    begin
        _OnPaint( Self ) ;
    end ;
end ;



end.

