{
        Program Name : VT05_Main
        Package Name : CEF
        Purpose      : Simple terminal component main form
        Institution  : Conroy & Conroy Co.
        Date Written : 2-Dec-2006
        Written By   : Alan Conroy
        Version      : 1.0A

	Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        * 20-Jan-2007    EAC         Handle shutdown better.        *
        *                            Add flow-control.  Emulate     *
        *                            DEV VT05 and VT50.             *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This is the main form for a simple video terminal Emulator for CEF.
        It encapsulates the screen and keyboard.
}

unit VT05_Main ;

interface

uses // Borland...
     Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
     Dialogs, Menus, Buttons, StdCtrls, ExtCtrls, ComCtrls,

     // C&C...
     CommonUt, // Edit
     CVT, // CVTB
     TPanels, // TTransparent_Panel

     // CEF...
     CEF, // TCable
     _CEFUtil, // TCEF_Character_Set
     Serial_Cable ; // TSerial_Cable

type TVT_Mode = ( VTM_TTY, // Glass teletype
                  VTM_VT05, // DEC VT05 emulation
                  VTM_VT50 // DEC VT50 emulation
                ) ;

type TMain_Form = class( TForm )
                    Screen_Panel: TPanel;
                    StatusBar1: TStatusBar;
                    Panel2: TPanel;
                    MainMenu1: TMainMenu;
                    File1: TMenuItem;
                    Exit1: TMenuItem;
                    Edit1: TMenuItem;
                    Copyscreen1: TMenuItem;
                    SerialPort1: TMenuItem;
                    Baudrate1: TMenuItem;
                    N751: TMenuItem;
                    N1101: TMenuItem;
                    N1501: TMenuItem;
                    N3001: TMenuItem;
                    N6001: TMenuItem;
                    N12001: TMenuItem;
                    N24001: TMenuItem;
                    N48001: TMenuItem;
                    N96001: TMenuItem;
                    N8databits1: TMenuItem;
                    N71: TMenuItem;
                    N81: TMenuItem;
                    N2stopbits1: TMenuItem;
                    Parity1: TMenuItem;
                    Video1: TMenuItem;
                    Cursor1: TMenuItem;
                    Blinking1: TMenuItem;
                    Solid1: TMenuItem;
                    Display1: TMenuItem;
                    DisplayControlCharacters1: TMenuItem;
                    Options1: TMenuItem;
                    Bufferkeystrokes1: TMenuItem;
                    Keymapping1: TMenuItem;
                    Local1: TMenuItem;
                    Ignorenoncursorcontrols1: TMenuItem;
                    N8bitdisplay1: TMenuItem;
                    Options2: TMenuItem;
                    N1: TMenuItem;
                    Scroll1: TMenuItem;
                    Flowcontrol1: TMenuItem;
                    None1: TMenuItem;
                    XOnXOff1: TMenuItem;
                    CTSRTS1: TMenuItem;
                    Connect1: TMenuItem;
                    Open_Dialog: TOpenDialog;
                    N2: TMenuItem;
                    Logtofile1: TMenuItem;
                    Sendfile1: TMenuItem;
                    Log_File_Dialog: TSaveDialog;
                    Cancellogging1: TMenuItem;
                    N3: TMenuItem;
                    Uppercaseoutput1: TMenuItem;
                    Uppercaseinput1: TMenuItem;
                    MarginBell1: TMenuItem;
                    ChangeKeyboard1: TMenuItem;
                    Printer1: TMenuItem;
                    Baudrate2: TMenuItem;
                    N96002: TMenuItem;
                    N48002: TMenuItem;
                    N24002: TMenuItem;
                    N12002: TMenuItem;
                    N6002: TMenuItem;
                    N3002: TMenuItem;
                    N1502: TMenuItem;
                    N1102: TMenuItem;
                    N752: TMenuItem;
                    Databits1: TMenuItem;
                    N82: TMenuItem;
                    N72: TMenuItem;
                    Flowcontrol2: TMenuItem;
                    CTSRTS2: TMenuItem;
                    XOnXOff2: TMenuItem;
                    None2: TMenuItem;
                    N2stopbits2: TMenuItem;
                    Parity2: TMenuItem;
                    Connect2: TMenuItem;
                    N5: TMenuItem;
                    Autocopy1: TMenuItem;
                    Copyscreen2: TMenuItem;
                    Keyboard1: TMenuItem;
                    Auto1: TMenuItem;
                    Auto2: TMenuItem;
                    procedure Check_Click(Sender: TObject);
                    procedure FormCreate(Sender: TObject);
                    procedure BufferKeyDown(Sender: TObject; var Key: Word;
                      Shift: TShiftState);
                    procedure BufferKeyUp(Sender: TObject; var Key: Word;
                      Shift: TShiftState);
                    procedure BufferKeyPress(Sender: TObject; var Key: Char);
                    procedure Blinking1Click(Sender: TObject);
                    procedure Solid1Click(Sender: TObject);
                    procedure Exit1Click(Sender: TObject);
                    procedure Display1Click(Sender: TObject);
                    procedure DisplayControlCharacters1Click(Sender: TObject);
                    procedure Copyscreen1Click(Sender: TObject);
                    procedure Baud_Click(Sender: TObject);
                    procedure Bits_Check(Sender: TObject);
                    procedure Keymapping1Click(Sender: TObject);
                    procedure FormKeyDown(Sender: TObject; var Key: Word;
                      Shift: TShiftState);
                    procedure FormDestroy(Sender: TObject);
                    procedure Ignorenoncursorcontrols1Click(Sender: TObject);
                    procedure N8bitdisplay1Click(Sender: TObject);
                    procedure Options2Click(Sender: TObject);
                    procedure Scroll1Click(Sender: TObject);
                    procedure FormClose(Sender: TObject; var Action: TCloseAction);
                    procedure Connect1Click(Sender: TObject);
                    procedure Logtofile1Click(Sender: TObject);
                    procedure Sendfile1Click(Sender: TObject);
                    procedure Cancellogging1Click(Sender: TObject);
                    procedure Uppercaseoutput1Click(Sender: TObject);
                    procedure Uppercaseinput1Click(Sender: TObject);
                    procedure MarginBell1Click(Sender: TObject);
                    procedure ChangeKeyboard1Click(Sender: TObject);
                    procedure Copyscreen2Click(Sender: TObject);
                    procedure Printer_Baud_Click(Sender: TObject);
                    procedure Printer_Buad_Click(Sender: TObject);
                    procedure Connect2Click(Sender: TObject);
                    procedure Keyboard1Click(Sender: TObject);

                  private // Instance data...
                      Bitmap_Image : TBitmap ;
                      Data : array[ 0..32767 ] of byte ;
                      Dirty : array[ 0..32767 ] of bytebool ;
                      Hold_Screen : boolean ;
                      Last_Width, Last_Height : integer ;
                      Screen : TTransparent_Panel ;
                      Keyboard_Handle : THandle ;
                      _Key_Mapper : TCEF_Key_Mapper ;
                      Output_Queue : TInteger_List ;
                      Printer_Output_Queue : TInteger_List ;
                      Input_Queue : TInteger_List ;
                      Printer : TComponent ;

                  protected // Property handlers...
                      function _Get_Key_Mapper : TCEF_Key_Mapper ;

                  protected // Callbacks...
                      procedure CB_Paint_Screen( Sender : Tobject ) ;
                      procedure CB_Timer( Sender : TObject ) ;

                      procedure WMGetDlgCode( var Message : TMessage ) ;
                          message WM_GetDlgCode ;

                  private // Internal utility routines...
                      procedure _Write( Value : longint ) ;
                      procedure _Write_Printer( Value : longint ) ;

                  public // API...
                      _8_Bit_Mode : boolean ; // True to display 8-bit characters (otherwise trim high bit)
                      Auto_Copy : boolean ;
                      Default_Font : string ;
                      _Blank_Control : boolean ; // True to blank control characters on screen
                      _Ignore_Control : boolean ; // True to ignore non-cursor control characters
                      _Invert : boolean ;
                      CAD_State : integer ; // VT05 CAD state
                      CAD_Y : integer ; // VT05 CAD Y value
                      Character_Set : TCEF_Character_Set ;
                      _Cursor_Mode : integer ;
                      Cursor_Rate : cardinal ; // Cursor cycle time in ms
                      Margin : integer ; // Screen margin, in pixels
                      _Scroll : boolean ; // True to scroll screen when cursor goes off bottom
                      Baud, Printer_Baud : longint ;
                      Block_New_Chars : boolean ;
                      Rows : integer ;
                      Columns : integer ;
                      Cursor_Row : integer ;
                      Cursor_Column : integer ;
                      Data_Bits, Printer_Data_Bits : integer ;
                      In_Escape_Seq : boolean ; // True if in VT50 escape sequence processing
                      KB_Receiver : TComponent ;
                      _Line_Wrap : boolean ;
                      Log_File : file ;
                      Timer : TTimer ;
                      Transmit_Paused : boolean ;
                      Printer_Transmit_Paused : boolean ;
                      _Uppercase_Out : boolean ; // True if to transmit only uppercase alphas
                      _Uppercase_In : boolean ; // True if to display only uppercase alphas
                      _UI : TUI_Interface ;
                      _VT05 : TComponent ;
                      _Margin_Bell : boolean ;
                      Mode : TVT_Mode ;
                      Keyboard : TComponent ;
                      Cable_Component : TComponent ;
                      Printer_Component : TComponent ;

                      function Check_Flow_Control : boolean ; // Return true if can send data
                      function Printer_Check_Flow_Control : boolean ; // Return true if can send data to printer
                      procedure Flush_Queue ;
                      procedure Printer_Flush_Queue ;
                      procedure Load_Character_Set( const Text : string ) ;
                      function Load_Keyboard( Name : string ; Silent : boolean ) : boolean ;
                      function Load_Printer( Name : string ; Silent : boolean ) : boolean ;
                      procedure New_Char( Value : integer ) ;
                      procedure Receive_Char( Value : longint ) ;
                      procedure Receive_Printer_Char( Value : longint ) ;
                      procedure Set_Mode( _Mode : TVT_Mode ) ;
                      procedure Validate_Size ;
                      procedure Write_Printer( Value : integer ) ;
                      procedure Write_Serial( Value : integer ) ;
                      property Key_Mapper : TCEF_Key_Mapper
                          read _Get_Key_Mapper
                          write _Key_Mapper ;

                      // Special behaviors...
                      procedure Correct_For_Cursor( Old_Column : integer ) ;
                      procedure Cursor_Down ;
                      procedure Cursor_Up ;
                      procedure Cursor_Right ;
                      procedure EEOL ;
                      procedure EEOS ;
                  end ; // TMain_Form

implementation

uses // Borland...
     Clipbrd, // Clipboard

     // C&C...
     ASCIIDef, // ESSC
     Standard, // ERT
     _UEHDEFs, // TUEC

     // VT05...
     VT_05, // _UI
     Video_Options_Form, // Video_Options_Dialog
     Send;

{$R *.dfm}

function Get_Character_Set : TCEF_Character_Set ; stdcall ; external 'CEF_Util.dll' ;
function Get_Key_Mapper : TCEF_Key_Mapper ; stdcall ; external 'CEF_Util.dll' ;

type TKBComponent = class( TComponent )
                        public
                            Main_Form : TMain_Form ;

                            function Write( Address : int64 ;
                                Value, Size : longint ;
                                IO_Type : longint ) : TUEC ; override ;
                    end ;

function TKBComponent.Write( Address : int64 ; Value, Size : longint ;
    IO_Type : longint ) : TUEC ;

var P : PChar ;
    S : string ;

begin
    if( Value = 1 ) then // Key down
    begin
        P := Main_Form.Keyboard.Keyboard.Get_Key ;
        while( P <> nil ) do
        begin
            S := string( P ) ;
            if( copy( S, 1, 5 ) = 'LEFT_' ) then
            begin
                S := copy( S, 6, length( S ) ) ;
            end ;
            if( copy( S, 1, 6 ) = 'RIGHT_' ) then
            begin
                S := copy( S, 7, length( S ) ) ;
            end ;
            if( copy( S, 1, 4 ) = 'NKP_' ) then
            begin
                S := copy( S, 5, length( S ) ) ;
            end ;

            if( length( S ) = 1 ) then
            begin
                Main_Form.Write_Serial( ord( S[ 1 ] ) ) ;
            end else
            if( S = 'BREAK' ) then
            begin
                Set_Signal( 'BREAK', True ) ;
            end else
            if( S = 'UP' ) then
            begin
                Main_Form.Cursor_Up ;
            end else
            if( S = 'DOWN' ) then
            begin
                Main_Form.Cursor_Down ;
            end else
            if( S = 'LEFT' ) then
            begin
                Main_Form.New_Char( 8 ) ;
            end else
            if( S = 'RIGHT' ) then
            begin
                Main_Form.Cursor_Right ;
            end else
            if( S = 'EEOL' ) then
            begin
                Main_Form.EEOL ;
            end else
            if( S = 'EEOS' ) then
            begin
                Main_Form.EEOS ;
            end ;
            // Ignore all other keys
            P := Main_Form.Keyboard.Keyboard.Get_Key ;
        end ; // while( P <> nil )
    end ; // if( Value = 1 )
end ;


// TMain_Form methods...

procedure TMain_Form._Write( Value : longint ) ;

var Stops : integer ;

begin
    if( N2stopbits1.Checked ) then
    begin
        Stops := 2 ;
    end else
    begin
        Stops := 1 ;
    end ;
    _VT05.Cable.Transmit( Baud, Value, Data_Bits, Stops ) ;
end ;


procedure TMain_Form._Write_Printer( Value : longint ) ;

var Stops : integer ;

begin
    if( N2stopbits2.Checked ) then
    begin
        Stops := 2 ;
    end else
    begin
        Stops := 1 ;
    end ;
    Printer.Cable.Receive( _VT05, Printer_Baud, Value, Printer_Data_Bits, Stops ) ;
end ;


procedure TMain_Form.Load_Character_Set( const Text : string ) ;

begin
    if( Text = '' ) then
    begin
        if( Character_Set = nil ) then
        begin
            Character_Set.Terminate ;
            Character_Set := nil ;
        end ;
        exit ;
    end ;
    if( Character_Set = nil ) then
    begin
        Character_Set := Get_Character_Set ;
        Character_Set.Invert := _Invert ;
    end ;
    Character_Set.Load( PChar( Text ) ) ;
end ;


procedure TMain_Form.Correct_For_Cursor( Old_Column : integer ) ;

var I : integer ;

begin
    // Handle cursor bounds
    if( Cursor_Column > Columns ) then
    begin
        if( _Line_Wrap ) then
        begin
            Cursor_Column := 1 ;
            inc( Cursor_Row ) ;
        end else
        begin
            Cursor_Column := Columns ;
        end ;
    end ;
    if( Cursor_Row > Rows ) then
    begin
        if( _Scroll ) then // Need to scroll up
        begin
            Cursor_Row := Rows ;

            // Scroll data...
            move( Data[ Columns ], Data[ 0 ], ( Rows - 1 ) * Columns ) ;
            fillchar( Data[ ( Rows - 1 ) * Columns ], Columns, 32 ) ;
            fillchar( Dirty, sizeof( Dirty ), 255 ) ;
        end else
        begin
            Cursor_Row := 1 ;
        end ;
    end ;
    if(
        _Margin_Bell
        and
        ( Old_Column < Cursor_Column )
        and
        ( Cursor_Column > Columns - 8 )
      ) then
    begin
        messagebeep( 0 ) ;
    end ;

    // Mark new cursor position as dirty...
    I := ( Cursor_Row - 1 ) * Columns + Cursor_Column - 1 ;
    Dirty[ I ] := True ;

    // Need a refresh
    Screen.Invalidate ;
end ; // TMain_Form.Correct_For_Cursor


procedure TMain_Form.Cursor_Down ;

var I : integer ;

begin
    if( Cursor_Row = Rows ) then
    begin
        exit ;
    end ;
    // Mark current cursor position as dirty (so cursor is undrawn)...
    I := ( Cursor_Row - 1 ) * Columns + Cursor_Column - 1 ;
    Dirty[ I ] := True ;
    inc( Cursor_Row ) ;
    Correct_For_Cursor( 0 ) ;
end ;


procedure TMain_Form.Cursor_Up ;

var I : integer ;

begin
    if( Cursor_Row = 1 ) then
    begin
        exit ;
    end ;
    // Mark current cursor position as dirty (so cursor is undrawn)...
    I := ( Cursor_Row - 1 ) * Columns + Cursor_Column - 1 ;
    Dirty[ I ] := True ;
    dec( Cursor_Row ) ;
    Correct_For_Cursor( 0 ) ;
end ;


procedure TMain_Form.Cursor_Right ;

var I : integer ;
     Old_Column : integer ;
     
begin
    if( Cursor_Column = Columns ) then
    begin
        exit ;
    end ;
    Old_Column := Cursor_Column ;
    // Mark current cursor position as dirty (so cursor is undrawn)...
    I := ( Cursor_Row - 1 ) * Columns + Cursor_Column - 1 ;
    Dirty[ I ] := True ;
    inc( Cursor_Column ) ;
    Correct_For_Cursor( Old_Column ) ;
end ;


procedure TMain_Form.EEOL ;

var I, Loop : integer ;

begin
    for Loop := Cursor_Column to Columns do
    begin
        I := ( Cursor_Row - 1 ) * Columns + Loop - 1 ;
        Dirty[ I ] := True ;
        Data[ I ] := 32 ;
    end ;
    Invalidate ;
end ;


procedure TMain_Form.EEOS ;

var I : integer ;

begin
    EEOL ; // Erase line
    if( Cursor_Row < Rows ) then
    begin
        I := Cursor_Row * Columns ;
        fillchar( Data[ I ], sizeof( Data ) - I, 32 ) ;
        fillchar( Dirty[ I ], sizeof( Data ) - I, 255 ) ;
    end ;
end ;


function TMain_Form.Load_Keyboard( Name : string ; Silent : boolean ) : boolean ;

var C : TComponent ;
    H : THandle ;
    P : function( Serial_Number : integer ; UI : TUI_Interface ) : TComponent ; stdcall ;

begin
    Result := False ; // Assume failure
    H := LoadLibrary( PChar( Name ) ) ;
    if( H <> 0 ) then
    begin
        P := GetProcAddress( H, 'Make_Instance' ) ;
        if( assigned( P ) ) then
        begin
            C := P( 0, _UI ) ;
            if( C = nil ) then
            begin
                if( not Silent ) then
                begin
                    ShowMessage( 'Cannot load component' ) ;
                end ;
                try
                    FreeLibrary( H ) ;
                except
                end ;
                exit ;
            end ;
            if( C.Component_Type <> Component_Type_Keyboard ) then
            begin
                if( not Silent ) then
                begin
                    ShowMessage( 'Cannot load component: not a keyboard component' ) ;
                end ;
                try
                    C.Terminate ;
                    FreeLibrary( H ) ;
                except
                end ;
                exit ;
            end ;
            Keyboard.Terminate ;
            Keyboard := C ;
            Keyboard.Connect_Output( KB_Receiver ) ;
            if( not Panel2.Visible ) then
            begin
                Keyboard1Click( nil ) ;
            end ;
            Result := True ;
        end else
        begin
            H := 0 ;
        end ; // if( assigned( P ) )
    end else
    begin
        H := 0 ;
    end ;
    if( ( not Silent ) and ( H = 0 ) ) then
    begin
        ShowMessage( 'Cannot load component' ) ;
    end ;
end ;


function TMain_Form.Load_Printer( Name : string ; Silent : boolean ) : boolean ;

var C : TComponent ;
    H : THandle ;
    P : function( Serial_Number : integer ; UI : TUI_Interface ) : TComponent ; stdcall ;

begin
    Result := False ;
    H := LoadLibrary( PChar( Name ) ) ;
    if( H <> 0 ) then
    begin
        P := GetProcAddress( H, 'Make_Instance' ) ;
        if( assigned( P ) ) then
        begin
            C := P( 0, _UI ) ;
            if( C = nil ) then
            begin
                if( not Silent ) then
                begin
                    ShowMessage( 'Cannot load component' ) ;
                end ;
                try
                    FreeLibrary( H ) ;
                except
                end ;
                exit ;
            end ;
            if( C.Component_Type <> Component_Type_Cable ) then
            begin
                if( not Silent ) then
                begin
                    ShowMessage( 'Cannot load component: not a cable component' ) ;
                end ;
                try
                    C.Terminate ;
                    FreeLibrary( H ) ;
                except
                end ;
                exit ;
            end ;
            if( Printer <> nil ) then
            begin
                Printer.Terminate ;
            end ;
            Printer.Connect_Input( C ) ;
            C.Connect_Output( _VT05 ) ;
            Printer.Set_Signal( 'DTR', True ) ;
            Printer_Component := C ;
            Printer_Component.Add_Notification( _VT05 ) ;
            Result := True ;
        end else
        begin
            H := 0 ;
        end ;
    end else
    begin
        H := 0 ;
    end ;
    if( ( not Silent ) and ( H = 0 ) ) then
    begin
        ShowMessage( 'Cannot load component' ) ;
    end ;
end ;


procedure TMain_Form.New_Char( Value : integer ) ;

var I : integer ;
    Old_Column : integer ;

begin
    if( Value = 0 ) then
    begin
        exit ; // Ignore nulls
    end ;
    if( Block_New_Chars ) then
    begin
        exit ;
    end ;
    if( Hold_Screen ) then
    begin
        Input_Queue.Add( Value ) ;
        exit ;
    end ;
    if( Input_Queue.Count > 0 ) then
    begin
        // Process items in input queue
        while( ( not Hold_Screen ) and ( Input_Queue.Count > 0 ) ) do
        begin
            New_Char( Input_Queue[ 0 ] ) ;
            Input_Queue.Remove( 0 ) ;
        end ;
        New_Char( Value ) ;
        exit ;
    end ;
    Old_Column := Cursor_Column ;

    // Mark current cursor position as dirty (so cursor is undrawn)...
    I := ( Cursor_Row - 1 ) * Columns + Cursor_Column - 1 ;
    Dirty[ I ] := True ;

    // Handle escape codes...
    if( Mode = VTM_VT50 ) then
    begin
        case chr( Value ) of // Emulate buggy VT50 character processing
            '`' : Value := ord( '@' ) ;
            '{' : Value := ord( '[' ) ;
            '|' : Value := ord( '\' ) ;
            '}' : Value := ord( ']' ) ;
            '~' : Value := ord( '^' ) ;
        end ;
        if( Value = 127 ) then
        begin
            exit ; // Ignore these
        end ;
        if( Value = ord( ESC ) ) then
        begin
            if( In_Escape_Seq ) then
            begin
                In_Escape_Seq := False ;
                exit ;
            end ;
            In_Escape_Seq := True ;
            exit ;
        end else
        if( In_Escape_Seq ) then
        begin
            case chr( Value ) of
                 'A' : // Move up
                     begin
                         Cursor_Up ;
                         Correct_For_Cursor( Old_Column ) ;
                     end ;
                 'C' : // Move right
                     begin
                         Cursor_Right ;
                         Correct_For_Cursor( Old_Column ) ;
                     end ;
                 'H' : // Home
                     begin
                         Cursor_Row := 1 ;
                         Cursor_Column := 1 ;
                         Correct_For_Cursor( Old_Column ) ;
                     end ;
                 'J' : EEOS ;
                 'K' : EEOL ;
                 'Z' : // Request terminat ID
                     begin
                         Write_Serial( ord( ESC ) ) ;
                         Write_Serial( ord( '/' ) ) ;
                         if( Printer = nil ) then
                         begin
                             Write_Serial( ord( 'A' ) ) ;
                         end else
                         begin
                             Write_Serial( ord( 'B' ) ) ;
                         end ;
                     end ;
                 '[' : Hold_Screen := True ; // Enable hold screen
                 '\' : Hold_Screen := False ; // Disable hold screen
                 ']' : Copyscreen2Click( nil ) ; // Copy screen to copier
                 '^' : Auto_Copy := True ; // Enter auto-copy mode
                 '_' : Auto_Copy := False ; // Exit auto-copy mode
            end ;
            In_Escape_Seq := False ;
            exit ;
        end ;
    end else
    if( Mode = VTM_VT05 ) then
    begin
        case CAD_State of
            1 : // Y value
                begin
                    Value := Value - 31 ;
                    if( ( Value < 1 ) or ( Value > Rows ) ) then // Invalid row
                    begin
                        CAD_State := 0 ;
                        exit ;
                    end ;
                    CAD_State := 2 ; // Waiting for X value
                    CAD_Y := Value ;
                    exit ;
                end ;
            2 : // X value
                begin
                    CAD_State := 0 ;
                    Value := Value - 31 ;
                    if( ( Value < 1 ) or ( Value > columns ) ) then // Invalid column
                    begin
                        exit ;
                    end ;
                    Cursor_Column := Value ;
                    Cursor_Row := CAD_Y ;
                    Correct_For_Cursor( Columns ) ;
                    exit ;
                end ;
        end ;
        case Value of
            11 : // Cursor down
                 begin
                     Cursor_Down ;
                     Correct_For_Cursor( Columns ) ;
                     exit ;
                 end ;
            14 : // Direct cursor addressing
                 begin
                     CAD_State := 1 ; // Waiting for Y value
                     exit ;
                 end ;
            24 : // Cursor right
                 begin
                     inc( Cursor_Column ) ;
                     Correct_For_Cursor( Columns ) ;
                     exit ;
                 end ;
            26 : // Cursor up
                 begin
                     Cursor_Up ;
                     Correct_For_Cursor( Columns ) ;
                     exit ;
                 end ;
            27 : // Escape
                 exit ; // Ignored
            29 : // Home
                 begin
                     Cursor_Row := 1 ;
                     Cursor_Column := 1 ;
                     Correct_For_Cursor( Columns ) ;
                     exit ;
                 end ;
        end ;
    end ; // if( Mode = VTM_VT05 )

    // Handle character...
    if( Value = ord( CR ) ) then
    begin
        Cursor_Column := 1 ;
    end else
    if( Value = ord( LF ) ) then
    begin
        inc( Cursor_Row ) ;
    end else
    if( Value = ord( BEL ) ) then
    begin
        messagebeep( 0 ) ;
    end else
    if( Value = ord( HT ) ) then
    begin
        Cursor_Column := ( Cursor_Column + 7 ) and ( not 7 ) ;
    end else
    if( Value = ord( BS ) ) then
    begin
        dec( Cursor_Column ) ;
        if( Cursor_Column < 1 ) then
        begin
            Cursor_Column := 1 ;
        end ;
    end else
    if( ( Value < 32 ) and _Ignore_Control ) then
    begin
        exit ;
    end else
    begin
        if( _Uppercase_In ) then
        begin
            Value := ord( upcase( chr( Value ) ) ) ;
        end ;
        Data[ I ] := Value ;
        inc( Cursor_Column ) ;
    end ;
    Correct_For_Cursor( Old_Column ) ;
end ; // TMain_Form.New_Char


function TMain_Form.Check_Flow_Control : boolean ; // Return true if can send data

begin
    Result := True ;
    if( CTSRTS1.Checked ) then
    begin
        _VT05.Set_Signal( 'RTS', True ) ;
        _VT05.Get_Signal( 'CTS', Result ) ;
    end ;
end ;


function TMain_Form.Printer_Check_Flow_Control : boolean ; // Return true if can send data

begin
    Result := True ;
    if( CTSRTS2.Checked ) then
    begin
        Printer.Set_Signal( 'RTS', True ) ;
        Printer.Get_Signal( 'CTS', Result ) ;
    end ;
end ;


procedure TMain_Form.Flush_Queue ;

begin
    while( not Transmit_Paused ) do
    begin
        if( Output_Queue.Count > 0 ) then
        begin
            if( not Check_Flow_Control ) then
            begin
                break ;
            end ;
            _Write( Output_Queue[ 0 ] ) ;
            New_Char( Output_Queue[ 0 ] ) ;
            Output_Queue.Delete( 0 ) ;
        end else
        begin
            break ;
        end ;
    end ;
end ;


procedure TMain_Form.Printer_Flush_Queue ;

begin
    while( not Printer_Transmit_Paused ) do
    begin
        if( Printer_Output_Queue.Count > 0 ) then
        begin
            if( not Printer_Check_Flow_Control ) then
            begin
                break ;
            end ;
            _Write_Printer( Output_Queue[ 0 ] ) ;
            Printer_Output_Queue.Delete( 0 ) ;
        end else
        begin
            break ;
        end ;
    end ;
end ;


procedure TMain_Form.Receive_Char( Value : longint ) ;

begin
    if( XonXoff1.Checked ) then
    begin
        if( Value = 17 ) then // Control-Q
        begin
            Transmit_Paused := False ;
            Flush_Queue ;
            exit ;
        end ;
        if( Value = 19 ) then // Control-S
        begin
            Transmit_Paused := True ;
            exit ;
        end ;
    end ;
    New_Char( Value ) ;
end ;


procedure TMain_Form.Receive_Printer_Char( Value : longint ) ;

begin
    if( XonXoff2.Checked ) then
    begin
        if( Value = 17 ) then // Control-Q
        begin
            Printer_Transmit_Paused := False ;
            Printer_Flush_Queue ;
            exit ;
        end ;
        if( Value = 19 ) then // Control-S
        begin
            Printer_Transmit_Paused := True ;
            exit ;
        end ;
    end ;
end ;


procedure TMain_Form.Set_Mode( _Mode : TVT_Mode ) ;

begin
    if( _Mode = VTM_TTY ) then
    begin
        _Margin_Bell := False ;
        _Uppercase_Out := False ;
        _Uppercase_In := False ;
        _Scroll := True ;
        _Ignore_Control := True ;
        _8_Bit_Mode := False ;
        Rows := 24 ;
        Columns := 80 ;
        _Line_Wrap := True ;
    end else
    if( _Mode = VTM_VT05 ) then
    begin
        _Margin_Bell := True ;
        _Uppercase_Out := True ;
        _Uppercase_In := True ;
        _Scroll := True ;
        _Ignore_Control := True ;
        _8_Bit_Mode := False ;
        Rows := 20 ;
        Columns := 72 ;
        _Line_Wrap := False ;
    end else
    if( _Mode = VTM_VT50 ) then
    begin
        _Margin_Bell := False ;
        _Uppercase_Out := True ;
        _Uppercase_In := True ;
        _Scroll := True ;
        _Ignore_Control := True ;
        _8_Bit_Mode := False ;
        Rows := 12 ;
        Columns := 80 ;
        _Line_Wrap := False ;
    end ;
    Validate_Size ;
    Mode := _Mode ;
end ;


procedure TMain_Form.Validate_Size ;

begin
    // Make sure eveything fits in Data
    while( Rows * Columns > sizeof( Data ) ) do
    begin
        dec( Rows ) ;
    end ;

    // Bounds check current position...
    if( Cursor_Row > Rows ) then
    begin
        Cursor_Row := Rows ;
    end ;
    if( Cursor_Column > Columns ) then
    begin
        Cursor_Column := Columns ;
    end ;
end ;


procedure TMain_Form.Write_Serial( Value : integer ) ;

begin
    _VT05.Set_Signal( 'BREAK', False ) ;
    if( _Uppercase_Out ) then
    begin
        Value := ord( upcase( chr( Value ) ) ) ;
    end ;
    Flush_Queue ;
    if( Transmit_Paused ) then
    begin
        Output_Queue.Add( Value ) ;
        exit ;
    end ;
    if( not Check_Flow_Control ) then
    begin
        Output_Queue.Add( Value ) ;
        exit ;
    end ;
    if( Local1.Checked ) then
    begin
        New_Char( Value ) ;
    end ;
    _Write( Value ) ;
end ;


procedure TMain_Form.Write_Printer( Value : integer ) ;

begin
    if( _Uppercase_Out ) then
    begin
        Value := ord( upcase( chr( Value ) ) ) ;
    end ;
    Printer_Flush_Queue ;
    if( Printer_Transmit_Paused ) then
    begin
        Printer_Output_Queue.Add( Value ) ;
        exit ;
    end ;
    if( not Check_Flow_Control ) then
    begin
        Printer_Output_Queue.Add( Value ) ;
        exit ;
    end ;
    _Write_Printer( Value ) ;
end ;


procedure TMain_Form.WMGetDlgCode( var Message : TMessage ) ;

begin
    Message.Result := DLGC_WANTALLKEYS ;
end ;


procedure TMain_Form.CB_Timer( Sender : TObject ) ;

var A : integer ;

begin
    if( HandleAllocated ) then
    begin
        if( Keyboard.User_Interface.Parent_Window = 0 ) then
        begin
            Keyboard.User_Interface.Parent_Window := Panel2.Handle ;
            Keyboard.User_Interface.Set_Hidden( False ) ;
        end ;
    end ;
    if( Timer.Interval = Cursor_Rate * 10 div 30 ) then
    begin
        Timer.Interval := Cursor_Rate * 20 div 30 ;
    end else
    begin
        Timer.Interval := Cursor_Rate * 10 div 30 ;
    end ;
    if( _Cursor_Mode = 1 ) then // Blinking
    begin
        A := ( Cursor_Row - 1 ) * Columns + Cursor_Column - 1 ;
        Dirty[ A ] := True ;
        Screen.Invalidate ;
    end ;
end ;


// Property handlers...
function TMain_Form._Get_Key_Mapper : TCEF_Key_Mapper ;

var Loop : integer ;
    S : string ;

begin
    if( _Key_Mapper = nil ) then
    begin
        _Key_Mapper := Get_Key_Mapper ;
        Key_Mapper.Add_Key( 'F1' ) ;
        Key_Mapper.Add_Key( 'F2' ) ;
        Key_Mapper.Add_Key( 'F3' ) ;
        Key_Mapper.Add_Key( 'F4' ) ;
        Key_Mapper.Add_Key( 'F5' ) ;
        Key_Mapper.Add_Key( 'F6' ) ;
        Key_Mapper.Add_Key( 'F7' ) ;
        Key_Mapper.Add_Key( 'F8' ) ;
        Key_Mapper.Add_Key( 'F9' ) ;
        Key_Mapper.Add_Key( 'F10' ) ;
        Key_Mapper.Add_Key( 'F11' ) ;
        Key_Mapper.Add_Key( 'F12' ) ;
        Key_Mapper.Add_Key( 'CANCEL' ) ;
        Key_Mapper.Add_Key( 'CLEAR' ) ;
        Key_Mapper.Add_Key( 'PAUSE' ) ;
        Key_Mapper.Add_Key( 'PAGE_UP' ) ;
        Key_Mapper.Add_Key( 'PAGE_DOWN' ) ;
        Key_Mapper.Add_Key( 'END_CB' ) ;
        Key_Mapper.Add_Key( 'PRINT' ) ;
        Key_Mapper.Add_Key( 'INSERT' ) ;
        for Loop := 33 to 126 do
        begin
            if( Upcase( char( Loop ) ) = char( Loop ) ) then
            begin
                S := char( Loop ) ;
                Key_Mapper.Add_Mapping( PChar( S ) ) ;
            end ;
        end ;
        Key_Mapper.Add_Mapping( 'SPACE' ) ;
        Key_Mapper.Add_Mapping( 'TAB' ) ;
        Key_Mapper.Add_Mapping( 'ESCAPE' ) ;
        Key_Mapper.Add_Mapping( 'CR' ) ;
        Key_Mapper.Add_Mapping( 'LF' ) ;
        Key_Mapper.Add_Mapping( 'RUB OUT' ) ;
        Key_Mapper.Add_Mapping( 'BREAK' ) ;
    end ;
    Result := _Key_Mapper ;
end ;


// Callbacks...

procedure TMain_Form.CB_Paint_Screen( Sender : Tobject ) ;

var A : integer ;
    C, R : integer ; // Current position
    Rect : TRect ;
    S : string ;
    X, Y : integer ; // Cell width and height

begin
    // Create and size bitmap...
    if( Bitmap_Image = nil ) then
    begin
        Bitmap_Image := TBitmap.Create ;
        if( _Invert ) then
        begin
            Bitmap_Image.Canvas.Brush.Color := clWhite ;
            Bitmap_Image.Canvas.Font.Color := clBlack ;
        end else
        begin
            Bitmap_Image.Canvas.Brush.Color := clBlack ;
            Bitmap_Image.Canvas.Font.Color := clWhite ;
        end ;
        Last_Width := 0 ;
        Last_Height := 0 ;
        if( Default_Font = '' ) then
        begin
            Default_Font := 'Courier New' ;
        end ;
        Bitmap_Image.Canvas.Font.Name := Default_Font ;
    end ;
    if(
        ( Screen.Width <> Last_Width )
        or
        ( Screen.Height <> Last_Height )
      ) then
    begin
        fillchar( Rect, sizeof( Rect ), 0 ) ;
        Rect.Bottom := Bitmap_Image.Height ;
        Rect.Right := Bitmap_Image.Width ;
        Bitmap_Image.Canvas.FillRect( Rect ) ;
        fillchar( Dirty, sizeof( Dirty ), 255 ) ;
        Last_Width := Screen.Width ;
        Last_Height := Screen.Height ;
    end ;
    if( Character_Set = nil ) then
    begin
        Y := Bitmap_Image.Canvas.TextHeight( 'W' ) ;
        X := Bitmap_Image.Canvas.TextWidth( 'W' ) ;
    end else
    begin
        Y := 13 ;
        X := 8 ;
    end ;
    Bitmap_Image.Height := Y * Rows + 2 ;
    Bitmap_Image.Width := X * Columns + Margin ;

    // Write data to bitmap...
    for R := 1 to Rows do
    begin
        for C := 1 to Columns do
        begin
            A := ( R - 1 ) * Columns + C - 1 ;
            if( Dirty[ A ] ) then
            begin
                Dirty[ A ] := false ;
                A := Data[ A ] ;
                if( not _8_Bit_Mode ) then
                begin
                    S := chr( A and 127 ) ;
                end ;
                if( A < 32 ) then
                begin
                    if( _Blank_Control ) then
                    begin
                        A := 32 ;
                    end ;
                end ;

                // Remove all traces of cursor before outputting glyph...
                if( _Invert ) then
                begin
                    selectobject( Bitmap_Image.Canvas.Handle, GetStockObject( WHITE_PEN ) ) ;
                end else
                begin
                    selectobject( Bitmap_Image.Canvas.Handle, GetStockObject( BLACK_PEN ) ) ;
                end ;
                MoveToEx( Bitmap_Image.Canvas.Handle, ( C - 1 ) * X + Margin div 2, ( R ) * Y - 1, nil ) ;
                LineTo( Bitmap_Image.Canvas.Handle, C * X + Margin div 2 - 1, ( R ) * Y - 1 ) ;

                // Output the glyph...
                if(
                    ( Character_Set = nil )
                    or
                    ( not Character_Set.Has_Glyph( A ) )
                  ) then
                begin
                    SetBkMode( Bitmap_Image.Canvas.Handle, OPAQUE ) ;
                    Bitmap_Image.Canvas.TextOut( ( C - 1 ) * X + Margin div 2, ( R - 1 ) * Y, S ) ;
                end else
                begin
                    Character_Set.Draw( Bitmap_Image.Canvas.Handle, ( C - 1 ) * X + Margin div 2, ( R - 1 ) * Y, A ) ;
                end ;

                // Handle showing cursor...
                if( ( R = Cursor_Row ) and ( C = Cursor_Column ) ) then
                begin
                    if(
                        ( _Cursor_Mode = 2 )
                        or
                        (
                          ( _Cursor_Mode = 1 )
                          and
                          ( Timer.Interval = Cursor_Rate * 20 div 30 )
                        )
                      ) then
                    begin
                        if( _Invert ) then
                        begin
                            selectobject( Bitmap_Image.Canvas.Handle, GetStockObject( BLACK_PEN ) ) ;
                        end else
                        begin
                            selectobject( Bitmap_Image.Canvas.Handle, GetStockObject( WHITE_PEN ) ) ;
                        end ;
                        MoveToEx( Bitmap_Image.Canvas.Handle, ( C - 1 ) * X + Margin div 2, ( R ) * Y - 1, nil ) ;
                        LineTo( Bitmap_Image.Canvas.Handle, C * X + Margin div 2 - 1, ( R ) * Y - 1 ) ;
                    end else
                    begin
                        if( _Invert ) then
                        begin
                            selectobject( Bitmap_Image.Canvas.Handle, GetStockObject( WHITE_PEN ) ) ;
                        end else
                        begin
                            selectobject( Bitmap_Image.Canvas.Handle, GetStockObject( BLACK_PEN ) ) ;
                        end ;
                        MoveToEx( Bitmap_Image.Canvas.Handle, ( C - 1 ) * X + Margin div 2, ( R ) * Y - 1, nil ) ;
                        LineTo( Bitmap_Image.Canvas.Handle, C * X + Margin div 2 - 1, ( R ) * Y - 1 ) ;
                    end ; // if
                end ; // if( ( R = Cursor_Row ) and ( C = Cursor_Column ) )
            end ; // if( not Dirty[ ( Row - 1 ) * Columns + C - 1 ] )
        end ; // for C := 1 to Columns
    end ; // for R := 1 to Rows

    // Draw on window...
    Screen.Canvas.StretchDraw( Screen.ClientRect, Bitmap_Image ) ;
end ; // TMain_Form.CB_Paint_Screen


procedure TMain_Form.Check_Click( Sender : TObject ) ;

begin
    TMenuItem( Sender ).Checked := not TMenuItem( Sender ).Checked ;
end ;


procedure TMain_Form.FormCreate( Sender : TObject ) ;

var F : function( Serial_Number : integer ; UI : TUI_Interface ) : TComponent ; stdcall ;

begin
    // Setup screen...
    Set_Mode( VTM_TTY ) ;
    Margin := 2 ;
    Cursor_Row := 1 ;
    Cursor_Column := 1 ;
    Screen := TTransparent_Panel.Create( self ) ;
    Screen.Parent := Screen_Panel ;
    Screen.Align := alClient ;
    Screen.OnPaint := CB_Paint_Screen ;
    fillchar( Data, sizeof( Data ), 32 ) ;
    Timer := TTimer.Create( Application ) ;
    Cursor_Rate := 1000 ;
    _Cursor_Mode := 1 ; // Blinking
    Timer.Interval := Cursor_Rate * 20 div 30 ;
    Timer.OnTimer := CB_Timer ;
    Timer.Enabled := True ;
    Output_Queue := TInteger_List.Create ;
    Printer_Output_Queue := TInteger_List.Create ;
    Input_Queue := TInteger_List.Create ;

    // Setup keyboard...
    Keyboard_Handle := LoadLibrary( 'VT05_KB.DLL' ) ;
    if( Keyboard_Handle = 0 ) then
    begin
        ShowMessage( 'Load failure for VT05_KB.DLL' ) ;
        exit ;
    end ;
    F := GetProcAddress( Keyboard_Handle, 'Make_Instance' ) ;
    if( @F = nil ) then
    begin
        FreeLibrary( Keyboard_Handle ) ;
        ShowMessage( 'VT05_KB.DLL is corrupt' ) ;
        exit ;
    end ;
    Keyboard := F( 0, _UI ) ;
    if( Keyboard = nil ) then
    begin
        FreeLibrary( Keyboard_Handle ) ;
        ShowMessage( 'Keyboard initialization failure' ) ;
        exit ;
    end ;
    KB_Receiver := TKBComponent.Create ;
    TKBComponent( KB_Receiver ).Main_Form := self ;
    Keyboard.Connect_Output( KB_Receiver ) ;
end ;


procedure TMain_Form.BufferKeyDown( Sender : TObject ; var Key : Word ;
    Shift : TShiftState ) ;

var _Buffer : array[ 0..2 ] of char ;
    Defined : boolean ;
    KeyStates : TKeyboardState ;

    procedure Substitute( CB : string ) ;

    var S : string ;

    begin
        S := string( Key_Mapper.Mapping( Pchar( CB ) ) ) ;
        if( S <> '' ) then
        begin
            Defined := True ;
            if( length( S ) = 1 ) then
            begin
                Key := ord( S[ 1 ] ) ;
            end else
            if( S = 'SPACE' ) then
            begin
                Key := 32 ;
            end else
            if( S = 'CR' ) then
            begin
                Key := 13 ;
            end else
            if( S = 'DEL' ) then
            begin
                Key := 127 ;
            end else
            if( S = 'LF' ) then
            begin
                Key := 10 ;
            end else
            if( S = 'ESC' ) then
            begin
                Key := ord( ESC ) ;
            end else
            if( S = 'BREAK' ) then
            begin
                _VT05.Set_Signal( 'BREAK', True ) ;
            end else
            if( S = 'TAB' ) then
            begin
                Key := 9 ;
            end else
            if( S = 'SHIFT LOCK' ) then
            begin
                Keyboard.Keyboard.Set_Key_Down( 'LOCK', True ) ;
                Key := 0 ;
                exit ;
            end ;
        end ; // if( S <> '' )
    end ; // .Substitute

begin
    Defined := False ;
    case Key of
        VK_BACK :
            begin
                Key :=  $5F ;
                Defined := True ;
            end ;
        VK_F1 : Substitute( 'F1' ) ;
        VK_F2 : Substitute( 'F2' ) ;
        VK_F3 : Substitute( 'F3' ) ;
        VK_F4 : Substitute( 'F4' ) ;
        VK_F5 : Substitute( 'F5' ) ;
        VK_F6 : Substitute( 'F6' ) ;
        VK_F7 : Substitute( 'F7' ) ;
        VK_F8 : Substitute( 'F8' ) ;
        VK_F9 : Substitute( 'F9' ) ;
        VK_F10 : Substitute( 'F10' ) ;
        VK_F11 : Substitute( 'F11' ) ;
        VK_F12 : Substitute( 'F12' ) ;
        VK_CANCEL : Substitute( 'CANCEL' ) ;
        VK_CLEAR : Substitute( 'CLEAR' ) ;
        VK_PAUSE : Substitute( 'PAUSE' ) ;
        VK_PRIOR : Substitute( 'PAGE_UP' ) ;
        VK_NEXT : Substitute( 'PAGE_DOWN' ) ;
        VK_END : Substitute( 'END_CB' ) ;
        VK_PRINT : Substitute( 'PRINT' ) ;
        VK_INSERT : Substitute( 'INSERT' ) ;
    end ;
    if( not Defined ) then
    begin
        GetKeyboardState( KeyStates ) ;
        if( ToAscii( Key, MapVirtualKey( Key, 0 ), KeyStates, _Buffer, 0 ) = 1 ) then
        begin
            Key := ord( _Buffer[ 0 ] ) ;
        end else
        begin
            case Key of
                VK_UP : Key := $97 ;
                VK_DOWN : Key := $9A ;
                VK_LEFT : Key := $81 ;
                VK_RIGHT : Key := $93 ;
                VK_TAB : Key := 9 ;
                VK_ESCAPE : Key := ord( ESC ) ;
                VK_RETURN : Key := ord( CR ) ;
                VK_HOME : Key := $8E ;
                VK_DELETE : Key := $5F ;
                VK_BACK : Key := $5F ;
                else exit ;
            end ;
        end ;
    end ;

    Key := 0 ;
end ; // TMain_Form.BufferKeyDown


procedure TMain_Form.BufferKeyUp(Sender: TObject; var Key: Word;
    Shift: TShiftState);

begin
    Key := 0 ;
end ;


procedure TMain_Form.BufferKeyPress(Sender: TObject; var Key: Char);

begin
    Key := #0 ;
end ;


procedure TMain_Form.Blinking1Click( Sender : TObject ) ;

begin
    Blinking1.Checked := True ;
    _Cursor_Mode := 1 ;
    Screen.Invalidate ;
end ;


procedure TMain_Form.Solid1Click( Sender : TObject ) ;

begin
    Solid1.Checked := True ;
    _Cursor_Mode := 2 ;
    Screen.Invalidate ;
end ;


procedure TMain_Form.Exit1Click( Sender : TObject ) ;

begin
    _VT05.Terminate ;
end ;


procedure TMain_Form.Display1Click( Sender : TObject ) ;

begin
    Check_Click( Sender ) ;
    if( Display1.Checked ) then
    begin
        _Invert := True ;
    end else
    begin
        _Invert := False ;
    end ;
    if( Character_Set <> nil ) then
    begin
        Character_Set.Invert := _Invert ;
    end ;
    Screen.Invalidate ;
end ;


procedure TMain_Form.DisplayControlCharacters1Click( Sender : TObject ) ;

begin
    Check_Click( Sender ) ;
    if( DisplayControlCharacters1.Checked ) then
    begin
        _Blank_Control := False ;
    end else
    begin
        _Blank_Control := True ;
    end ;
end ;


procedure TMain_Form.Copyscreen1Click( Sender : TObject ) ;

var Loop : integer ;
    S : string ;
    UEC : TUEC ;

begin
    Loop := Rows * Columns ;
    setlength( S, Loop ) ;
    move( Data, PChar( S )[ 0 ], Loop ) ;
    Clipboard.AsText := S ;
    fillchar( UEC, sizeof( UEC ), 0 ) ;
end ;


procedure TMain_Form.Baud_Click( Sender : TObject ) ;

begin
    Check_Click( Sender ) ;
    if( TMenuItem( Sender ).Caption = '&Auto' ) then
    begin
        Baud := 0 ;
    end else
    begin
        Baud := strtoint( TMenuItem( Sender ).Caption ) ;
    end ;
end ;


procedure TMain_Form.Bits_Check( Sender : TObject ) ;

begin
    Check_Click( Sender ) ;
    Data_Bits := strtoint( TMenuItem( Sender ).Caption ) ;
end ;


procedure TMain_Form.Keymapping1Click( Sender : TObject ) ;

begin
    Key_Mapper.Query ;
end ;


procedure TMain_Form.FormKeyDown( Sender : TObject ; var Key : Word ;
    Shift : TShiftState ) ;

var _Buffer : array[ 0..2 ] of char ;
    Defined : boolean ;
    KeyStates : TKeyboardState ;

    procedure Substitute( CB : string ) ;

    var S : string ;

    begin
        S := string( Key_Mapper.Mapping( PChar( CB ) ) ) ;
        if( S <> '' ) then
        begin
            Defined := True ;
            if( length( S ) = 1 ) then
            begin
                Key := ord( S[ 1 ] ) ;
            end else
            if( S = 'SPACE' ) then
            begin
                Key := 32 ;
            end else
            if( S = 'RETURN' ) then
            begin
                Key := 13 ;
            end else
            if( S = 'DEL' ) then
            begin
                Key := 127 ;
            end else
            if( S = 'LF' ) then
            begin
                Key := 10 ;
            end else
            if( S = 'ESCAPE' ) then
            begin
                Key := ord( ESC ) ;
            end else
            if( S = 'BREAK' ) then
            begin
                _VT05.Set_Signal( 'BREAK', True ) ;
            end else
            if( S = 'TAB' ) then
            begin
                Key := 9 ;
            end else
            if( S = 'UP' ) then
            begin
                Cursor_Up ;
                Key := 0 ;
            end else
            if( S = 'DOWN' ) then
            begin
                Cursor_Down ;
                Key := 0 ;
            end else
            if( S = 'LEFT' ) then
            begin
                New_Char( 8 ) ;
                Key := 0 ;
            end else
            if( S = 'RIGHT' ) then
            begin
                Cursor_Right ;
                Key := 0 ;
            end else
            if( S = 'EEOL' ) then
            begin
                EEOL ;
                Key := 0 ;
            end else
            if( S = 'EEOS' ) then
            begin
                EEOS ;
                Key := 0 ;
            end else
            if( S = 'LOCK' ) then
            begin
                Keyboard.Keyboard.Set_Key_Down( 'LOCK', True ) ;
                Key := 0 ;
            end ;
        end ; // if( S <> '' )
    end ; // .Substitute

begin
    Defined := False ;
    case Key of
        VK_BACK :
            begin
                Key :=  127 ;
                Defined := True ;
            end ;
        VK_F1 : Substitute( 'F1' ) ;
        VK_F2 : Substitute( 'F2' ) ;
        VK_F3 : Substitute( 'F3' ) ;
        VK_F4 : Substitute( 'F4' ) ;
        VK_F5 : Substitute( 'F5' ) ;
        VK_F6 : Substitute( 'F6' ) ;
        VK_F7 : Substitute( 'F7' ) ;
        VK_F8 : Substitute( 'F8' ) ;
        VK_F9 : Substitute( 'F9' ) ;
        VK_F10 : Substitute( 'F10' ) ;
        VK_F11 : Substitute( 'F11' ) ;
        VK_F12 : Substitute( 'F12' ) ;
        VK_CANCEL : Substitute( 'CANCEL' ) ;
        VK_CLEAR : Substitute( 'CLEAR' ) ;
        VK_PAUSE : Substitute( 'PAUSE' ) ;
        VK_PRIOR : Substitute( 'PAGE_UP' ) ;
        VK_NEXT : Substitute( 'PAGE_DOWN' ) ;
        VK_END : Substitute( 'END_' ) ;
        VK_PRINT : Substitute( 'PRINT' ) ;
        VK_INSERT : Substitute( 'INSERT' ) ;
        VK_UP : Substitute( 'UP' ) ;
        VK_DOWN : Substitute( 'DOWN' ) ;
        VK_LEFT : Substitute( 'LEFT' ) ;
        VK_RIGHT : Substitute( 'RIGHT' ) ;
    end ;
    if( not Defined ) then
    begin
        GetKeyboardState( KeyStates ) ;
        if( ToAscii( Key, MapVirtualKey( Key, 0 ), KeyStates, _Buffer, 0 ) = 1 ) then
        begin
            Key := ord( _Buffer[ 0 ] ) ;
        end else
        begin
            case Key of
                VK_TAB : Key := 9 ;
                VK_ESCAPE : Key := ord( ESC ) ;
                VK_RETURN : Key := ord( CR ) ;
                VK_DELETE : Key := 127 ;
                VK_BACK : Key := 127 ;
                VK_UP :
                    begin
                        Cursor_Up ;
                        Key := 0 ;
                    end ;
                VK_DOWN :
                    begin
                        Cursor_Down ;
                        Key := 0 ;
                    end ;
                VK_LEFT :
                    begin
                        New_Char( 8 ) ;
                        Key := 0 ;
                    end ;
                VK_RIGHT :
                    begin
                        Cursor_Right ;
                        Key := 0 ;
                    end ;
                else exit ;
            end ;
        end ;
    end ;

    if( ( ( Key > 0 ) and ( Key < 27 ) )
        or
        ( pos( chr( Key ), '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!@#$%^&*()-=_+\|[]{};:<>,./?`~" '#39#$97#$9A#$81#$93#9#13#$8E#$5F+ESC ) > 0 )
      ) then
    begin
        Write_Serial( Key ) ;
        Key := 0 ;
    end ;
end ; // TMain_Form.FormKeyDown


procedure TMain_Form.FormDestroy( Sender : TObject ) ;

begin
    Keyboard.Terminate ;
    Keyboard := nil ;
    KB_Receiver.Free ;
    KB_Receiver := nil ;
    Output_Queue.Free ;
    Output_Queue := nil ;
    Printer_Output_Queue.Free ;
    Printer_Output_Queue := nil ;
    Input_Queue.Free ;
    Input_Queue := nil ;
    if( Character_Set <> nil ) then
    begin
        Character_Set.Terminate ;
        Character_Set := nil ;
    end ;
    if( Printer <> nil ) then
    begin
        Printer.Terminate ;
        Printer := nil ;
    end ;
end ;


procedure TMain_Form.Ignorenoncursorcontrols1Click( Sender : TObject ) ;

begin
    TMenuItem( Sender ).Checked := not TMenuItem( Sender ).Checked ;
    _Ignore_Control := TMenuItem( Sender ).Checked ;
end ;


procedure TMain_Form.N8bitdisplay1Click( Sender : TObject ) ;

begin
    TMenuItem( Sender ).Checked := not TMenuItem( Sender ).Checked ;
    _8_Bit_Mode := TMenuItem( Sender ).Checked ;
end ;


procedure TMain_Form.Options2Click( Sender : TObject ) ;

var C, I, R : integer ;
    Old : array[ 0..sizeof( Data ) - 1 ] of byte ;

begin
    if( Video_Options_Dialog = nil ) then
    begin
        Video_Options_Dialog := TVideo_Options_Dialog.Create( Application ) ;
    end ;
    Video_Options_Dialog.Margin.Value := Margin ;
    Video_Options_Dialog.Cursor_Rate.Value := Cursor_Rate ;
    Video_Options_Dialog.Rows.Value := Rows ;
    Video_Options_Dialog.Columns.Value := Columns ;
    Video_Options_Dialog.Current_Font := Bitmap_Image.Canvas.Font.Name ;
    if( Video_Options_Dialog.ShowModal = mrOK ) then
    begin
        Margin := Video_Options_Dialog.Margin.Value ;
        Cursor_Rate := Video_Options_Dialog.Cursor_Rate.Value ;
        Rows := Video_Options_Dialog.Rows.Value ;
        if( Columns <> Video_Options_Dialog.Columns.Value ) then // Number of columnes is changing
        begin
            // copy old to new to preserve relative character positions...
            move( Data, Old, sizeof( Data ) ) ; // Save old data
            for R := 1 to Rows do
            begin
                for C := 1 to Video_Options_Dialog.Columns.Value do
                begin
                    I := ( R - 1 ) * Video_Options_Dialog.Columns.Value + C - 1 ;
                    if( C > Columns ) then // new column
                    begin
                        Data[ I ] := 32 ;
                    end else
                    begin
                        Data[ I ] := Old[ ( R - 1 ) * Columns + C - 1 ] ;
                    end ;
                end ;
            end ;
            Columns := Video_Options_Dialog.Columns.Value ;
        end ;
        if( Cursor_Row > Rows ) then
        begin
            Cursor_Row := Rows ;
        end ;
        if( Cursor_Column > Columns ) then
        begin
            Cursor_Column := Columns ;
        end ;
        Default_Font := Video_Options_Dialog.Windows_Font.Text ;
        if( Video_Options_Dialog.RadioButton1.Checked ) then
        begin
            Load_Character_Set( Video_Options_Dialog.Filename.Text ) ;
        end else
        begin
            Character_Set.Terminate ;
            Character_Set := nil ;
        end ;
        Bitmap_Image.Free ;
        Bitmap_Image := nil ;
        Screen.Invalidate ;
    end ;
end ;


procedure TMain_Form.Scroll1Click( Sender : TObject ) ;

begin
    TMenuItem( Sender ).Checked := not TMenuItem( Sender ).Checked ;
    _Scroll := TMenuItem( Sender ).Checked ;
end ;


procedure TMain_Form.FormClose( Sender : TObject ; var Action : TCloseAction ) ;

begin
    Action := caFree ;
end ;


procedure TMain_Form.Connect1Click( Sender : TObject ) ;

var C : TComponent ;
    H : THandle ;
    P : function( Serial_Number : integer ; UI : TUI_Interface ) : TComponent ; stdcall ;

begin
    while( true ) do
    begin
        Open_Dialog.Title := 'Connect to a component' ;
        if( Open_Dialog.Execute ) then
        begin
            H := LoadLibrary( PChar( Open_Dialog.Filename ) ) ;
            if( H <> 0 ) then
            begin
                P := GetProcAddress( H, 'Make_Instance' ) ;
                if( assigned( P ) ) then
                begin
                    C := P( 0, _UI ) ;
                    if( C = nil ) then
                    begin
                        ShowMessage( 'Cannot load component' ) ;
                        try
                            FreeLibrary( H ) ;
                        except
                        end ;
                        continue ;
                    end ;
                    if( C.Component_Type <> Component_Type_Cable ) then
                    begin
                        ShowMessage( 'Cannot load component: not a cable component' ) ;
                        try
                            C.Terminate ;
                            FreeLibrary( H ) ;
                        except
                        end ;
                        continue ;
                    end ;
                    _VT05.Connect_Input( C ) ;
                    C.Connect_Output( _VT05 ) ;
                    _VT05.Set_Signal( 'DTR', True ) ;
                    Cable_Component := C ;
                    Cable_Component.Add_Notification( _VT05 ) ;
                end else
                begin
                    H := 0 ;
                end ;
            end else
            begin
                H := 0 ;
            end ;
            if( H = 0 ) then
            begin
                ShowMessage( 'Cannot load component' ) ;
                continue ;
            end ;
        end ; // if( Open_Dialog.Execute )
        exit ;
    end ; // while( True )
end ;


procedure TMain_Form.Logtofile1Click( Sender : TObject ) ;

var Appending : boolean ;

begin
    if( Log_File_Dialog.Execute ) then
    begin
        Appending := False ;
        if( FileExists( Log_File_Dialog.Filename ) ) then
        begin
            case MessageBox( 0, 'Do you want to overwrite the file (No to append)', 'Logging file already exists', MB_YesNoCancel ) of
                idCancel : exit ;
                idNo : Appending := True ;
            end ;
        end ;
        if( Cancellogging1.Enabled ) then
        begin
            {$I-}
            closefile( Log_File ) ;
            {$I+}
            IOResult ;
        end ;
        assignfile( Log_File, Log_File_Dialog.Filename ) ;
        if( Appending ) then
        begin
            reset( Log_File, 1 ) ;
            seek( Log_File, filesize( Log_File ) ) ;
        end else
        begin
            rewrite( Log_File, 1 ) ;
        end ;
        Cancellogging1.Enabled := True ;
    end ;
end ; // TMain_Form.Logtofile1Click


procedure TMain_Form.Sendfile1Click( Sender : TObject ) ;

var Dlg : TSend_Dialog ;

begin
    Dlg := TSend_Dialog.Create( Application ) ;
    Dlg.Main_Form := self ;
    Dlg.ShowModal ;
    Dlg.Free ;
end ;


procedure TMain_Form.Cancellogging1Click( Sender : TObject ) ;

begin
    {$I-}
    closefile( Log_File ) ;
    {$I+}
    IOResult ;
    Cancellogging1.Enabled := False ;
end ;


procedure TMain_Form.Uppercaseoutput1Click( Sender : TObject ) ;

begin
    TMenuItem( Sender ).Checked := not TMenuItem( Sender ).Checked ;
    _Uppercase_Out := Uppercaseoutput1.Checked ;
end ;


procedure TMain_Form.Uppercaseinput1Click( Sender : TObject ) ;

begin
    TMenuItem( Sender ).Checked := not TMenuItem( Sender ).Checked ;
    _Uppercase_In := Uppercaseinput1.Checked ;
end ;


procedure TMain_Form.MarginBell1Click( Sender : TObject ) ;

begin
    TMenuItem( Sender ).Checked := not TMenuItem( Sender ).Checked ;
    _Margin_Bell := MarginBell1.Checked ;
end ;


procedure TMain_Form.ChangeKeyboard1Click( Sender : TObject ) ;

begin
    while( true ) do
    begin
        Open_Dialog.Title := 'Select a keyboard' ;
        if( Open_Dialog.Execute ) then
        begin
            if( Load_Keyboard( Open_Dialog.Filename, False ) ) then
            begin
                exit ;
            end ;
        end ; // if( Open_Dialog.Execute )
        exit ;
    end ; // while( True )
end ;


procedure TMain_Form.Copyscreen2Click( Sender : TObject ) ;

var I, Loop : integer ;

begin
    Loop := Rows * Columns ;
    for I := 0 to Loop do
    begin
        Write_Printer( Data[ I ] ) ;
    end ;
end ;


procedure TMain_Form.Printer_Baud_Click( Sender : TObject ) ;

begin
    Check_Click( Sender ) ;
    if( TMenuItem( Sender ).Caption = '&Auto' ) then
    begin
        Printer_Baud := 0 ;
    end else
    begin
        Printer_Baud := strtoint( TMenuItem( Sender ).Caption ) ;
    end ;
end ;


procedure TMain_Form.Printer_Buad_Click( Sender : TObject ) ;

begin
    Check_Click( Sender ) ;
    Printer_Data_Bits := strtoint( TMenuItem( Sender ).Caption ) ;
end ;


procedure TMain_Form.Connect2Click( Sender : TObject ) ;

begin
    while( true ) do
    begin
        Open_Dialog.Title := 'Select a printer' ;
        if( Open_Dialog.Execute ) then
        begin
            if( Load_Printer( Open_Dialog.Filename, False ) ) then
            begin
                exit ;
            end ;
            continue ;
        end ;
        exit ;
    end ; // while( True )
end ;


procedure TMain_Form.Keyboard1Click( Sender : TObject ) ;

begin
    Keyboard1.Checked := not Keyboard1.Checked ;
    Panel2.Visible := Keyboard1.Checked ;
    if( Panel2.Visible ) then
    begin
        Height := Height + Panel2.Height ;
    end else
    begin
        Height := Height - Panel2.Height ;
    end ;
end ;



end.
